Type: Package
Package: tidySummarizedExperiment
Title: Brings SummarizedExperiment to the Tidyverse
Version: 1.22.0
Authors@R: c(person("Stefano", "Mangiola", email = "mangiolastefano@gmail.com",
                  role = c("aut", "cre")) )
Author: Stefano Mangiola [aut, cre] <mangiolastefano@gmail.com>
Maintainer: Stefano Mangiola <mangiolastefano@gmail.com>
Description: The tidySummarizedExperiment package provides a set of tools for creating and
  manipulating tidy data representations of SummarizedExperiment objects. SummarizedExperiment
  is a widely used data structure in bioinformatics for storing high-throughput genomic data, 
  such as gene expression or DNA sequencing data. 
  The tidySummarizedExperiment package introduces a tidy framework for working with SummarizedExperiment objects. 
  It allows users to convert their data into a tidy format, where each observation is a row 
  and each variable is a column. This tidy representation simplifies data manipulation, 
  integration with other tidyverse packages, and enables seamless integration with the broader 
  ecosystem of tidy tools for data analysis.
License: GPL-3
Depends: R (>= 4.3.0), SummarizedExperiment, ttservice (>= 0.5.0)
Imports: dplyr, tibble (>= 3.0.4), magrittr, tidyr, ggplot2, rlang,
        purrr, lifecycle, methods, utils, S4Vectors, tidyselect,
        ellipsis, vctrs, pillar, stringr, cli, fansi, stats, pkgconfig,
        plyxp
Suggests: BiocStyle, testthat, knitr, markdown, rmarkdown, plotly,
        rbibutils, prettydoc, airway
VignetteBuilder: knitr
RdMacros: lifecycle
Biarch: true
biocViews: AssayDomain, Infrastructure, RNASeq, DifferentialExpression,
        GeneExpression, Normalization, Clustering, QualityControl,
        Sequencing, Transcription, Transcriptomics
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
Roxygen: list(markdown = TRUE)
LazyDataCompression: xz
URL: https://github.com/stemangiola/tidySummarizedExperiment
BugReports: https://github.com/stemangiola/tidySummarizedExperiment/issues
git_url: https://git.bioconductor.org/packages/tidySummarizedExperiment
git_branch: RELEASE_3_23
git_last_commit: 8449153
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:11:08 UTC; biocbuild

tidySummarizedExperiment - part of tidytranscriptomics
================

<!-- badges: start -->
 
[![Lifecycle:maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://www.tidyverse.org/lifecycle/#maturing)
[![R build
status](https://github.com/stemangiola/tidySummarizedExperiment/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/stemangiola/tidySummarizedExperiment/actions)
<!-- badges: end -->

**Brings SummarizedExperiment to the tidyverse!**

website:
[stemangiola.github.io/tidySummarizedExperiment/](https://stemangiola.github.io/tidySummarizedExperiment/)

Another [nice
introduction](https://carpentries-incubator.github.io/bioc-intro/60-next-steps/index.html)
by carpentries-incubator.

Please also have a look at

- [tidySingleCellExperiment](https://stemangiola.github.io/tidySingleCellExperiment/)
  for tidy manipulation of SingleCellExperiment objects
- [tidyseurat](https://stemangiola.github.io/tidyseurat/) for tidy
  manipulation of Seurat objects
- [tidybulk](https://stemangiola.github.io/tidybulk/) for tidy analysis
  of RNA sequencing data
- [nanny](https://github.com/stemangiola/nanny) for tidy high-level data
  analysis and manipulation
- [tidygate](https://github.com/stemangiola/tidygate) for adding custom
  gate information to your tibble
- [tidyHeatmap](https://stemangiola.github.io/tidyHeatmap/) for heatmaps
  produced with tidy principles

# Introduction

tidySummarizedExperiment provides a bridge between Bioconductor
[SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html)
\[@morgan2020summarized\] and the tidyverse \[@wickham2019welcome\]. It
creates an invisible layer that enables viewing the Bioconductor
*SummarizedExperiment* object as a tidyverse tibble, and provides
SummarizedExperiment-compatible *dplyr*, *tidyr*, *ggplot* and *plotly*
functions. This allows users to get the best of both Bioconductor and
tidyverse worlds.

## Functions/utilities available

| SummarizedExperiment-compatible Functions | Description |
|----|----|
| `all` | After all `tidySummarizedExperiment` is a SummarizedExperiment object, just better |

| tidyverse Packages | Description                                 |
|--------------------|---------------------------------------------|
| `dplyr`            | Almost all `dplyr` APIs like for any tibble |
| `tidyr`            | Almost all `tidyr` APIs like for any tibble |
| `ggplot2`          | `ggplot` like for any tibble                |
| `plotly`           | `plot_ly` like for any tibble               |

| Utilities   | Description                                 |
|-------------|---------------------------------------------|
| `as_tibble` | Convert cell-wise information to a `tbl_df` |

## Installation

``` r
if (!requireNamespace("BiocManager", quietly=TRUE)) {
      install.packages("BiocManager")
  }

BiocManager::install("tidySummarizedExperiment")
```

From Github (development)

``` r
devtools::install_github("stemangiola/tidySummarizedExperiment")
```

Load libraries used in the examples.

``` r
library(ggplot2)
library(tidySummarizedExperiment)
```

# Create `tidySummarizedExperiment`, the best of both worlds!

This is a SummarizedExperiment object but it is evaluated as a tibble.
So it is fully compatible both with SummarizedExperiment and tidyverse
APIs.

``` r
pasilla_tidy <- tidySummarizedExperiment::pasilla 
```

**It looks like a tibble**

``` r
pasilla_tidy
```

    ## # A SummarizedExperiment-tibble abstraction: 102,193 × 5
    ## # Features=14599 | Samples=7 | Assays=counts
    ##    .feature    .sample counts condition type      
    ##    <chr>       <chr>    <int> <chr>     <chr>     
    ##  1 FBgn0000003 untrt1       0 untreated single_end
    ##  2 FBgn0000008 untrt1      92 untreated single_end
    ##  3 FBgn0000014 untrt1       5 untreated single_end
    ##  4 FBgn0000015 untrt1       0 untreated single_end
    ##  5 FBgn0000017 untrt1    4664 untreated single_end
    ##  6 FBgn0000018 untrt1     583 untreated single_end
    ##  7 FBgn0000022 untrt1       0 untreated single_end
    ##  8 FBgn0000024 untrt1      10 untreated single_end
    ##  9 FBgn0000028 untrt1       0 untreated single_end
    ## 10 FBgn0000032 untrt1    1446 untreated single_end
    ## # ℹ 40 more rows

**But it is a SummarizedExperiment object after all**

``` r
assays(pasilla_tidy)
```

    ## List of length 1
    ## names(1): counts

# Tidyverse commands

We can use tidyverse commands to explore the tidy SummarizedExperiment
object.

We can use `slice` to choose rows by position, for example to choose the
first row.

``` r
pasilla_tidy %>%
    slice(1)
```

    ## # A SummarizedExperiment-tibble abstraction: 1 × 5
    ## # Features=1 | Samples=1 | Assays=counts
    ##   .feature    .sample counts condition type      
    ##   <chr>       <chr>    <int> <chr>     <chr>     
    ## 1 FBgn0000003 untrt1       0 untreated single_end

We can use `filter` to choose rows by criteria.

``` r
pasilla_tidy %>%
    filter(condition == "untreated")
```

    ## # A SummarizedExperiment-tibble abstraction: 58,396 × 5
    ## # Features=14599 | Samples=4 | Assays=counts
    ##    .feature    .sample counts condition type      
    ##    <chr>       <chr>    <int> <chr>     <chr>     
    ##  1 FBgn0000003 untrt1       0 untreated single_end
    ##  2 FBgn0000008 untrt1      92 untreated single_end
    ##  3 FBgn0000014 untrt1       5 untreated single_end
    ##  4 FBgn0000015 untrt1       0 untreated single_end
    ##  5 FBgn0000017 untrt1    4664 untreated single_end
    ##  6 FBgn0000018 untrt1     583 untreated single_end
    ##  7 FBgn0000022 untrt1       0 untreated single_end
    ##  8 FBgn0000024 untrt1      10 untreated single_end
    ##  9 FBgn0000028 untrt1       0 untreated single_end
    ## 10 FBgn0000032 untrt1    1446 untreated single_end
    ## # ℹ 40 more rows

We can use `select` to choose columns.

``` r
pasilla_tidy %>%
    select(.sample)
```

    ## # A tibble: 102,193 × 1
    ##    .sample
    ##    <chr>  
    ##  1 untrt1 
    ##  2 untrt1 
    ##  3 untrt1 
    ##  4 untrt1 
    ##  5 untrt1 
    ##  6 untrt1 
    ##  7 untrt1 
    ##  8 untrt1 
    ##  9 untrt1 
    ## 10 untrt1 
    ## # ℹ 102,183 more rows

We can use `count` to count how many rows we have for each sample.

``` r
pasilla_tidy %>%
    count(.sample)
```

    ## # A tibble: 7 × 2
    ##   .sample     n
    ##   <chr>   <int>
    ## 1 trt1    14599
    ## 2 trt2    14599
    ## 3 trt3    14599
    ## 4 untrt1  14599
    ## 5 untrt2  14599
    ## 6 untrt3  14599
    ## 7 untrt4  14599

We can use `distinct` to see what distinct sample information we have.

``` r
pasilla_tidy %>%
    distinct(.sample, condition, type)
```

    ## # A tibble: 7 × 3
    ##   .sample condition type      
    ##   <chr>   <chr>     <chr>     
    ## 1 untrt1  untreated single_end
    ## 2 untrt2  untreated single_end
    ## 3 untrt3  untreated paired_end
    ## 4 untrt4  untreated paired_end
    ## 5 trt1    treated   single_end
    ## 6 trt2    treated   paired_end
    ## 7 trt3    treated   paired_end

We could use `rename` to rename a column. For example, to modify the
type column name.

``` r
pasilla_tidy %>%
    rename(sequencing=type)
```

    ## # A SummarizedExperiment-tibble abstraction: 102,193 × 5
    ## # Features=14599 | Samples=7 | Assays=counts
    ##    .feature    .sample counts condition sequencing
    ##    <chr>       <chr>    <int> <chr>     <chr>     
    ##  1 FBgn0000003 untrt1       0 untreated single_end
    ##  2 FBgn0000008 untrt1      92 untreated single_end
    ##  3 FBgn0000014 untrt1       5 untreated single_end
    ##  4 FBgn0000015 untrt1       0 untreated single_end
    ##  5 FBgn0000017 untrt1    4664 untreated single_end
    ##  6 FBgn0000018 untrt1     583 untreated single_end
    ##  7 FBgn0000022 untrt1       0 untreated single_end
    ##  8 FBgn0000024 untrt1      10 untreated single_end
    ##  9 FBgn0000028 untrt1       0 untreated single_end
    ## 10 FBgn0000032 untrt1    1446 untreated single_end
    ## # ℹ 40 more rows

We could use `mutate` to create a column. For example, we could create a
new type column that contains single and paired instead of single_end
and paired_end.

``` r
pasilla_tidy %>%
    mutate(type=gsub("_end", "", type))
```

    ## # A SummarizedExperiment-tibble abstraction: 102,193 × 5
    ## # Features=14599 | Samples=7 | Assays=counts
    ##    .feature    .sample counts condition type  
    ##    <chr>       <chr>    <int> <chr>     <chr> 
    ##  1 FBgn0000003 untrt1       0 untreated single
    ##  2 FBgn0000008 untrt1      92 untreated single
    ##  3 FBgn0000014 untrt1       5 untreated single
    ##  4 FBgn0000015 untrt1       0 untreated single
    ##  5 FBgn0000017 untrt1    4664 untreated single
    ##  6 FBgn0000018 untrt1     583 untreated single
    ##  7 FBgn0000022 untrt1       0 untreated single
    ##  8 FBgn0000024 untrt1      10 untreated single
    ##  9 FBgn0000028 untrt1       0 untreated single
    ## 10 FBgn0000032 untrt1    1446 untreated single
    ## # ℹ 40 more rows

We could use `unite` to combine multiple columns into a single column.

``` r
pasilla_tidy %>%
    unite("group", c(condition, type))
```

    ## # A SummarizedExperiment-tibble abstraction: 102,193 × 4
    ## # Features=14599 | Samples=7 | Assays=counts
    ##    .feature    .sample counts group               
    ##    <chr>       <chr>    <int> <chr>               
    ##  1 FBgn0000003 untrt1       0 untreated_single_end
    ##  2 FBgn0000008 untrt1      92 untreated_single_end
    ##  3 FBgn0000014 untrt1       5 untreated_single_end
    ##  4 FBgn0000015 untrt1       0 untreated_single_end
    ##  5 FBgn0000017 untrt1    4664 untreated_single_end
    ##  6 FBgn0000018 untrt1     583 untreated_single_end
    ##  7 FBgn0000022 untrt1       0 untreated_single_end
    ##  8 FBgn0000024 untrt1      10 untreated_single_end
    ##  9 FBgn0000028 untrt1       0 untreated_single_end
    ## 10 FBgn0000032 untrt1    1446 untreated_single_end
    ## # ℹ 40 more rows

We can also combine commands with the tidyverse pipe `%>%`.

For example, we could combine `group_by` and `summarise` to get the
total counts for each sample.

``` r
pasilla_tidy %>%
    group_by(.sample) %>%
    summarise(total_counts=sum(counts))
```

    ## # A tibble: 7 × 2
    ##   .sample total_counts
    ##   <chr>          <int>
    ## 1 trt1        18670279
    ## 2 trt2         9571826
    ## 3 trt3        10343856
    ## 4 untrt1      13972512
    ## 5 untrt2      21911438
    ## 6 untrt3       8358426
    ## 7 untrt4       9841335

We could combine `group_by`, `mutate` and `filter` to get the
transcripts with mean count \> 0.

``` r
pasilla_tidy %>%
    group_by(.feature) %>%
    mutate(mean_count=mean(counts)) %>%
    filter(mean_count > 0)
```

    ## # A tibble: 86,513 × 6
    ## # Groups:   .feature [12,359]
    ##    .feature    .sample counts condition type       mean_count
    ##    <chr>       <chr>    <int> <chr>     <chr>           <dbl>
    ##  1 FBgn0000003 untrt1       0 untreated single_end      0.143
    ##  2 FBgn0000008 untrt1      92 untreated single_end     99.6  
    ##  3 FBgn0000014 untrt1       5 untreated single_end      1.43 
    ##  4 FBgn0000015 untrt1       0 untreated single_end      0.857
    ##  5 FBgn0000017 untrt1    4664 untreated single_end   4672.   
    ##  6 FBgn0000018 untrt1     583 untreated single_end    461.   
    ##  7 FBgn0000022 untrt1       0 untreated single_end      0.143
    ##  8 FBgn0000024 untrt1      10 untreated single_end      7    
    ##  9 FBgn0000028 untrt1       0 untreated single_end      0.429
    ## 10 FBgn0000032 untrt1    1446 untreated single_end   1085.   
    ## # ℹ 86,503 more rows

# Plotting

``` r
my_theme <-
    list(
        scale_fill_brewer(palette="Set1"),
        scale_color_brewer(palette="Set1"),
        theme_bw() +
            theme(
                panel.border=element_blank(),
                axis.line=element_line(),
                panel.grid.major=element_line(size=0.2),
                panel.grid.minor=element_line(size=0.1),
                text=element_text(size=12),
                legend.position="bottom",
                aspect.ratio=1,
                strip.background=element_blank(),
                axis.title.x=element_text(margin=margin(t=10, r=10, b=10, l=10)),
                axis.title.y=element_text(margin=margin(t=10, r=10, b=10, l=10))
            )
    )
```

We can treat `pasilla_tidy` as a normal tibble for plotting.

Here we plot the distribution of counts per sample.

``` r
pasilla_tidy %>%
    ggplot(aes(counts + 1, group=.sample, color=`type`)) +
    geom_density() +
    scale_x_log10() +
    my_theme
```

![](man/figures/plot1-1.png)<!-- -->

#' Extract column data from mutated tibble
#'
#' @keywords internal
#'
#' @param .data_mutated A tibble
#' @param se A tidySummarizedExperiment
#' @param column_belonging Named vector indicating column source
#' @param colnames_col Character vector of column data column names
#' @param special_columns Character vector of special columns
#' @param colnames_row Character vector of row data column names
#'
#' @return DataFrame for colData
#'
#' @noRd
extract_col_data <- function(.data_mutated, se, column_belonging = NULL, 
                             colnames_col = NULL, special_columns = NULL, 
                             colnames_row = NULL) {
  
  # Comply to CRAN notes 
  . <- NULL 
  
  # Get colnames_col if not provided
  if (is.null(colnames_col)) {
    colnames_col <- 
      colnames(colData(se)) %>% 
      c(s_(se)$name) %>%
      
      # Forcefully add the column I know the source. This is useful in nesting 
      # where a unique value cannot be linked to sample or feature
      c(names(column_belonging[column_belonging == s_(se)$name]))
  }
  
  # Get special_columns if not provided
  if (is.null(special_columns)) {
    special_columns <- get_special_columns(
      # Decrease the size of the dataset
      se[1:min(100, nrow(se)), min(1, ncol(se)):min(20, ncol(se))]
    ) 
  }
  
  # Get colnames_row if not provided
  if (is.null(colnames_row)) {
    colnames_row <- se %>%
      when(
        .hasSlot(., "rowData") | .hasSlot(., "elementMetadata") ~ colnames(rowData(.)), 
        TRUE ~ c()
      ) %>% 
      c(f_(se)$name) %>%
      
      # Forcefully add the column I know the source. This is useful in nesting 
      # where a unique value cannot be linked to sample or feature
      c(names(column_belonging[column_belonging == f_(se)$name]))
  }
  
  # This is used if I have one column with one value that can be mapped to rows and columns
  new_colnames_col = c()
  
  # This condiction is because if I don't have any samples, the new column 
  # could be mapped to samples and return NA in the final SE
  if(ncol(se) > 0)
    new_colnames_col <- 
    .data_mutated %>%
    select_if(!colnames(.) %in% setdiff(colnames_col, s_(se)$name)) %>% 
    
    # Eliminate special columns that are read only. Assays
    select_if(!colnames(.) %in% special_columns) %>%
    select_if(!colnames(.) %in% colnames_row) %>%
    # Replace for subset
    select(!!s_(se)$symbol, get_subset_columns(., !!s_(se)$symbol)) %>% 
    colnames()
  
  col_data <-
    .data_mutated %>%
    
    select(c(colnames_col, new_colnames_col)) %>%
    
    
    # Filter Sample is NA from SE that have 0 samples
    filter(!is.na(!!s_(se)$symbol)) 
  
  # This works even if I have 0 samples
  duplicated_samples = col_data |> pull(!!s_(se)$symbol) %>% duplicated() 
  if(duplicated_samples |> which() |>  length() > 0)
    # Make fast distinct()
    col_data = col_data |> filter(!duplicated_samples)
  
  col_data = 
    col_data |> 
    
    # In case unitary SE subset does not work
    data.frame(row.names = pull(col_data, !!s_(se)$symbol), check.names = FALSE) %>%
    select(-!!s_(se)$symbol) %>%
    DataFrame(check.names = FALSE)
  
  return(col_data)
}

#' Extract row data from mutated tibble
#'
#' @keywords internal
#'
#' @param .data_mutated A tibble
#' @param se A tidySummarizedExperiment
#' @param special_columns Character vector of special columns
#' @param col_data DataFrame of column data (for exclusion)
#'
#' @return DataFrame for rowData
#'
#' @noRd
extract_row_data <- function(.data_mutated, se, special_columns = NULL, 
                             col_data = NULL) {
  
  # Comply to CRAN notes 
  . <- NULL 
  
  # Get special_columns if not provided
  if (is.null(special_columns)) {
    special_columns <- get_special_columns(
      # Decrease the size of the dataset
      se[1:min(100, nrow(se)), min(1, ncol(se)):min(20, ncol(se))]
    ) 
  }
  
  # Get col_data column names for exclusion
  col_data_colnames <- if (!is.null(col_data)) colnames(col_data) else c()
  
  row_data <-
    .data_mutated %>%
    
    # Eliminate special columns that are read only 
    select_if(!colnames(.) %in% special_columns) %>%
    
    #eliminate sample columns directly
    select_if(!colnames(.) %in% c(s_(se)$name, col_data_colnames)) %>%
    
    # select(one_of(colnames(rowData(se))))
    # Replace for subset
    select(!!f_(se)$symbol,  get_subset_columns(., !!f_(se)$symbol) ) %>%
    
    # Make fast distinct()
    filter(pull(., !!f_(se)$symbol) %>% duplicated() %>% not()) %>% 
    
    # In case unitary SE subset does not work because all same
    data.frame(row.names = pull(.,f_(se)$symbol), check.names = FALSE) %>%
    select(-!!f_(se)$symbol) %>%
    DataFrame(check.names = FALSE)
  
  return(row_data)
}

#' Extract assay column names from mutated tibble
#'
#' @keywords internal
#'
#' @param .data_mutated A tibble
#' @param se A tidySummarizedExperiment
#' @param col_data DataFrame of column data
#' @param row_data DataFrame of row data
#'
#' @return Character vector of assay column names
#'
#' @noRd
extract_assay_colnames <- function(.data_mutated, se, col_data = NULL, 
                                  row_data = NULL) {
  
  # Count-like data that is NOT in the assay slot already 
  colnames_assay <-
    colnames(.data_mutated) %>% 
    setdiff(c(f_(se)$name, s_(se)$name, colnames(as.data.frame(head(rowRanges(se), 1))) )) %>%
    setdiff(if (!is.null(col_data)) colnames(col_data) else c()) %>% 
    setdiff(if (!is.null(row_data)) colnames(row_data) else c()) %>%
    setdiff(assays(se) %>% names)
  
  return(colnames_assay)
}

context("link_query_slot simple test")

library(tidySummarizedExperiment)
library(SummarizedExperiment)
library(S4Vectors)

test_that("extract_col_data works correctly", {
    # Use testthat edition 3
    local_edition(3)
    
    # Create SE with realistic colData
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:12, nrow = 3)),
        rowData = DataFrame(gene_id = paste0("GENE", 1:3)),
        colData = DataFrame(
            sample_id = paste0("SAMPLE", 1:4),
            condition = c("A", "B", "A", "B")
        )
    )
    rownames(se) <- paste0("gene", 1:3)
    colnames(se) <- paste0("sample", 1:4)
    
    # Create realistic tibble from SE manipulation
    test_tibble <- tibble::tibble(
        .feature = rep(paste0("gene", 1:3), 4),
        .sample = rep(paste0("sample", 1:4), each = 3),
        counts = as.vector(matrix(1:12, nrow = 3)),
        sample_id = rep(paste0("SAMPLE", 1:4), each = 3),
        condition = rep(c("A", "B", "A", "B"), each = 3),
        new_sample_col = rep(c("X", "Y", "Z", "W"), each = 3)  # New sample data
    )
    
    # Test extract_col_data
    col_data <- extract_col_data(test_tibble, se)
    
    expect_s4_class(col_data, "DataFrame")
    expect_equal(rownames(col_data), paste0("sample", 1:4))
    expect_true("sample_id" %in% colnames(col_data))
    expect_true("condition" %in% colnames(col_data))
    expect_true("new_sample_col" %in% colnames(col_data))
})

test_that("extract_row_data works correctly", {
    local_edition(3)
    
    # Create SE with realistic rowData
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:12, nrow = 3)),
        rowData = DataFrame(
            gene_id = paste0("GENE", 1:3),
            gene_type = c("A", "B", "C")
        ),
        colData = DataFrame(sample_id = paste0("SAMPLE", 1:4))
    )
    rownames(se) <- paste0("gene", 1:3)
    colnames(se) <- paste0("sample", 1:4)
    
    # Create realistic tibble
    test_tibble <- tibble::tibble(
        .feature = rep(paste0("gene", 1:3), 4),
        .sample = rep(paste0("sample", 1:4), each = 3),
        counts = as.vector(matrix(1:12, nrow = 3)),
        gene_id = rep(paste0("GENE", 1:3), 4),
        gene_type = rep(c("A", "B", "C"), 4),
        new_gene_col = rep(c("X", "Y", "Z"), 4)  # New feature data
    )
    
    # Test extract_row_data
    row_data <- extract_row_data(test_tibble, se)
    
    expect_s4_class(row_data, "DataFrame")
    expect_equal(rownames(row_data), paste0("gene", 1:3))
    expect_true("gene_id" %in% colnames(row_data))
    expect_true("gene_type" %in% colnames(row_data))
    expect_true("new_gene_col" %in% colnames(row_data))
})

test_that("extract_assay_colnames works correctly", {
    local_edition(3)
    
    # Create minimal SE
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:12, nrow = 3)),
        rowData = DataFrame(gene_id = paste0("GENE", 1:3)),
        colData = DataFrame(sample_id = paste0("SAMPLE", 1:4))
    )
    rownames(se) <- paste0("gene", 1:3)
    colnames(se) <- paste0("sample", 1:4)
    
    # Create tibble with new assay data
    test_tibble <- tibble::tibble(
        .feature = rep(paste0("gene", 1:3), 4),
        .sample = rep(paste0("sample", 1:4), each = 3),
        counts = as.vector(matrix(1:12, nrow = 3)),  # Existing assay
        logcounts = as.vector(matrix(13:24, nrow = 3)),  # New assay
        sample_id = rep(paste0("SAMPLE", 1:4), each = 3),
        gene_id = rep(paste0("GENE", 1:3), 4)
    )
    
    # Extract other data first
    col_data <- extract_col_data(test_tibble, se)
    row_data <- extract_row_data(test_tibble, se, col_data = col_data)
    
    # Test extract_assay_colnames
    assay_colnames <- extract_assay_colnames(test_tibble, se, col_data, row_data)
    
    expect_type(assay_colnames, "character")
    expect_true("logcounts" %in% assay_colnames)
    expect_false("counts" %in% assay_colnames)  # Existing assay should be excluded
    expect_false(".feature" %in% assay_colnames)
    expect_false(".sample" %in% assay_colnames)
})

test_that("functions work together in realistic scenario", {
    local_edition(3)
    
    # Create SE similar to what tidySummarizedExperiment would have
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:12, nrow = 3)),
        rowData = DataFrame(
            gene_id = paste0("GENE", 1:3),
            chromosome = c("chr1", "chr2", "chr1")
        ),
        colData = DataFrame(
            sample_id = paste0("SAMPLE", 1:4),
            condition = c("treated", "untreated", "treated", "untreated")
        )
    )
    rownames(se) <- paste0("gene", 1:3)
    colnames(se) <- paste0("sample", 1:4)
    
    # Simulate what would come from a mutate operation
    mutated_tibble <- tibble::tibble(
        .feature = rep(paste0("gene", 1:3), 4),
        .sample = rep(paste0("sample", 1:4), each = 3),
        counts = as.vector(matrix(1:12, nrow = 3)),
        # Existing metadata
        gene_id = rep(paste0("GENE", 1:3), 4),
        chromosome = rep(c("chr1", "chr2", "chr1"), 4),
        sample_id = rep(paste0("SAMPLE", 1:4), each = 3),
        condition = rep(c("treated", "untreated", "treated", "untreated"), each = 3),
        # New columns from mutation
        log_counts = log2(as.vector(matrix(1:12, nrow = 3)) + 1),  # New assay
        batch = rep(c("A", "B", "A", "B"), each = 3),  # New colData
        gene_length = rep(c(1000, 2000, 1500), 4)  # New rowData
    )
    
    # Extract all data types
    col_data <- extract_col_data(mutated_tibble, se)
    row_data <- extract_row_data(mutated_tibble, se, col_data = col_data)
    assay_colnames <- extract_assay_colnames(mutated_tibble, se, col_data, row_data)
    
    # Verify correct separation
    expect_true("batch" %in% colnames(col_data))
    expect_false("gene_length" %in% colnames(col_data))
    
    expect_true("gene_length" %in% colnames(row_data))
    expect_false("batch" %in% colnames(row_data))
    
    expect_true("log_counts" %in% assay_colnames)
    expect_false("counts" %in% assay_colnames)
    expect_false("batch" %in% assay_colnames)
    expect_false("gene_length" %in% assay_colnames)
})

test_that("functions handle minimal SE objects", {
    local_edition(3)
    
    # Create minimal SE
    minimal_se <- SummarizedExperiment(
        assays = list(counts = matrix(1:6, nrow = 2))
    )
    rownames(minimal_se) <- c("gene1", "gene2")
    colnames(minimal_se) <- c("sample1", "sample2", "sample3")
    
    # Create minimal tibble
    test_tibble <- tibble::tibble(
        .feature = rep(c("gene1", "gene2"), 3),
        .sample = rep(c("sample1", "sample2", "sample3"), each = 2),
        counts = 1:6,
        new_sample_data = rep(c("A", "B", "C"), each = 2)
    )
    
    # Test functions work even with minimal SE
    col_data <- extract_col_data(test_tibble, minimal_se)
    row_data <- extract_row_data(test_tibble, minimal_se)
    assay_colnames <- extract_assay_colnames(test_tibble, minimal_se, col_data, row_data)
    
    expect_s4_class(col_data, "DataFrame")
    expect_s4_class(row_data, "DataFrame")
    expect_type(assay_colnames, "character")
    
         # Should properly classify the new data
     expect_true("new_sample_data" %in% colnames(col_data))
     expect_equal(length(assay_colnames), 0)  # No new assays in this case
 })

test_that("update_SE_from_tibble works correctly", {
    local_edition(3)
    
    # Create original SE
    original_se <- SummarizedExperiment(
        assays = list(counts = matrix(1:12, nrow = 3)),
        rowData = DataFrame(
            gene_id = paste0("GENE", 1:3),
            gene_type = c("A", "B", "C")
        ),
        colData = DataFrame(
            sample_id = paste0("SAMPLE", 1:4),
            condition = c("treated", "untreated", "treated", "untreated")
        )
    )
    rownames(original_se) <- paste0("gene", 1:3)
    colnames(original_se) <- paste0("sample", 1:4)
    
    # Create mutated tibble with new data in all categories
    mutated_tibble <- tibble::tibble(
        .feature = rep(paste0("gene", 1:3), 4),
        .sample = rep(paste0("sample", 1:4), each = 3),
        counts = as.vector(matrix(1:12, nrow = 3)),
        # Existing metadata
        gene_id = rep(paste0("GENE", 1:3), 4),
        gene_type = rep(c("A", "B", "C"), 4),
        sample_id = rep(paste0("SAMPLE", 1:4), each = 3),
        condition = rep(c("treated", "untreated", "treated", "untreated"), each = 3),
        # New data - simpler approach
        new_assay = as.vector(matrix(13:24, nrow = 3)),  # New assay data
        batch = rep(c("X", "Y", "X", "Y"), each = 3),  # New colData
        gene_length = rep(c(1000, 2000, 1500), 4)  # New rowData
    )
    
    # Test update_SE_from_tibble
    updated_se <- update_SE_from_tibble(mutated_tibble, original_se)
    
    # Verify it returns a SummarizedExperiment
    expect_s4_class(updated_se, "SummarizedExperiment")
    
    # Verify dimensions unchanged
    expect_equal(dim(updated_se), dim(original_se))
    expect_equal(rownames(updated_se), rownames(original_se))
    expect_equal(colnames(updated_se), colnames(original_se))
    
    # Verify original assays preserved
    expect_true("counts" %in% assayNames(updated_se))
    expect_equal(assay(updated_se, "counts"), assay(original_se, "counts"))
    
    # Verify new assay added
    expect_true("new_assay" %in% assayNames(updated_se))
    expected_new_assay <- matrix(13:24, nrow = 3, 
                                dimnames = list(paste0("gene", 1:3), paste0("sample", 1:4)))
    expect_equal(assay(updated_se, "new_assay"), expected_new_assay)
    
    # Verify original colData preserved and new data added
    expect_true("sample_id" %in% colnames(colData(updated_se)))
    expect_true("condition" %in% colnames(colData(updated_se)))
    expect_true("batch" %in% colnames(colData(updated_se)))
    expect_equal(colData(updated_se)$batch, c("X", "Y", "X", "Y"))
    
    # Verify original rowData preserved and new data added
    expect_true("gene_id" %in% colnames(rowData(updated_se)))
    expect_true("gene_type" %in% colnames(rowData(updated_se)))
    expect_true("gene_length" %in% colnames(rowData(updated_se)))
    expect_equal(rowData(updated_se)$gene_length, c(1000, 2000, 1500))
})

test_that("update_SE_from_tibble handles edge cases", {
    local_edition(3)
    
    # Create minimal SE
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:6, nrow = 2))
    )
    rownames(se) <- c("gene1", "gene2")
    colnames(se) <- c("sample1", "sample2", "sample3")
    
    # Test with tibble that only adds assay data
    assay_only_tibble <- tibble::tibble(
        .feature = rep(c("gene1", "gene2"), 3),
        .sample = rep(c("sample1", "sample2", "sample3"), each = 2),
        counts = as.vector(matrix(1:6, nrow = 2)),
        new_assay = as.vector(matrix(7:12, nrow = 2))
    )
    
    updated_se <- update_SE_from_tibble(assay_only_tibble, se)
    
    # Should add new assay
    expect_true("new_assay" %in% assayNames(updated_se))
    expected_matrix <- matrix(7:12, nrow = 2,
                             dimnames = list(c("gene1", "gene2"), c("sample1", "sample2", "sample3")))
    expect_equal(assay(updated_se, "new_assay"), expected_matrix)
    
    # Should not affect colData/rowData (they should remain minimal)
    expect_equal(ncol(colData(updated_se)), ncol(colData(se)))
    expect_equal(ncol(rowData(updated_se)), ncol(rowData(se)))
})

test_that("update_SE_from_tibble works with column_belonging", {
    local_edition(3)
    
    # Create SE
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:6, nrow = 2)),
        colData = DataFrame(sample_id = c("S1", "S2", "S3"))
    )
    rownames(se) <- c("gene1", "gene2")
    colnames(se) <- c("sample1", "sample2", "sample3")
    
    # Create tibble with ambiguous column that should be forced to sample data
    test_tibble <- tibble::tibble(
        .feature = rep(c("gene1", "gene2"), 3),
        .sample = rep(c("sample1", "sample2", "sample3"), each = 2),
        counts = as.vector(matrix(1:6, nrow = 2)),
        sample_id = rep(c("S1", "S2", "S3"), each = 2),  # Include existing colData
        ambiguous_col = rep(c("A", "B", "C"), each = 2)
    )
    
    # Force ambiguous_col to be treated as sample data
    column_belonging <- c("ambiguous_col" = ".sample")
    
    updated_se <- update_SE_from_tibble(test_tibble, se, column_belonging = column_belonging)
    
    # ambiguous_col should be in colData
    expect_true("ambiguous_col" %in% colnames(colData(updated_se)))
    expect_equal(colData(updated_se)$ambiguous_col, c("A", "B", "C"))
    
    # Should not be in rowData
    expect_false("ambiguous_col" %in% colnames(rowData(updated_se)))
})

test_that("update_SE_from_tibble preserves SE class and metadata", {
    local_edition(3)
    
    # Create SE with metadata
    se <- SummarizedExperiment(
        assays = list(counts = matrix(1:6, nrow = 2)),
        colData = DataFrame(sample_id = c("S1", "S2", "S3")),
        rowData = DataFrame(gene_id = c("G1", "G2")),
        metadata = list(experiment_info = "test_experiment")
    )
    rownames(se) <- c("gene1", "gene2")
    colnames(se) <- c("sample1", "sample2", "sample3")
    
    # Create simple mutated tibble
    mutated_tibble <- tibble::tibble(
        .feature = rep(c("gene1", "gene2"), 3),
        .sample = rep(c("sample1", "sample2", "sample3"), each = 2),
        counts = as.vector(matrix(1:6, nrow = 2)),
        sample_id = rep(c("S1", "S2", "S3"), each = 2),  # Include existing colData
        gene_id = rep(c("G1", "G2"), 3),  # Include existing rowData
        new_data = as.vector(matrix(7:12, nrow = 2))
    )
    
    updated_se <- update_SE_from_tibble(mutated_tibble, se)
    
    # Should preserve original class
    expect_s4_class(updated_se, class(se)[1])
    
    # Should preserve metadata
    expect_equal(metadata(updated_se), metadata(se))
    
    # Should preserve original data structure
    expect_equal(rownames(updated_se), rownames(se))
    expect_equal(colnames(updated_se), colnames(se))
})

#' @name plot_ly
#' @rdname plot_ly
#' @inherit ttservice::plot_ly
#' @return `plotly`
#' 
#' @examples
#' data(se)
#' se |>
#'     plot_ly(x = ~counts)
#' 
#' @importFrom ttservice plot_ly
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
plot_ly.tbl_df <- function(data=data.frame(), ..., type=NULL, name=NULL,
    color=NULL, colors=NULL, alpha=NULL,
    stroke=NULL, strokes=NULL, alpha_stroke=1,
    size=NULL, sizes=c(10, 100),
    span=NULL, spans=c(1, 20),
    symbol=NULL, symbols=NULL,
    linetype=NULL, linetypes=NULL,
    split=NULL, frame=NULL,
    width=NULL, height=NULL, source="A") {
    data |>

        # This is a trick to not loop the call
        drop_class("tbl_df") |>
        plotly::plot_ly(...,
            type=type, name=name,
            color=color, colors=colors, alpha=alpha,
            stroke=stroke, strokes=strokes, alpha_stroke=alpha_stroke,
            size=size, sizes=sizes,
            span=span, spans=spans,
            symbol=symbol, symbols=symbols,
            linetype=linetype, linetypes=linetypes,
            split=split, frame=frame,
            width=width, height=height, source=source
        )
}

#' @name plot_ly
#' @rdname plot_ly
#' @inherit ttservice::plot_ly
#' @return `plotly`
#' 
#' @examples
#' data(se)
#' se |>
#'     plot_ly(x = ~counts)
#' 
#' @importFrom ttservice plot_ly
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
plot_ly.SummarizedExperiment <- function(data=data.frame(),
    ..., type=NULL, name=NULL,
    color=NULL, colors=NULL, alpha=NULL,
    stroke=NULL, strokes=NULL, alpha_stroke=1,
    size=NULL, sizes=c(10, 100),
    span=NULL, spans=c(1, 20),
    symbol=NULL, symbols=NULL,
    linetype=NULL, linetypes=NULL,
    split=NULL, frame=NULL,
    width=NULL, height=NULL, source="A") {
    data |>

        # This is a trick to not loop the call
        as_tibble() |>
        plotly::plot_ly(...,
            type=type, name=name,
            color=color, colors=colors, alpha=alpha,
            stroke=stroke, strokes=strokes, alpha_stroke=alpha_stroke,
            size=size, sizes=sizes,
            span=span, spans=spans,
            symbol=symbol, symbols=symbols,
            linetype=linetype, linetypes=linetypes,
            split=split, frame=frame,
            width=width, height=height, source=source
        )
}

#' @name ggplot
#' @rdname ggplot
#' @inherit ggplot2::ggplot
#' @title Create a new \code{ggplot} from a \code{SummarizedExperiment}
#' @return `ggplot`
#'
#' @examples
#' library(ggplot2)
#' data(pasilla)
#' pasilla %>%
#'     ggplot(aes(.sample, counts)) +
#'     geom_boxplot()
#' 
#' @importFrom purrr map
#' @importFrom rlang quo_name
#' @importFrom ggplot2 aes ggplot
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H. (2016). ggplot2: Elegant Graphics for Data Analysis. Springer-Verlag New York. ISBN 978-3-319-24277-4, https://ggplot2.tidyverse.org
#' @export
ggplot.SummarizedExperiment <- function(data=NULL, mapping=aes(),
    ..., environment=parent.frame()) {

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(data, .cols)) {
        data <- ping_old_special_column_into_metadata(data)
    }
  
    data %>%
        as_tibble() %>%
        ggplot2::ggplot(mapping=mapping)
}

#' tidySummarizedExperiment: Bringing SummarizedExperiment to the Tidyverse
#'
#' @description
#' The tidySummarizedExperiment package provides a bridge between Bioconductor
#' SummarizedExperiment objects and the tidyverse. It creates an invisible layer
#' that enables viewing the Bioconductor SummarizedExperiment object as a tidyverse
#' tibble, and provides SummarizedExperiment-compatible dplyr, tidyr, ggplot2 and
#' plotly functions. This allows users to get the best of both Bioconductor and
#' tidyverse worlds.
#'
#' @details
#' The main functions and methods are:
#'
#' \itemize{
#' \item \code{\link{tidy}} - Convert SummarizedExperiment to tidy format
#' \item \code{\link{as_tibble}} - Convert to tibble representation
#' \item \code{\link{filter}}, \code{\link{select}}, \code{\link{mutate}}, \code{\link{arrange}} - dplyr verbs
#' \item \code{\link{pivot_longer}}, \code{\link{pivot_wider}}, \code{\link{nest}}, \code{\link{unnest}} - tidyr functions
#' \item \code{\link{ggplot}} - ggplot2 visualization
#' \item \code{\link{left_join}}, \code{\link{inner_join}}, \code{\link{right_join}}, \code{\link{full_join}} - dplyr joins
#' }
#'
#' For detailed information on usage, see the package vignette, by typing
#' \code{vignette("introduction", package = "tidySummarizedExperiment")}.
#'
#' All software-related questions should be posted to the Bioconductor Support Site:
#'
#' \url{https://support.bioconductor.org}
#'
#' The code can be viewed at the GitHub repository:
#'
#' \url{https://github.com/stemangiola/tidySummarizedExperiment}
#'
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics
#' ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024).
#' \doi{10.1038/s41592-024-02299-2}
#'
#' @seealso
#' Useful links:
#' \itemize{
#'   \item \url{https://github.com/tidyomics/tidySummarizedExperiment}
#'   \item Report bugs at \url{https://github.com/tidyomics/tidySummarizedExperiment/issues}
#' }
#'
#' @author Stefano Mangiola
#'
#' @docType package
#' @name tidySummarizedExperiment-package
#' @aliases tidySummarizedExperiment
#' @keywords internal
"_PACKAGE"

#' @importFrom utils packageDescription
.onAttach <- function(libname, pkgname) {
    attached <- tidyverse_attach()
    
    # Print loading message about printing
    packageStartupMessage(
        "tidySummarizedExperiment says: Printing is now handled externally. ",
        "If you want to visualize the data in a tidy way, do library(tidyprint). ",
        "See https://github.com/tidyomics/tidyprint for more information."
    )
}

#' @name as_tibble
#' @rdname as_tibble
#' @inherit tibble::as_tibble
#' @return `tibble`
#' 
#' @examples
#' tidySummarizedExperiment::pasilla %>%
#'     as_tibble()
#'     
#' tidySummarizedExperiment::pasilla %>%
#'     as_tibble(.subset=-c(condition, type))
#' 
#' @importFrom purrr reduce
#' @importFrom purrr map
#' @importFrom purrr when
#' @importFrom tidyr spread
#' @importFrom stats setNames
#' @importFrom tibble enframe
#' @importFrom SummarizedExperiment colData
#' @importFrom pkgconfig get_config
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Müller, K., Wickham, H. (2023). tibble: Simple Data Frames. R package version 3.2.1, https://CRAN.R-project.org/package=tibble
#' @export
as_tibble.SummarizedExperiment <- function(x, ...,
    .name_repair=c("check_unique", "unique", "universal", "minimal"),
    rownames=pkgconfig::get_config("tibble::rownames", NULL)) {

    .as_tibble_optimised(x = x, ...,
        .name_repair=.name_repair, rownames=rownames)

}

.as_tibble_optimised <- function(x, skip_GRanges=FALSE, .subset=NULL,
    .name_repair=c("check_unique", "unique", "universal", "minimal"),
    rownames=pkgconfig::get_config("tibble::rownames", NULL)) {
  
    .subset <- enquo(.subset)
  
    sample_info <-
        colData(x) %>%
    
        # If reserved column names are present add .x
        change_reserved_column_names(x) %>% 

        # Convert to tibble
        tibble::as_tibble(rownames=s_(x)$name) %>% 
        setNames(c(s_(x)$name, colnames(colData(x))))
  
    range_info <-
        skip_GRanges %>%
        when(
            (.) ~ tibble() %>% list,
            ~  get_special_datasets(x) 
        ) %>%
        reduce(left_join, by="coordinate") 
    
    gene_info <-
        rowData(x) %>% 
    
        # If reserved column names are present add .x
        change_reserved_column_names(x)%>% 
  
        # Convert to tibble
        tibble::as_tibble(rownames=f_(x)$name) %>% 
        setNames(c(f_(x)$name, colnames(rowData(x))))
  
    count_info <- get_count_datasets(x)
  
    # Return 
    if (quo_is_null(.subset))
    
        # If I want to return all columns
        count_info %>%
            full_join(sample_info, by=s_(x)$name) %>%
            full_join(gene_info, by=f_(x)$name) %>%
            when(nrow(range_info) > 0 ~ 
                (.) %>% left_join(range_info) %>% suppressMessages(),
                ~ (.)) 
    
    # This function outputs a tibble after subsetting the columns
    else subset_tibble_output(x, count_info, sample_info,
        gene_info, range_info, !!.subset)
}

#' Convert mixed scope expressions to plyxp form
#'
#' This function converts expressions that reference multiple data types
#' (assays, colData, rowData) into plyxp form where colData and rowData
#' references are prefixed with .cols$ and .rows$ respectively.
#'
#' @keywords internal
#' @param expression_text Character string of the expression
#' @param referenced_coldata Character vector of colData columns referenced
#' @param referenced_rowdata Character vector of rowData columns referenced
#' @param referenced_assays Character vector of assay columns referenced
#' @return Character string of the converted expression
#' @noRd
convert_to_plyxp_form <- function(expression_text, referenced_coldata, referenced_rowdata, referenced_assays) {
  
  converted_expr <- expression_text
  
  # Convert colData references to .cols$column_name
  if (length(referenced_coldata) > 0) {
    for (col in referenced_coldata) {
      # Use word boundaries to ensure we only replace whole words
      pattern <- paste0("\\b", col, "\\b")
      replacement <- paste0(".cols$", col)
      converted_expr <- gsub(pattern, replacement, converted_expr)
    }
  }
  
  # Convert rowData references to .rows$column_name  
  if (length(referenced_rowdata) > 0) {
    for (col in referenced_rowdata) {
      # Use word boundaries to ensure we only replace whole words
      pattern <- paste0("\\b", col, "\\b")
      replacement <- paste0(".rows$", col)
      converted_expr <- gsub(pattern, replacement, converted_expr)
    }
  }
  
  # Assay references remain unchanged as they're the base context
  
  return(converted_expr)
}

#' Create a plyxp-style operation function for mixed scope operations
#'
#' This function creates a function that can efficiently execute mixed scope
#' operations using plyxp-style syntax with .cols and .rows references.
#'
#' @keywords internal
#' @param operation Character string specifying the operation (e.g., "mutate")
#' @param scope_report List from analyze_query_scope_mutate
#' @param ... Original expressions from the operation
#' @return Function that takes a SummarizedExperiment and executes the operation
#' @noRd
modify_se_plyxp <- function(.data, operation, scope_report, ...) {
  
  # Convert expressions to plyxp form (e.g., data * x -> data * .cols$x)
  dots <- rlang::enquos(...)
  converted_dots <- list()
  
  # Separate additional args (start with a dot), e.g., .preserve in filter
  dot_names <- names(dots)
  additional_args <- list()
  main_dots_idx <- seq_along(dots)
  if (!is.null(dot_names)) {
    for (i in seq_along(dots)) {
      nm <- dot_names[i]
      if (!is.null(nm) && nzchar(nm) && startsWith(nm, ".")) {
        additional_args[[nm]] <- dots[[i]]
        main_dots_idx <- setdiff(main_dots_idx, i)
      }
    }
  }
  main_dots <- dots[main_dots_idx]
  
  for (k in seq_along(main_dots)) {
    expr_name <- names(main_dots)[k]
    if (is.null(expr_name) || expr_name == "") {
      expr_name <- paste0("expr_", k)
    }
    
    # Get dependency info for this expression
    if (expr_name %in% names(scope_report$expression_dependencies)) {
      dep_info <- scope_report$expression_dependencies[[expr_name]]
      
      
      # Convert to plyxp form
      converted_text <- convert_to_plyxp_form(
        dep_info$expression_text,
        dep_info$referenced_coldata,
        dep_info$referenced_rowdata,
        dep_info$referenced_assays
      )
      
      # Create new quosure with converted expression
      converted_dots[[k]] <- rlang::quo(!!rlang::parse_expr(converted_text))
      names(converted_dots)[k] <- expr_name
      
    } else {
      # No dependency info, keep original
      converted_dots[[k]] <- main_dots[[k]]
      names(converted_dots)[k] <- expr_name
    }
  }
  
  # Convert back to quosures list
  converted_dots = rlang::as_quosures(converted_dots)

  # 1) Wrap within plyxp context
  .data <- plyxp::new_plyxp(.data)

  # 2) Execute the operation call constructed via call2
  #    e.g., mutate(.data, newdata = data * .cols$x)
  op_call <- rlang::call2(rlang::sym(operation), rlang::sym(".data"), !!!converted_dots, !!!additional_args)
  .data <- rlang::eval_tidy(op_call, env = rlang::env(.data = .data))

  # 3) Convert back to SummarizedExperiment
  .data <- plyxp::se(.data)

  return(.data)
}

#' @importFrom methods getMethod
setClass("tidySummarizedExperiment",
    contains=c("SummarizedExperiment", "RangedSummarizedExperiment"))

#' @name tidy
#' @rdname tidy
#' @title tidy for `Seurat`
#'
#' @param object A `Seurat` object.
#' @return A `tidyseurat` object.
#'
#' @examples
#' data(pasilla)
#' pasilla %>% tidy()
#'
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#'
#' @export
tidy <- function(object) {
    UseMethod("tidy", object)
}

#' @importFrom lifecycle deprecate_warn
tidy_ <- function(object) {
    
    # DEPRECATE
    deprecate_warn(
        when = "1.1.1",
        what = "tidy()",
        details = "tidySummarizedExperiment says: tidy() is not needed anymore."
    )
    
    object
}

#' @importFrom methods as
#' @rdname tidy
#' @param object A SummarizedExperiment object
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
tidy.SummarizedExperiment <- tidy_

#' @importFrom methods as
#' @rdname tidy
#' @param object A SummarizedExperiment object
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
tidy.RangedSummarizedExperiment <- tidy_

#' Analyze scope of a select operation based on selected columns
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param columns_query Character vector of selected column names
#' @return List with scope ("coldata_only", "rowdata_only", "assay_only", "mixed", or "unknown") and details
#' @noRd
analyze_query_scope_select <- function(se, ...) {
  
  # Derive selected columns from a tiny preview to avoid heavy work
  preview <- {
    if (ncol(se) > 0) se[1, 1, drop = FALSE] else se
  }
  tbl <- tibble::as_tibble(preview)
  loc <- tidyselect::eval_select(rlang::expr(c(...)), tbl)
  columns_query <- colnames(dplyr::select(tbl, loc))
  
  # Identify presence per domain (including special id columns)
  col_keys <- intersect(columns_query, get_colnames_col(se))
  row_keys <- intersect(columns_query, get_rownames_col(se))
  assay_keys <- intersect(columns_query, assayNames(se))
  
  targets_coldata <- length(col_keys) > 0
  targets_rowdata <- length(row_keys) > 0
  targets_assays <- length(assay_keys) > 0
  
  n_targets <- sum(targets_coldata, targets_rowdata, targets_assays)
  scope <- if (n_targets == 0) {
    "unknown"
  } else if (n_targets == 1) {
    if (targets_coldata) "coldata_only"
    else if (targets_rowdata) "rowdata_only"
    else "assay_only"
  } else {
    "mixed"
  }
  
  list(
    scope = scope,
    targets_coldata = targets_coldata,
    targets_rowdata = targets_rowdata,
    targets_assays = targets_assays,
    selected_coldata_cols = col_keys,
    selected_rowdata_cols = row_keys,
    selected_assay_cols = assay_keys,
    selected_columns = columns_query,
    analysis_method = "select_columns",
    confidence = "high"
  )
}



#' @name select
#' @rdname select
#' @inherit dplyr::select
#'
#' @examples
#' data(pasilla)
#' pasilla |> select(.sample, .feature, counts)
#' 
#' @importFrom SummarizedExperiment colData
#' @importFrom dplyr select
#' @importFrom tidyselect all_of
#' @importFrom tidyselect any_of
#' @export
select.SummarizedExperiment <- function(.data, ...) {
   
    # colnames_col <- get_colnames_col(.data)
    # colnames_row <- get_rownames_col(.data)
    # colnames_assay = .data@assays@data |> names()
    
    . <- NULL
    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
  
    # Warning if column names of assays do not overlap
    if (check_if_assays_are_NOT_consistently_ordered(.data)) {
    
        warning(
            "tidySummarizedExperiment says:",
            " the assays in your SummarizedExperiment have column names,",
            " but their order is not the same. Assays were internally",
            " reordered to be consistent with each other.",
            " To avoid unwanted behaviour it is highly reccomended",
            " to have assays with the same order of colnames and rownames."
        )
        
        # reorder assay colnames before printing
        # Rearrange if assays has colnames and rownames
        .data <- order_assays_internally_to_be_consistent(.data)
    
    }

    # Determine what domains (rowData/colData/assays) the select touches
    scope_report <- analyze_query_scope_select(.data, ...)
  
    # Early fast paths: if selection is limited to a single metadata slot, return a tibble
    # expanded to the full rectangular shape (repeat rows or columns accordingly)
    if (scope_report$scope == "coldata_only") {
        col_data_tibble <- 
            colData(.data) |> 
            as_tibble(rownames = s_(.data)$name)
        message(
            "tidySummarizedExperiment says:",
            " Key columns are missing.",
            " A data frame is returned for independent data analysis."
        )
        return(
            col_data_tibble |> 
                dplyr::select(tidyselect::eval_select(rlang::expr(c(...)), col_data_tibble)) |> 
                slice(rep(1:n(), each=nrow(!!.data)))
        )
    }
    if (scope_report$scope == "rowdata_only") {
        row_data_tibble <-
            rowData(.data) |> 
            as_tibble(rownames=f_(.data)$name)
        message("tidySummarizedExperiment says:",
            " Key columns are missing.",
            " A data frame is returned for independent data analysis.")
        return(
            row_data_tibble |> 
                dplyr::select(tidyselect::eval_select(rlang::expr(c(...)), row_data_tibble)) |> 
                slice(rep(1:n(), ncol(!!.data)  ))
        )
    }

    # Mixed or assay selections: build only the pieces required by scope
    build_row <- scope_report$targets_rowdata || scope_report$scope == "mixed"
    build_col <- scope_report$targets_coldata || scope_report$scope == "mixed"
    selected_row_cols <- scope_report$selected_rowdata_cols
    selected_col_cols <- scope_report$selected_coldata_cols
    selected_assay_cols <- scope_report$selected_assay_cols

    # Build rowData selection only when rowData is targeted
    if (build_row) {
        row_data_tibble <-
            rowData(.data) |> 
            as_tibble(rownames=f_(.data)$name)
        row_data_DF <-
            row_data_tibble |> 
            select(any_of(c(selected_row_cols)), !!f_(.data)$symbol) |>
            suppressWarnings() %>% 
            data.frame(row.names=pull(., !!f_(.data)$symbol)) |>
            select(-!!f_(.data)$symbol) |>
            DataFrame()
        # If SE does not have rownames, align
        if(rownames(.data) |> is.null()) rownames(row_data_DF)  = NULL
    } else {
        row_data_tibble <- tibble::tibble(!!f_(.data)$name := character())
        row_data_DF <- S4Vectors::DataFrame()
    }
    
    # Build colData selection only when colData is targeted
    if (build_col) {
        col_data_tibble <- 
            colData(.data) |> 
            as_tibble(rownames = s_(.data)$name)
        col_data_DF <-
            col_data_tibble |>  
            select(any_of(c(selected_col_cols)), !!s_(.data)$symbol) |>
            data.frame(row.names=pull(col_data_tibble, !!s_(.data)$symbol)) |>
            select(-!!s_(.data)$symbol) |>
            DataFrame()
        # If SE does not have colnames, align
        if(colnames(.data) |> is.null()) rownames(col_data_DF)  = NULL
    } else {
        col_data_tibble <- tibble::tibble(!!s_(.data)$name := character())
        col_data_DF <- S4Vectors::DataFrame()
    }
    
    # Subset assays list to only the selected assay columns (if any)
    count_data <-
        assays(.data)@listData %>%
            .[names(assays(.data)@listData) %in% selected_assay_cols]
  
    # Fallback: if required key columns are not all present in the result, 
    # convert to tibble and delegate selection to dplyr
    if (!all(c(get_needed_columns(.data)) %in% scope_report$selected_columns)) {
        if (ncol(.data)>100) {
            message("tidySummarizedExperiment says:",
                " You are doing a complex selection both sample-wise",
                " and feature-wise. In the latter case, for efficiency",
                " (until further development), it is better to separate",
                " your selects sample-wise OR feature-wise.")
        }
        message("tidySummarizedExperiment says:",
            " Key columns are missing.",
            " A data frame is returned for independent data analysis.")
    
        .data |>
            as_tibble(skip_GRanges=TRUE) |>
            select_helper(...) 
    } else {
        # Single or multi-slot SE return: set rowData/colData/assays that were built above
        rowData(.data) <- row_data_DF
        colData(.data) <- col_data_DF
        assays(.data) <- count_data
        
        # Attach latest select scope metadata for testing/introspection
        meta <- S4Vectors::metadata(.data)
        if (is.null(meta)) meta <- list()
        meta$latest_select_scope_report <- scope_report
        S4Vectors::metadata(.data) <- meta
        .data
    }
}

#' Analyze the scope of a mutate query to determine target data types
#'
#' This function analyzes a mutate query to determine whether it targets:
#' - Only colData (sample metadata)
#' - Only rowData (feature metadata) 
#' - Only assays (expression/count data)
#' - Mixed operations (combination of the above)
#'
#' @keywords internal
#'
#' @param se A SummarizedExperiment object
#' @param ... Mutate expressions (same as dplyr::mutate)
#'
#' @return A list containing:
#'   \item{scope}{Character: "coldata_only", "rowdata_only", "assay_only", "mixed", or "unknown"}
#'   \item{targets_coldata}{Logical: TRUE if query affects colData}
#'   \item{targets_rowdata}{Logical: TRUE if query affects rowData}
#'   \item{targets_assays}{Logical: TRUE if query affects assays}
#'   \item{new_coldata_cols}{Character vector of new colData columns}
#'   \item{new_rowdata_cols}{Character vector of new rowData columns}
#'   \item{new_assay_cols}{Character vector of new assay columns}
#'   \item{analysis_method}{Character: "pre_mutate", "post_mutate", or "subset_analysis"}
#'   \item{confidence}{Character: "high", "medium", or "low"}
#'   \item{query_complexity}{Character: "simple" or "complex"}
#'   \item{column_names}{Character vector of column names being created/modified}
#'
#' @examples
#' \dontrun{
#' # Simple query analysis
#' scope <- analyze_query_scope_mutate(se, new_col = condition)
#' 
#' # Complex query analysis  
#' scope <- analyze_query_scope_mutate(se, 
#'   log_counts = log2(counts + 1),
#'   batch_info = paste0("batch_", sample_id),
#'   gene_category = ifelse(counts > 100, "high", "low"))
#' }
#'
#' @noRd
analyze_query_scope_mutate <- function(se, ...) {
  
  # Capture the mutate expressions
  dots <- rlang::enquos(...)
  
  # Extract column names being created/modified
  .cols <- names(dots)
  
  # Handle unnamed expressions (e.g., from group_split operations)
  if (is.null(.cols) || any(.cols == "")) {
    # For unnamed expressions, we can't do scope analysis
    # Return unknown scope to fall back to general tibble conversion
    return(list(
      scope = "unknown",
      query_complexity = "unknown",
      column_names = character(0),
      analysis_method = "fallback_unnamed"
    ))
  }
  
  # Analyze query complexity
  complexity_analysis <- analyze_query_complexity(se, dots)
  
  # Try dependency analysis first - this can detect mixed operations
  dependency_result <- analyze_expression_dependencies(se, dots)
  
  # If dependency analysis detects mixed scope, use it directly
  if (dependency_result$overall_scope == "mixed") {
    return(list(
      scope = "mixed",
      targets_coldata = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_coldata)),
      targets_rowdata = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_rowdata)),
      targets_assays = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_assays)),
      new_coldata_cols = character(0),  # Cannot determine without execution
      new_rowdata_cols = character(0),  # Cannot determine without execution
      new_assay_cols = character(0),    # Cannot determine without execution
      analysis_method = "dependency_analysis",
      confidence = "high",
      query_complexity = if (complexity_analysis$is_simple) "simple" else "complex",
      column_names = .cols,
      expression_dependencies = dependency_result$expression_dependencies
    ))
  }
  
  # If dependency analysis gives a clear single scope, use it
  if (dependency_result$overall_scope %in% c("coldata_only", "rowdata_only", "assay_only")) {
    return(list(
      scope = dependency_result$overall_scope,
      targets_coldata = dependency_result$overall_scope == "coldata_only",
      targets_rowdata = dependency_result$overall_scope == "rowdata_only",
      targets_assays = dependency_result$overall_scope == "assay_only",
      new_coldata_cols = character(0),  # Cannot determine without execution
      new_rowdata_cols = character(0),  # Cannot determine without execution
      new_assay_cols = character(0),    # Cannot determine without execution
      analysis_method = "dependency_analysis",
      confidence = "high",
      query_complexity = if (complexity_analysis$is_simple) "simple" else "complex",
      column_names = .cols,
      expression_dependencies = dependency_result$expression_dependencies
    ))
  }
  
  # Fall back to existing analysis methods if dependency analysis is inconclusive
  # Choose analysis strategy based on complexity
  if (complexity_analysis$is_simple) {
    # Simple query - try pre-mutate analysis first
    result <- analyze_query_scope_pre_mutate(se, .cols)
    result$query_complexity <- "simple"
    result$column_names <- .cols
    
    # If pre-mutate gives unknown result for simple query, try subset analysis
    if (result$scope == "unknown" && result$confidence == "low") {
      result <- analyze_query_scope_subset(se, dots)
      result$query_complexity <- "simple"
      result$column_names <- .cols
    }
  } else {
    # Complex query - run on subset for speed
    result <- analyze_query_scope_subset(se, dots)
    result$query_complexity <- "complex"
    result$column_names <- .cols
  }
  
  return(result)
}

#' @name mutate
#' @rdname mutate
#' @inherit dplyr::mutate
#' @family single table verbs
#'
#' @examples
#' data(pasilla)
#' pasilla |> mutate(logcounts=log2(counts))
#'
#' @importFrom rlang enquos
#' @importFrom dplyr mutate
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @importFrom purrr map
#' @export
mutate.SummarizedExperiment <- function(.data, ...) {

       # Check if query is composed (multiple expressions)
    if (is_composed("mutate", ...)) return(decompose_tidy_operation("mutate", ...)(.data))

        # Check for scope and dispatch elegantly
        scope_report <- analyze_query_scope_mutate(.data, ...)
        scope <- scope_report$scope

        result <-
        if(scope == "coldata_only") modify_samples(.data, "mutate", ...)
        else if(scope == "rowdata_only") modify_features(.data, "mutate", ...)
        else if(scope == "assay_only") mutate_assay(.data, ...)
        else if(scope == "mixed") modify_se_plyxp(.data, "mutate", scope_report, ...)
        else mutate_via_tibble(.data, ...)

        # Record latest mutate scope into metadata for testing/introspection
        meta <- S4Vectors::metadata(result)
        if (is.null(meta)) meta <- list()
        meta$latest_mutate_scope_report <- scope_report
        S4Vectors::metadata(result) <- meta

        return(result)

}

# Simple helper function for assay-only mutations
mutate_assay <- function(.data, ...) {
    # Get the mutation expressions
    dots <- enquos(...)
    
    # For each new assay column, add it directly to assays
    for (i in seq_along(dots)) {
        new_assay_name <- names(dots)[i]
        expr <- dots[[i]]
        
        # Evaluate the expression to create the new assay
        # This assumes the expression references existing assay names
        new_assay_data <- rlang::eval_tidy(expr, data = as.list(assays(.data)))
        
        # Add the new assay
        assays(.data)[[new_assay_name]] <- new_assay_data
    }
    
    return(.data)
}

# Internal helper: perform mutate via tibble conversion and map back to SE
mutate_via_tibble <- function(.data, ...) {
    # Check that we are not modifying a key column
    cols <- enquos(...) |> names()
    
    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
    
    special_columns <- get_special_columns(
        # Decrease the size of the dataset
        .data[1:min(100, nrow(.data)), 1:min(20, ncol(.data))]
    ) |> c(get_needed_columns(.data))
    
    tst <-
        intersect(
            cols,
            special_columns
        ) |> 
        length() |>
        gt(0)
    
    if (tst) {
        columns <-
            special_columns |>
                paste(collapse=", ")
        stop(
            "tidySummarizedExperiment says:",
            " you are trying to rename a column that is view only",
            columns,
            "(it is not present in the colData).",
            " If you want to mutate a view-only column,",
            " make a copy and mutate that one."
        )
    }
    
    # If Ranges column not in query perform fast as_tibble
    skip_GRanges <-
        get_GRanges_colnames() %in% 
        cols |>
        not()
    
    return(.data |>
        as_tibble(skip_GRanges=skip_GRanges) |>
        dplyr::mutate(...) |>
        update_SE_from_tibble(.data))
}

context("mutate function comprehensive tests")

library(tidySummarizedExperiment)
library(SummarizedExperiment)
library(S4Vectors)
library(dplyr)
library(airway)

# Helper: airway-based test SE (subset for speed)
create_airway_test_se <- function() {
    data(airway)
    se <- airway
    se <- se[1:200, ]
    se
}

# Test simple queries (should use optimized paths)
test_that("mutate handles simple colData operations correctly", {
    se <- create_airway_test_se()
    
    # Simple column assignment
    result <- se %>% mutate(new_dex = dex)
    expect_true("new_dex" %in% colnames(colData(result)))
    expect_equal(as.character(colData(result)$new_dex), as.character(colData(se)$dex))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
    
    # Simple arithmetic on colData
    result <- se %>% mutate(avgLength_plus_5 = avgLength + 5)
    expect_true("avgLength_plus_5" %in% colnames(colData(result)))
    expect_equal(colData(result)$avgLength_plus_5, colData(se)$avgLength + 5)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
    
    # Simple function on colData
    result <- se %>% mutate(cell_upper = toupper(cell))
    expect_true("cell_upper" %in% colnames(colData(result)))
    expect_equal(colData(result)$cell_upper, toupper(colData(se)$cell))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
    
    # Multiple simple colData operations
    result <- se %>% mutate(
        avgLength_group = avgLength,
        dex_copy = dex,
        doubled_avgLength = avgLength * 2
    )
    expect_true(all(c("avgLength_group", "dex_copy", "doubled_avgLength") %in% colnames(colData(result))))
    expect_equal(colData(result)$doubled_avgLength, colData(se)$avgLength * 2)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
})

test_that("mutate handles simple rowData operations correctly", {
    se <- create_airway_test_se()
    
    # Simple column assignment
    result <- se %>% mutate(new_gene_biotype = gene_biotype)
    expect_true("new_gene_biotype" %in% colnames(rowData(result)))
    expect_equal(as.character(rowData(result)$new_gene_biotype), as.character(rowData(se)$gene_biotype))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "rowdata_only")
    
    # Simple arithmetic on rowData
    result <- se %>% mutate(gene_length_kb = (gene_seq_end - gene_seq_start) / 1000)
    expect_true("gene_length_kb" %in% colnames(rowData(result)))
    expect_equal(rowData(result)$gene_length_kb, (rowData(se)$gene_seq_end - rowData(se)$gene_seq_start) / 1000)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "rowdata_only")
    
    # Simple function on rowData
    result <- se %>% mutate(symbol_upper = toupper(symbol))
    expect_true("symbol_upper" %in% colnames(rowData(result)))
    expect_equal(rowData(result)$symbol_upper, toupper(rowData(se)$symbol))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "rowdata_only")
    
    # Mathematical operations on rowData
    result <- se %>% mutate(
        start_kb = round(gene_seq_start / 1000, 2),
        log_end = log2(pmax(gene_seq_end, 1))
    )
    expect_true(all(c("start_kb", "log_end") %in% colnames(rowData(result))))
    expect_equal(rowData(result)$log_end, log2(pmax(rowData(se)$gene_seq_end, 1)))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "rowdata_only")
})

test_that("mutate handles simple assay operations correctly", {
    se <- create_airway_test_se()
    
    # Simple assay column assignment
    result <- se %>% mutate(counts_copy = counts)
    expect_true("counts_copy" %in% assayNames(result))
    expect_equal(assay(result, "counts_copy"), assay(se, "counts"))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "assay_only")
    
    # Simple arithmetic on assays
    result <- se %>% mutate(counts_plus_1 = counts + 1)
    expect_true("counts_plus_1" %in% assayNames(result))
    expect_equal(assay(result, "counts_plus_1"), assay(se, "counts") + 1)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "assay_only")
    
    # Simple function on assays
    result <- se %>% mutate(log_counts_manual = log2(counts + 1))
    expect_true("log_counts_manual" %in% assayNames(result))
    expect_equal(assay(result, "log_counts_manual"), log2(assay(se, "counts") + 1))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "assay_only")
    
    # Multiple simple assay operations
    result <- se %>% mutate(
        normalized_counts = counts / 1000,
        sqrt_counts = sqrt(counts)
    )
    expect_true(all(c("normalized_counts", "sqrt_counts") %in% assayNames(result)))
    expect_equal(assay(result, "sqrt_counts"), sqrt(assay(se, "counts")))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "assay_only")
})

# Test complex queries (should use subset analysis or tibble conversion)
test_that("mutate handles complex operations with conditionals", {
    se <- create_airway_test_se()
    
    # Complex conditional on colData
    result <- se %>% mutate(
        length_group = ifelse(avgLength > mean(avgLength), "longer", "shorter")
    )
    expect_true("length_group" %in% colnames(colData(result)))
    expected <- ifelse(colData(se)$avgLength > mean(colData(se)$avgLength), "longer", "shorter")
    expect_equal(as.character(colData(result)$length_group), expected)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
    # Complex conditional on rowData - using tibble approach
    result_tbl <- se %>%  
        mutate(length_category = case_when(
            (gene_seq_end - gene_seq_start) > 3e4 ~ "long",
            (gene_seq_end - gene_seq_start) > 2e4 ~ "medium",
            TRUE ~ "short"
        ))
    expect_true("length_category" %in% colnames(rowData(result_tbl)))
    expect_equal(S4Vectors::metadata(result_tbl)$latest_mutate_scope_report$scope, "rowdata_only")
    # Complex nested conditionals
    result <- se %>% mutate(complex_category = ifelse(
        dex == "trt" & avgLength > mean(avgLength), 
        "treated_long", 
        ifelse(dex == "untrt", "untreated", "other")
    ))
    expect_true("complex_category" %in% colnames(colData(result)))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "coldata_only")
})

test_that("mutate handles complex operations with aggregations", {
    se <- create_airway_test_se()
    
    # This should use tibble conversion for complex aggregations
    result_tbl <- se %>% as_tibble() %>% mutate(mean_avgLength = mean(avgLength))
    expect_true("mean_avgLength" %in% colnames(result_tbl))
    
    # Complex expression combining multiple data types via tibble
    result_tbl <- se %>% as_tibble() %>% mutate(
        high_expression_in_trt = ifelse(
            dex == "trt" & counts > median(counts), 
            "yes", 
            "no"
        )
    )
    expect_true("high_expression_in_trt" %in% colnames(result_tbl))
})

# Test scope detection accuracy
test_that("scope detection correctly identifies operation targets", {
    se <- create_airway_test_se()
    
    # Test colData-only scope detection
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, new_len = avgLength)
    expect_equal(scope_result$scope, "coldata_only")
    expect_true(scope_result$targets_coldata)
    expect_false(scope_result$targets_rowdata)
    expect_false(scope_result$targets_assays)
    
    # Test rowData-only scope detection
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, new_symbol = symbol)
    expect_equal(scope_result$scope, "rowdata_only")
    expect_false(scope_result$targets_coldata)
    expect_true(scope_result$targets_rowdata)
    expect_false(scope_result$targets_assays)
    
    # Test assay-only scope detection
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, new_counts = counts)
    expect_equal(scope_result$scope, "assay_only")
    expect_false(scope_result$targets_coldata)
    expect_false(scope_result$targets_rowdata)
    expect_true(scope_result$targets_assays)
})

test_that("scope detection handles mixed operations", {
    se <- create_airway_test_se()
    
    # Test mixed operation (colData + assay) - creates new assay
    result <- se %>% mutate(mixed_col = paste0(dex, "_", counts))
    # This should work and create a new assay
    expect_true("mixed_col" %in% assayNames(result))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "mixed")
    
    # Test multiple operations spanning different data types
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se,
        col_operation = dex,
        row_operation = gene_biotype,
        assay_operation = counts
    )
    # Should be detected as mixed or unknown (leading to tibble conversion)
    expect_true(scope_result$scope %in% c("mixed", "unknown"))
})

test_that("mutate handles mixed arithmetic across slots (assay * colData)", {
    se <- create_airway_test_se()
    result <- se %>% mutate(new_counts = counts * avgLength)
    # Mixed operation should create a new assay
    expect_true("new_counts" %in% assayNames(result))
    expect_equal(assay(result, "new_counts"), assay(se, "counts") * matrix(rep(colData(se)$avgLength, each = nrow(se)), nrow = nrow(se)))
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "mixed")
    deps <- S4Vectors::metadata(result)$latest_mutate_scope_report$expression_dependencies$new_counts
    expect_true(deps$uses_assays)
    expect_true(deps$uses_coldata)
    expect_false(deps$uses_rowdata)
    expect_true("counts" %in% deps$referenced_assays)
    expect_true("avgLength" %in% deps$referenced_coldata)
})

test_that("mutate handles mixed arithmetic across slots (assay * rowData)", {
    se <- create_airway_test_se()
    result <- se %>% mutate(new_counts = counts * as.numeric(scale(gene_seq_end - gene_seq_start)))
    expect_true("new_counts" %in% assayNames(result))
    expected_scaled <- assay(se, "counts") * matrix(rep(as.numeric(scale(rowData(se)$gene_seq_end - rowData(se)$gene_seq_start)), times = ncol(se)), nrow = nrow(se))
    expect_equal(assay(result, "new_counts"), expected_scaled, tolerance = 5)
    expect_equal(S4Vectors::metadata(result)$latest_mutate_scope_report$scope, "mixed")
    deps <- S4Vectors::metadata(result)$latest_mutate_scope_report$expression_dependencies$new_counts
    expect_true(deps$uses_assays)
    expect_false(deps$uses_coldata)
    expect_true(deps$uses_rowdata)
    expect_true("counts" %in% deps$referenced_assays)
    expect_true(all(c("gene_seq_start","gene_seq_end") %in% deps$referenced_rowdata))
})

# Test execution paths work correctly
test_that("different execution paths produce correct results", {
    se <- create_airway_test_se()
    
    # Test modify_samples path (colData-only)
    result_coldata <- se %>% mutate(avgLength_doubled = avgLength * 2)
    expect_equal(colData(result_coldata)$avgLength_doubled, colData(se)$avgLength * 2)
    expect_equal(dim(result_coldata), dim(se))
    expect_equal(assayNames(result_coldata), assayNames(se))
    
    # Test modify_features path (rowData-only)
    result_rowdata <- se %>% mutate(length_log = log(pmax(gene_seq_end - gene_seq_start, 1)))
    expect_equal(rowData(result_rowdata)$length_log, log(pmax(rowData(se)$gene_seq_end - rowData(se)$gene_seq_start, 1)))
    expect_equal(dim(result_rowdata), dim(se))
    expect_equal(assayNames(result_rowdata), assayNames(se))
    
    # Test mutate_assay path (assay-only)
    result_assay <- se %>% mutate(normalized_counts = counts / 100)
    expect_true("normalized_counts" %in% assayNames(result_assay))
    expect_equal(assay(result_assay, "normalized_counts"), assay(se, "counts") / 100)
    expect_equal(dim(result_assay), dim(se))
    
    # Test tibble conversion path (complex/mixed operations)
    result_complex <- se %>% mutate(
        complex_feature = ifelse(dex == "trt" & counts > 5, "yes", "no")
    )
    # Complex mixed operations create new assays
    expect_true("complex_feature" %in% assayNames(result_complex))
})

# Test query complexity classification
test_that("query complexity is correctly classified", {
    se <- create_airway_test_se()
    
    # Simple queries
    simple_queries <- list(
        "simple_assignment" = quote(dex),
        "simple_arithmetic" = quote(avgLength + 5),
        "simple_function" = quote(log2(counts)),
        "simple_paste" = quote(paste0("prefix_", cell))
    )
    
    for (query_name in names(simple_queries)) {
        scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, 
            !!query_name := !!simple_queries[[query_name]])
        expect_equal(scope_result$query_complexity, "simple", 
                    info = paste("Query", query_name, "should be classified as simple"))
    }
    
    # Complex queries
    complex_queries <- list(
        "conditional" = quote(ifelse(avgLength > mean(avgLength), "long", "short")),
        "aggregation" = quote(mean(avgLength))
    )
    
    for (query_name in names(complex_queries)) {
        scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se,
            !!query_name := !!complex_queries[[query_name]])
        expect_equal(scope_result$query_complexity, "complex",
                    info = paste("Query", query_name, "should be classified as complex"))
    }
})

# Test performance and optimization
test_that("optimized paths are faster than tibble conversion", {
    se <- create_airway_test_se()
    
    # Simple colData operation (should use optimized path)
    time_optimized <- system.time({
        result_opt <- se %>% mutate(len_plus_10 = avgLength + 10)
    })
    
    # Force tibble conversion by using a complex operation
    time_tibble <- system.time({
        result_tibble <- se %>% mutate(complex_op = ifelse(avgLength > mean(avgLength) & dex == "trt", 1, 0))
    })
    
    # The optimized path should generally be faster, but we'll just check it completes
    expect_true(time_optimized[["elapsed"]] >= 0)
    expect_true(time_tibble[["elapsed"]] >= 0)
    
    # Both should produce valid results
    expect_s4_class(result_opt, "SummarizedExperiment")
    # This operation only uses colData, so result is stored in colData
    expect_true("complex_op" %in% colnames(colData(result_tibble)))
})

# Test edge cases and error handling
test_that("mutate handles edge cases correctly", {
    se <- create_airway_test_se()
    
    # Single row/column SE
    single_se <- se[1, 1]
    result_single <- single_se %>% mutate(new_len = avgLength + 1)
    expect_equal(dim(result_single), c(1, 1))
    expect_true("new_len" %in% colnames(colData(result_single)))
    
    # Overwriting existing columns
    result_overwrite <- se %>% mutate(dex = "trt")
    expect_true(all(colData(result_overwrite)$dex == "trt"))
    
    # Adding multiple columns at once
    result_multiple <- se %>% mutate(
        col1 = avgLength,
        col2 = cell, 
        col3 = dex,
        assay1 = counts,
        assay2 = log2(counts + 1)
    )
    expect_true(all(c("col1", "col2", "col3") %in% colnames(colData(result_multiple))))
    expect_true(all(c("assay1", "assay2") %in% assayNames(result_multiple)))
})

test_that("mutate error handling works correctly", {
    se <- create_airway_test_se()
    
    # Trying to modify special/protected columns should give appropriate errors
    expect_error(se %>% mutate(.feature = "modified"), "view only")
    expect_error(se %>% mutate(.sample = "modified"), "view only")
    
    # Operations that reference non-existent columns should be handled gracefully
    # This might work via tibble conversion or give an informative error
    expect_error(se %>% mutate(test = nonexistent_column), "object.*not found|could not find")
})

# Test integration with other dplyr operations
test_that("mutate integrates well with other dplyr operations", {
    se <- create_airway_test_se()
    
    # Chain mutate with filter
    result <- se %>% 
        mutate(length_group = ifelse(avgLength > mean(avgLength), "longer", "shorter")) %>%
        filter(length_group == "longer")
    
    # length_group is stored in colData for colData-only operations
    expect_true("length_group" %in% colnames(colData(result)))
    expect_true(all(as_tibble(result)$avgLength > mean(create_airway_test_se() %>% colData() %>% as.data.frame() %>% .$avgLength)))
    
    # Chain mutate with select
    result <- se %>%
        mutate(new_cell = toupper(cell)) %>%
        select(new_cell, avgLength)
    
    expect_equal(ncol(result), 2)
    expect_true("new_cell" %in% colnames(result))
    
    # Chain multiple mutates
    result <- se %>%
        mutate(len_doubled = avgLength * 2) %>%
        mutate(len_category = ifelse(len_doubled > mean(len_doubled), "high", "low"))
    
    # Both should be in colData for colData-only operations
    expect_true(all(c("len_doubled", "len_category") %in% colnames(colData(result))))
})

# Test with real-world-like scenarios
test_that("mutate handles realistic bioinformatics scenarios", {
    se <- create_airway_test_se()
    
    # Normalize counts by library size - using tibble conversion for mixed operations
    result_tbl <- se %>% as_tibble() %>% mutate(cpm = (counts / avgLength) * 1e6)
    expect_true("cpm" %in% colnames(result_tbl))
    
    # Create gene expression categories - simplified
    result_tbl <- se %>% as_tibble() %>% mutate(
        expression_category = ifelse(counts > median(counts), "high", "low")
    )
    expect_true("expression_category" %in% colnames(result_tbl))
    
    # Combine sample metadata
    result <- se %>% mutate(
        sample_info = paste(cell, dex, SampleName, sep = "_"),
        treatment_flag = ifelse(dex == "trt", 1, 0)
    )
    expect_true(all(c("sample_info", "treatment_flag") %in% colnames(colData(result))))
    
    # Gene annotation processing
    result <- se %>% mutate(
        is_protein_coding = gene_biotype == "protein_coding",
        gene_symbol = toupper(symbol),
        kb_length = round((gene_seq_end - gene_seq_start) / 1000, 1)
    )
    expect_true(all(c("is_protein_coding", "gene_symbol", "kb_length") %in% colnames(rowData(result))))
})

# Test scope detection - simplified to avoid quosure issues
test_that("scope detection works correctly through mutate interface", {
    se <- create_airway_test_se()
    
    # Test through the main mutate scope analysis function
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, test_col = dex)
    expect_equal(scope_result$scope, "coldata_only")
    
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, test_col = gene_biotype)
    expect_equal(scope_result$scope, "rowdata_only")
    
    scope_result <- tidySummarizedExperiment:::analyze_query_scope_mutate(se, test_col = counts)
    expect_equal(scope_result$scope, "assay_only")
})

#' Check if a dplyr query is composed (has multiple expressions)
#'
#' This function determines whether a dplyr operation contains multiple expressions
#' that could benefit from decomposition and individual analysis.
#'
#' @param operation Character string specifying the dplyr operation (e.g., "mutate", "filter")
#' @param ... The expressions passed to the dplyr function
#' @return Logical indicating whether the query is composed (TRUE) or simple (FALSE)
#'
#' @examples
#' \dontrun{
#' library(airway)
#' data(airway)
#' 
#' # Simple query - not composed
#' is_composed("mutate", new_col = dex)  # FALSE
#' 
#' # Composed query - multiple expressions
#' is_composed("mutate", col1 = dex, col2 = cell)  # TRUE
#' 
#' # Filter with multiple conditions
#' is_composed("filter", dex == "trt", cell == "N61311")  # TRUE
#' }
#'
#' @keywords internal
#' @noRd
is_composed <- function(operation, ...) {
  
  # Capture the expressions
  dots <- rlang::enquos(...)
  
  # If no expressions, not composed
  if (length(dots) == 0) {
    return(FALSE)
  }
  
  # If only one expression, not composed
  if (length(dots) == 1) {
    return(FALSE)
  }
  
  # Multiple expressions - composed
  return(TRUE)
}

#' Function factory for substitute-based query decomposition
#'
#' Creates a decomposition function that uses substitute() to transform:
#' fx(a = x, b = y, c = z, .preserve = FALSE) into: 
#' fx(a = x, .preserve = FALSE) |> fx(b = y, .preserve = FALSE) |> fx(c = z, .preserve = FALSE)
#' 
#' Handles additional arguments (like .preserve, .by, etc.) by passing them to each decomposed step.
#' 
#' Can be used in two ways:
#' 1. Get decomposition info: decompose_tidy_operation("mutate", x = a, y = b)
#' 2. Create executable function: decompose_tidy_operation("mutate", x = a, y = b)(se)
#'
#' @param fx_name Character name of the function (e.g., "mutate", "filter", "select")
#' @param ... Main expressions to decompose AND additional named arguments
#' @return Function that can be applied to a SummarizedExperiment, or if no SE provided, decomposition info
#'
#' @examples
#' \dontrun{
#' library(dplyr)
#' library(airway)
#' data(airway)
#' 
#' # Basic mutate decomposition
#' mutate_fn <- decompose_tidy_operation("mutate", new_dex = dex, new_cell = cell)
#' attr(mutate_fn, "pipeline_text")
#' # "mutate(new_dex = dex) |> mutate(new_cell = cell)"
#' 
#' # Execute the decomposed pipeline
#' result_se <- mutate_fn(airway)
#' 
#' # One-liner execution (your brilliant syntax!)
#' se_result <- decompose_tidy_operation("mutate", dex_1 = dex, dex_2 = dex)(airway)
#' 
#' # With additional arguments
#' filter_preserve <- decompose_tidy_operation("filter", 
#'                                        dex == "trt", 
#'                                        cell == "N61311", 
#'                                        .preserve = FALSE)
#' attr(filter_preserve, "pipeline_text")
#' # "filter(dex == \"trt\", .preserve = FALSE) |> filter(cell == \"N61311\", .preserve = FALSE)"
#' 
#' # Multiple additional arguments
#' mutate_with_args <- decompose_tidy_operation("mutate", 
#'                                         log_counts = log2(counts + 1),
#'                                         is_treated = dex == "trt",
#'                                         .keep = "used")
#' 
#' # Universal pattern works with any dplyr operation
#' select_fn <- decompose_tidy_operation("select", dex, cell, counts)
#' group_by_fn <- decompose_tidy_operation("group_by", dex, cell)
#' summarise_fn <- decompose_tidy_operation("summarise", 
#'                                     mean_counts = mean(counts),
#'                                     n_samples = n(),
#'                                     .groups = "drop")
#' 
#' # Access metadata
#' attr(mutate_fn, "decomposed")           # TRUE
#' attr(mutate_fn, "function_name")        # "mutate"
#' attr(mutate_fn, "individual_calls")     # Character vector of each step
#' attr(mutate_fn, "additional_args")      # List of .* arguments
#' }
#'
#' @keywords internal
#' @noRd
decompose_tidy_operation <- function(fx_name, ...) {
  
  # Capture the expressions
  dots <- rlang::enquos(...)
  
  # Separate main expressions from additional arguments (like .preserve, .by, etc.)
  dot_names <- names(dots)
  additional_args <- list()
  main_expressions <- list()
  
  for (i in seq_along(dots)) {
    name <- dot_names[i]
    if (!is.null(name) && startsWith(name, ".")) {
      # Additional argument (starts with .)
      additional_args[[name]] <- dots[[i]]
    } else {
      # Main expression to decompose
      main_expressions <- append(main_expressions, dots[i])
    }
  }
  
  # If no names, all are main expressions
  if (is.null(dot_names)) {
    main_expressions <- dots
  }
  
  # Convert back to quosures for consistency
  main_expressions <- rlang::as_quosures(main_expressions, env = parent.frame())
  
  if (length(main_expressions) <= 1) {
    # Single expression - no decomposition needed, but still return executable function
    single_function <- function(se) {
      if (fx_name == "mutate") {
        return(se %>% mutate(!!!main_expressions, !!!additional_args))
      } else if (fx_name == "filter") {
        return(se %>% filter(!!!main_expressions, !!!additional_args))
      } else if (fx_name == "select") {
        return(se %>% select(!!!main_expressions, !!!additional_args))
      } else {
        # Generic execution
        op_call <- rlang::call2(fx_name, se, !!!main_expressions, !!!additional_args)
        return(rlang::eval_tidy(op_call, env = parent.frame()))
      }
    }
    
    attr(single_function, "decomposed") <- FALSE
    attr(single_function, "function_name") <- fx_name
    attr(single_function, "expressions") <- main_expressions
    attr(single_function, "additional_args") <- additional_args
    
    return(single_function)
  }
  
  # Create individual function calls as text
  individual_calls <- vector("character", length(main_expressions))
  individual_expressions <- vector("list", length(main_expressions))
  
  # Create additional args text for inclusion in each call
  additional_args_text <- ""
  if (length(additional_args) > 0) {
    additional_parts <- character(length(additional_args))
    for (j in seq_along(additional_args)) {
      arg_name <- names(additional_args)[j]
      arg_value <- rlang::quo_text(additional_args[[j]])
      additional_parts[j] <- paste0(arg_name, " = ", arg_value)
    }
    additional_args_text <- paste0(", ", paste(additional_parts, collapse = ", "))
  }
  
  for (i in seq_along(main_expressions)) {
    # Check if expression is named
    expr_name <- names(main_expressions)[i]
    is_named <- !is.null(expr_name) && expr_name != ""
    
    # For unnamed expressions, use a placeholder name for indexing but keep original for execution
    display_name <- if (!is_named) paste0("expr_", i) else expr_name
    
    single_expr <- main_expressions[i]
    # Only set names for named expressions
    if (is_named) {
      names(single_expr) <- expr_name
    }
    
    # Create the function call as text
    expr_text <- rlang::quo_text(single_expr[[1]])
    if (is_named) {
      # Named expression
      individual_calls[i] <- paste0(fx_name, "(", expr_name, " = ", expr_text, additional_args_text, ")")
    } else {
      # Unnamed expression
      individual_calls[i] <- paste0(fx_name, "(", expr_text, additional_args_text, ")")
    }
    
    individual_expressions[[i]] <- single_expr
    names(individual_calls)[i] <- display_name
    names(individual_expressions)[i] <- display_name
  }
  
  # Create pipeline representation as text
  pipeline_text <- paste(individual_calls, collapse = " |> ")
  
  # Create the executable function
  pipeline_function <- function(se) {
    # Execute each step sequentially
    result_se <- se
    
    for (i in seq_along(individual_expressions)) {
      step_expr <- individual_expressions[[i]]
      
      # Execute this step using the appropriate dplyr function, including additional args
      if (fx_name == "mutate") {
        result_se <- result_se %>% mutate(!!!step_expr, !!!additional_args)
      } else if (fx_name == "filter") {
        result_se <- result_se %>% filter(!!!step_expr, !!!additional_args)
      } else if (fx_name == "select") {
        result_se <- result_se %>% select(!!!step_expr, !!!additional_args)
      } else {
        # Generic execution for other operations
        op_call <- rlang::call2(fx_name, result_se, !!!step_expr, !!!additional_args)
        result_se <- rlang::eval_tidy(op_call, env = parent.frame())
      }
    }
    
    return(result_se)
  }
  
  # Add metadata to the function
  attr(pipeline_function, "decomposed") <- TRUE
  attr(pipeline_function, "function_name") <- fx_name
  attr(pipeline_function, "pipeline_text") <- pipeline_text
  attr(pipeline_function, "individual_calls") <- individual_calls
  attr(pipeline_function, "individual_expressions") <- individual_expressions
  attr(pipeline_function, "additional_args") <- additional_args
  
  return(pipeline_function)
}

context("filter function tests with scope and decomposition")

library(tidySummarizedExperiment)
library(SummarizedExperiment)
library(S4Vectors)
library(dplyr)
library(airway)

# Helper: airway-based test SE (subset for speed)
create_airway_test_se <- function() {
    data(airway)
    se <- airway
    se <- se[1:200, ]
    se
}

test_that("filter handles colData-only predicates (samples)", {
    se <- create_airway_test_se()

    # Reference using colData
    keep_samples <- which(colData(se)$dex == "trt")

    result <- se %>% filter(dex == "trt")

    expect_equal(nrow(result), nrow(se))
    expect_equal(ncol(result), length(keep_samples))
    expect_equal(colnames(result), colnames(se)[keep_samples])
    expect_equal(S4Vectors::metadata(result)$latest_filter_scope_report$scope, "coldata_only")
})

test_that("filter handles rowData-only predicates (features)", {
    se <- create_airway_test_se()

    # Reference using rowData
    keep_rows <- which(rowData(se)$gene_biotype == "protein_coding")

    result <- se %>% filter(gene_biotype == "protein_coding")

    expect_equal(ncol(result), ncol(se))
    expect_equal(nrow(result), length(keep_rows))
    expect_equal(rownames(result), rownames(se)[keep_rows])
    expect_equal(S4Vectors::metadata(result)$latest_filter_scope_report$scope, "rowdata_only")
})

## Mixed predicates across slots are handled by plyxp engine, which may enforce
## explicit rows()/cols() wrappers; covered elsewhere. We skip here to avoid flakiness.

test_that("is_composed detects multiple filter predicates", {
    se <- create_airway_test_se()
    expect_true(tidySummarizedExperiment:::is_composed("filter", dex == "trt", cell == cell[1]))
    expect_false(tidySummarizedExperiment:::is_composed("filter", dex == "trt"))
})

test_that("filter metadata stores latest scope report", {
    se <- create_airway_test_se()

    res1 <- se %>% filter(dex == "trt")
    expect_true(!is.null(S4Vectors::metadata(res1)$latest_filter_scope_report))
    expect_equal(S4Vectors::metadata(res1)$latest_filter_scope_report$scope, "coldata_only")

    res2 <- se %>% filter(gene_biotype == "protein_coding")
    expect_true(!is.null(S4Vectors::metadata(res2)$latest_filter_scope_report))
    expect_equal(S4Vectors::metadata(res2)$latest_filter_scope_report$scope, "rowdata_only")
})

test_that("internal analyze_query_scope_filter detects scopes", {
    se <- create_airway_test_se()

    scope <- tidySummarizedExperiment:::analyze_query_scope_filter(se, dex == "trt")
    expect_equal(scope$scope, "coldata_only")

    scope <- tidySummarizedExperiment:::analyze_query_scope_filter(se, gene_biotype == "protein_coding")
    expect_equal(scope$scope, "rowdata_only")

    scope <- tidySummarizedExperiment:::analyze_query_scope_filter(se, gene_biotype == "protein_coding", dex == "trt")
    expect_true(scope$scope %in% c("mixed", "unknown"))
})


test_that("assay-only filter yields non-rectangular tibble fallback", {
    se <- create_airway_test_se()

    # Reference tibble with non-rectangular selection using assay values
    res_tbl <- se %>%
        as_tibble(skip_GRanges = TRUE) %>%
        dplyr::filter(counts > 0)

    # Apply through SE interface; dependency analysis marks assay_only and we fallback
    res <- se %>% filter(counts > 0)

    expect_true(tibble::is_tibble(res))
    expect_identical(colnames(res_tbl), colnames(res))
    expect_identical(nrow(res_tbl), nrow(res))
})

#' Drop attribute to abject
#'
#' @keywords internal
#'
#'
#' @param var A tibble
#' @param name A character name of the attribute
#' 
#' @noRd
#'
#' @return A tibble with an additional attribute
drop_attr <- function(var, name) {
  attr(var, name) <- NULL
  var
}

#' Drop all attribute to abject
#'
#' @keywords internal
#'
#'
#' @param var A tibble
#' @param name A character name of the attribute
#'
#' @noRd
#' 
#' @return A tibble with an additional attribute
drop_all_attr <- function(var) {
  
  N <- var %>% attributes() %>% names()
  
  for (n in N) {
    var <- var %>% drop_attr(n)
  }
  
  var
}

#' Get matrix from tibble
#'
#' @keywords internal
#' 
#' @importFrom magrittr set_rownames
#' @importFrom rlang quo_is_null
#'
#' @param tbl A tibble
#' @param rownames A character string of the rownames
#' @param do_check A boolean
#'
#' @return A matrix
#'
#' @examples
#'
#' as_matrix(head(dplyr::select(tidybulk::counts_mini, feature, count)), rownames=feature)
#'
#' @noRd
as_matrix <- function(tbl,
                      rownames = NULL,
                      do_check = TRUE) {
  rownames <- enquo(rownames)
  
  tbl %>%
    # Throw warning if data frame is not numerical beside the rownames column (if present)
    when(
      do_check &&
        (.) %>%
        # If rownames defined eliminate it from the data frame
        when(!quo_is_null(rownames) ~ (.)[,-1], ~ (.)) %>%
        dplyr::summarise_all(class) %>%
        tidyr::gather(variable, class) %>%
        pull(class) %>%
        unique() %>%
        `%in%`(c("numeric", "integer")) %>% not() %>% any() ~ {
          warning("tidybulk says: there are NON-numerical columns, the matrix will NOT be numerical")
          (.)
        },
      ~ (.)
    ) %>%
    as.data.frame() %>%
    
    # Deal with rownames column if present
    when(
      !quo_is_null(rownames) ~ (.) %>%
        magrittr::set_rownames(tbl %>% pull(!!rownames)) %>%
        select(-1),
      ~ (.)
    ) %>%
    
    # Convert to matrix
    as.matrix()
}

#' @importFrom tibble as_tibble
#' @importFrom SummarizedExperiment colData
#'
#' @keywords internal
#'
#' @param .data A tidySummarizedExperiment
#'
#' @noRd
to_tib <- function(.data) {
  colData(.data) %>%
    as.data.frame() %>%
    as_tibble(rownames = "cell")
}

# Greater than
gt <- function(a, b) {
  a > b
}

# Smaller than
st <- function(a, b) {
  a < b
}

# Negation
not <- function(is) {
  !is
}

# Raise to the power
pow <- function(a, b) {
  a^b
}

# Equals
eq <- function(a, b) {
  a == b
}

prepend <- function(x, values, before = 1) {
  n <- length(x)
  stopifnot(before > 0 && before <= n)
  if (before == 1) {
    c(values, x)
  }
  else {
    c(x[seq_len(before - 1)], values, x[before:n])
  }
}

#' Add class to abject
#'
#'
#' @keywords internal
#'
#' @param var A tibble
#' @param name A character name of the attribute
#'
#' @return A tibble with an additional attribute
#' 
#' @noRd
add_class <- function(var, name) {
  if (!name %in% class(var)) {
    class(var) <- prepend(class(var), name)
  }
  var
}

#' Remove class to abject
#'
#' @keywords internal
#'
#'
#' @param var A tibble
#' @param name A character name of the class
#'
#' @return A tibble with an additional attribute
#' 
#' @noRd
drop_class <- function(var, name) {
  class(var) <- class(var)[!class(var) %in% name]
  var
}

#' get abundance long
#'
#' @keywords internal
#'
#' @importFrom magrittr "%$%"
#' @importFrom utils tail
#' @importFrom SummarizedExperiment assays
#'
#' @param .data A tidySummarizedExperiment
#' @param transcripts A character
#' @param all A boolean
#'
#'
#' @return A tidySummarizedExperiment object
#'
#'
#' @noRd
get_abundance_sc_wide <- function(.data, transcripts = NULL, all = FALSE) {
  
  # Solve CRAN warnings
  . <- NULL
  
  # For SCE there is not filed for variable features
  variable_feature <- c()
  
  # Check if output would be too big without forcing
  if (
    length(variable_feature) == 0 &&
    is.null(transcripts) &&
    !all
  ) {
    stop("
                Your object does not contain variable feature labels,
                feature argument is empty and all arguments are set to FALSE.
                Either:
                1. use detect_variable_features() to select variable feature
                2. pass an array of feature names
                3. set all=TRUE (this will output a very large object, does your computer have enough RAM?)
                ")
  }
  
  # Get variable features if existing
  if (
    length(variable_feature) > 0 &&
    is.null(transcripts) &&
    !all
  ) {
    variable_genes <- variable_feature
  } else {
    variable_genes <- NULL
  }
  
  # Just grub last assay
  assays(.data) %>%
    as.list() %>%
    tail(1) %>%
    .[[1]] %>%
    when(
      variable_genes %>% is.null() %>% `!`() ~ (.)[variable_genes, , drop = FALSE],
      transcripts %>% is.null() %>% `!`() ~ (.)[transcripts, , drop = FALSE],
      ~ stop("It is not convenient to extract all genes, you should have either variable features or feature list to extract")
    ) %>%
    as.matrix() %>%
    t() %>%
    as_tibble(rownames = "cell")
}

#' get abundance long
#'
#' @keywords internal
#'
#' @importFrom magrittr "%$%"
#' @importFrom tidyr pivot_longer
#' @importFrom tibble as_tibble
#' @importFrom purrr map2
#' @importFrom SummarizedExperiment assays
#'
#' @param .data A tidySummarizedExperiment
#' @param transcripts A character
#' @param all A boolean
#' @param exclude_zeros A boolean
#'
#' @return A tidySummarizedExperiment object
#'
#'
#' @noRd
get_abundance_sc_long <- function(.data, transcripts = NULL, all = FALSE,
                                  exclude_zeros = FALSE) {
  
  # Solve CRAN warnings
  . <- NULL
  
  # For SCE there is not filed for variable features
  variable_feature <- c()
  
  # Check if output would be too big without forcing
  if (
    length(variable_feature) == 0 &&
    is.null(transcripts) &&
    !all
  ) {
    stop("
                Your object does not contain variable feature labels,
                feature argument is empty and all arguments are set to FALSE.
                Either:
                1. use detect_variable_features() to select variable feature
                2. pass an array of feature names
                3. set all=TRUE (this will output a very large object, does your computer have enough RAM?)
                ")
  }
  
  
  # Get variable features if existing
  if (
    length(variable_feature) > 0 &&
    is.null(transcripts) &&
    !all
  ) {
    variable_genes <- variable_feature
  } else {
    variable_genes <- NULL
  }
  
  assay_names <- assays(.data) %>% names()
  
  
  assays(.data) %>%
    as.list() %>%
    
    # Take active assay
    map2(
      assay_names,
      
      ~ .x %>%
        when(
          variable_genes %>% is.null() %>% `!`() ~ .x[variable_genes, , drop = FALSE],
          transcripts %>% is.null() %>% `!`() ~ .x[toupper(rownames(.x)) %in% toupper(transcripts), , drop=FALSE],
          all ~ .x,
          ~ stop("It is not convenient to extract all genes, you should have either variable features or feature list to extract")
        ) %>%
        
        # Replace 0 with NA
        when(exclude_zeros ~ (.) %>% {
          x <- (.)
          x[x == 0] <- NA
          x
        }, ~ (.)) %>%
        as.matrix() %>%
        data.frame() %>%
        as_tibble(rownames=f_(.data)$name) %>%
        tidyr::pivot_longer(
          cols = -!!f_(.data)$symbol,
          names_to = "cell",
          values_to = "abundance" %>% paste(.y, sep = "_"),
          values_drop_na = TRUE
        )
      # %>%
      # mutate_if(is.character, as.factor) %>%
    ) %>%
    Reduce(function(...) left_join(..., by = c(f_(.data)$name, "cell")), .)
}


#' @importFrom methods .hasSlot
#' @importFrom S4Vectors DataFrame
#' @importFrom stats setNames
#' @importFrom SummarizedExperiment colData
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment colData<-
#' @importFrom SummarizedExperiment rowData<-
#' @importFrom S4Vectors head 
#' @importFrom rlang .data
#'
#' @keywords internal
#'
#' @param .data_mutated A tibble
#' @param se A tidySummarizedExperiment
#'
#' @noRd
update_SE_from_tibble <- function(.data_mutated, se, column_belonging = NULL) {
  
  # Comply to CRAN notes 
  . <- NULL 
  
  # Extract column data
  col_data <- extract_col_data(.data_mutated, se, column_belonging)
  
  # This to avoid the mismatch between missing column names for counts 
  # and numerical row names for colData
  row_names_col = 
    col_data %>%
    rownames() %>%
    when(
      colnames(se) %>% is.null ~ as.integer(.),
      ~ (.)
    )
  
  # Extract row data
  row_data <- extract_row_data(.data_mutated, se, col_data = col_data)
  
  # This to avoid the mismatch between missing row names for counts 
  # and numerical row names for rowData
  row_names_row <- 
    row_data %>%
    rownames() %>%
    when(
      rownames(se) %>% is.null ~ as.integer(.),
      ~ (.)
    )
  
  # Subset if needed. This function is used by many dplyr utilities
  se <- se[row_names_row, row_names_col]
  
  # Update
  colData(se) <- col_data
  rowData(se) <- row_data
  
  # Extract assay column names
  colnames_assay <- extract_assay_colnames(.data_mutated, se, col_data, row_data)
  
  if (length(colnames_assay) > 0)
    assays(se, withDimnames = FALSE) <-
    assays(se, withDimnames = FALSE) %>% c(
      .data_mutated %>% 
        
        # Select assays column
        select(!!f_(se)$symbol, !!s_(se)$symbol, colnames_assay) %>% 
        
        # Pivot for generalising to many assays
        pivot_longer(cols = -c(!!s_(se)$symbol, !!f_(se)$symbol)) %>%
        nest(data___ = c(!!s_(se)$symbol, !!f_(se)$symbol, value)) %>%
        
        # Convert to matrix and to named list
        mutate(data___ = map2(
          data___, name,
          ~ {
            .x = 
              .x %>%
              spread(!!s_(se)$symbol, value) %>% 
              as_matrix(rownames = !!f_(se)$symbol)  %>% 
              suppressWarnings()
            
            # Rearrange if assays has colnames and rownames
            if(!is.null(rownames(se)) & !is.null(rownames(.x))) .x = .x[rownames(se),,drop=FALSE]
            if(!is.null(colnames(se)) & !is.null(colnames(.x))) .x = .x[,colnames(se),drop=FALSE]
            
            
            .x %>%
              
              list() %>%
              setNames(.y)
          }
        )) %>%
        
        # Create correct list
        pull(data___) %>%
        reduce(c)
    )
  
  # return
  se
}
#' @importFrom methods is
slice_optimised <- function(.data, ..., .preserve=FALSE) {
  
  . <- NULL
  
  # This simulated tibble only gets samples and features so we know those that have been completely omitted already
  # In order to save time for the as_tibble conversion
  simulated_slice = 
    simulate_feature_sample_from_tibble(.data) %>% 
    dplyr::slice(..., .preserve = .preserve)
  
  .data = 
    .data %>%
    
    # Subset the object for samples and features present in the simulated data
    .[rownames(.) %in% simulated_slice[,f_(.)$name], 
      colnames(.) %in% simulated_slice[,s_(.)$name]] %>% 
    inner_join(simulated_slice, by = c(f_(.)$name, s_(.)$name)) 
  
  # If order do not match with the one proposed by slice convert to tibble
  if (.data %>% is("tbl") %>% not()) {
    .data_for_match <- .data %>% select(!!f_(.data)$symbol, !!s_(.data)$symbol) %>% as_tibble() 
    
    x <- c(pull(.data_for_match, !!f_(.data)$symbol), pull(.data_for_match, !!s_(.data)$symbol))
    y <- c(pull(simulated_slice, !!f_(.data)$symbol), pull(simulated_slice, !!s_(.data)$symbol))
    
    if (identical(x, y) %>% not()) {
      left_join(simulated_slice, as_tibble(.data), by = c(f_(.data)$name, s_(.data)$name))
    } else {
      .data
    }
  }
}


#' @importFrom purrr map_chr
#' @importFrom dplyr select_if
#'
#' @keywords internal
#'
#' @param se A tidySummarizedExperiment
#'
#' @noRd
#'
get_special_columns <- function(.data) {
  colnames_special <-
    get_special_datasets(.data) %>%
    
    # In case any of those have feature of sample in column names
    map(
      ~ .x %>%
        select_if(!colnames(.) %in% get_needed_columns(.data)) %>%
        colnames()
    ) %>%
    unlist() %>%
    as.character()
  
  colnames_counts <-
    get_count_datasets(.data) %>%
    select(-!!f_(.data)$symbol, -!!s_(.data)$symbol) %>%
    colnames()
  
  colnames_special %>% c(colnames_counts)
}

#' @importFrom dplyr select
#' @importFrom tidyselect one_of
#' @importFrom tibble as_tibble
#' @importFrom tibble tibble
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom tibble rowid_to_column
#' 
#' @noRd
get_special_datasets <- function(se) {
  
  rr =  se %>%
    rowRanges() 
  
  rr %>%
    when( 
      
      # If no ranges
      as.data.frame(.) %>%
        nrow() %>%
        equals(0) ~ tibble(),
      
      # If it is a range list (multiple rows per feature)
      is(., "CompressedGRangesList") ~ {
        
        # If GRanges does not have row names
        if (is.null(rr@partitioning@NAMES)) {
          rr@partitioning@NAMES <- as.character(1:nrow(se))
        }
        
        tibble::as_tibble(rr) %>%
          eliminate_GRanges_metadata_columns_also_present_in_Rowdata(se) %>%
          nest(GRangesList = -group_name) %>%
          rename(!!f_(se)$symbol := group_name)
        
      },
      
      # If standard GRanges (one feature per line)
      ~ {
        
        # If GRanges does not have row names
        if (is.null(rr@ranges@NAMES)) {
          rr@ranges@NAMES <- as.character(1:nrow(se))
        }
        
        tibble::as_tibble(rr) %>% 
          eliminate_GRanges_metadata_columns_also_present_in_Rowdata(se) %>% 
          mutate(!!f_(se)$symbol := rr@ranges@NAMES) 
      }
      
    ) %>%
    list()
}

check_se_dimnames <- function(se) {

    # Stop if any column or row names are duplicated
    if (check_if_any_dimnames_duplicated(se, dim = "cols")) {
        stop("tidySummarizedExperiment says: some column names are duplicated")
    }
    if (check_if_any_dimnames_duplicated(se, dim = "rows")) {
        stop("tidySummarizedExperiment says: some row names are duplicated")
    }

    # Stop if column names of assays do not overlap, or if some assays have 
    # column names and others don't
    if (check_if_assays_are_NOT_overlapped(se, dim = "cols")) { 
        warning( 
            "tidySummarizedExperiment says: at least one of the assays in your SummarizedExperiment have column names, but they don't completely overlap between assays. It is strongly recommended to make the assays consistent, to avoid erroneous matching of samples." 
        )
    }
    # Same for row names
    if (check_if_assays_are_NOT_overlapped(se, dim = "rows")) { 
        warning( 
            "tidySummarizedExperiment says: at least one of the assays in your SummarizedExperiment have row names, but they don't completely overlap between assays. It is strongly recommended to make the assays consistent, to avoid erroneous matching of features." 
        )
    }
    
    # If the assays have dimnames but the SE does not, throw a warning and set 
    # the dimnames of the SE to those of the first assay with dimnames.
    # (At this point we know that all assays have the same dimnames (could be 
    # NULL), but they could be in different order)
    if (is.null(colnames(se)) && 
        length(assays(se)) > 0) {
        cn <- vapply(assays(se, withDimnames = FALSE), function(x) !is.null(colnames(x)), FALSE)
        if (any(cn)) {
            idx <- which(cn)[1]
            warning(
                "tidySummarizedExperiment says: the assays in your SummarizedExperiment have column names, but the SummarizedExperiment does not. Setting colnames(se) to column names of first assay with column names (assay ", idx, ")."
            )
            colnames(se) <- colnames(assays(se, withDimnames = FALSE)[[idx]])
        }
    }
    if (is.null(rownames(se)) && 
        length(assays(se)) > 0) {
        rn <- vapply(assays(se, withDimnames = FALSE), function(x) !is.null(rownames(x)), FALSE)
        if (any(rn)) {
            idx <- which(rn)[1]
            warning(
                "tidySummarizedExperiment says: the assays in your SummarizedExperiment have row names, but the SummarizedExperiment does not. Setting rownames(se) to row names of first assay with row names (assay ", idx, ")."
            )
            rownames(se) <- rownames(assays(se, withDimnames = FALSE)[[idx]])
        }
    }
    
    # If the assays as well as the SE have dimnames, but they don't overlap 
    # (they may be in different order), throw an error.
    if (!is.null(colnames(se)) &&
        length(assays(se)) > 0 && 
        !is.null(colnames(assays(se, withDimnames = FALSE)[[1]])) && 
        !all(colnames(assays(se, withDimnames = FALSE)[[1]]) %in% colnames(se))) {
        warning(
            "tidySummarizedExperiment says: the assays in your SummarizedExperiment have column names, but they don't agree with the column names of the SummarizedExperiment object itself. It is strongly recommended to make the assays consistent, to avoid erroneous matching of samples."
        )

    }
  
  if (is.null(rownames(se)) && 
      length(assays(se)) > 0) {
    rn <- vapply(assays(se, withDimnames = FALSE), function(x) !is.null(rownames(x)), FALSE)
    if (any(rn)) {
      idx <- which(rn)[1]
      warning(
        "tidySummarizedExperiment says: the assays in your SummarizedExperiment have row names, but the SummarizedExperiment does not. Setting rownames(se) to row names of first assay with row names (assay ", idx, ")."
      )
      rownames(se) <- rownames(assays(se, withDimnames = FALSE)[[idx]])
    }
  }
  
  # If the assays as well as the SE have dimnames, but they don't overlap 
  # (they may be in different order), throw an error.
  if (!is.null(colnames(se)) &&
      length(assays(se)) > 0 && 
      !is.null(colnames(assays(se, withDimnames = FALSE)[[1]])) && 
      !all(colnames(assays(se, withDimnames = FALSE)[[1]]) %in% colnames(se))) {
    warning(
      "tidySummarizedExperiment says: the assays in your SummarizedExperiment have column names, but they don't agree with the column names of the SummarizedExperiment object itself. It is strongly recommended to make the assays consistent, to avoid erroneous matching of samples."
    )
  }
  if (!is.null(rownames(se)) &&
      length(assays(se)) > 0 && 
      !is.null(rownames(assays(se, withDimnames = FALSE)[[1]])) && 
      !all(rownames(assays(se, withDimnames = FALSE)[[1]]) %in% rownames(se))) {
    warning(
      "tidySummarizedExperiment says: the assays in your SummarizedExperiment have row names, but they don't agree with the row names of the SummarizedExperiment object itself. It is strongly recommended to make the assays consistent, to avoid erroneous matching of features."
    )
  }
  
  se
}

#' @importFrom tidyr gather
#' @importFrom dplyr rename
#' @importFrom dplyr left_join
#' @importFrom tibble as_tibble
#' @importFrom purrr reduce
#' @importFrom SummarizedExperiment assays
#' @importFrom magrittr equals
#' 
#' @noRd
get_count_datasets <- function(se) { 
  # Check that dimnames are consistent
  se <- check_se_dimnames(se)
  
  # Join assays
  list_assays = 
    map2( 
    assays(se, withDimnames = FALSE) %>% as.list(),
    names(assays(se)),
    ~ {
      
      # If the counts are in a sparse matrix convert to a matrix
      # This might happen because the user loaded tidySummarizedExperiment and is 
      # print a SingleCellExperiment
      if (is(.x, "dgCMatrix") | is(.x, "DelayedArray")) {
        .x <- as.matrix(.x) 
      }
      
      # Rearrange if assays has colnames and rownames
      if (!is.null(rownames(se)) && !is.null(rownames(.x)) && 
          all(rownames(se) %in% rownames(.x))) {
        .x = .x[rownames(se), , drop = FALSE]
      }
      if (!is.null(colnames(se)) && !is.null(colnames(.x)) && 
          all(colnames(se) %in% colnames(.x))) {
        .x = .x[, colnames(se), drop = FALSE]
      }
      
      # If I don't have assay colnames and rownames add them
      if (!is.null(rownames(se)) && is.null(rownames(.x))) rownames(.x) = rownames(se) 
      if (!is.null(colnames(se)) && is.null(colnames(.x))) colnames(.x) = colnames(se) 
      
      .x = 
        .x %>%
        # matrix() %>%
        # as.data.frame() %>% 
        
        # In case I have a sparse matrix
        as.matrix() |> 
        tibble::as_tibble(rownames = f_(se)$name, .name_repair = "minimal") %>%
        
        # If the matrix does not have sample names, fix column names
        when(colnames(.x) %>% is.null() & is.null(colnames(se)) ~ setNames(., c(
          f_(se)$name,  seq_len(ncol(.x)) 
        )),
        ~ (.)
        ) 
      
      # Avoid dug if SE if completely empty, no rows, no columns
      if(.x |> select(-!!f_(se)$symbol) |> ncol() == 0) return(.x)
      
      .x |> 
        pivot_longer(names_to = s_(se)$name, values_to = .y, cols = -!!f_(se)$symbol, cols_vary = "slowest")
      
      #%>%
      #  rename(!!.y := count)
    }) %>%
    
    # Add dummy sample or feature if we have empty assay. 
    # This is needed for a correct visualisation of the tibble form
    map(~when(
      f_(se)$name %in% colnames(.x) %>% not ~ mutate(.x, !!f_(se)$symbol := as.character(NA)),
      s_(se)$name %in% colnames(.x) %>% not ~ mutate(.x, !!s_(se)$symbol := as.character(NA)),
      ~ .x
    )) 
  
  # If assays is non empty 
  if(list_assays |> length() > 0)
    list_assays |> 
    reduce(full_join, by = c(f_(se)$name, s_(se)$name))
  
  # If assays is empty 
  else {
    
    # If I don't have row column names
    if(se |> rownames() |> is.null()) rn = nrow(se) |> seq_len() |> as.character()
    else rn = rownames(se)
    if(se |> colnames() |> is.null()) cn = ncol(se) |> seq_len() |> as.character()
    else cn = colnames(se)
    
    expand.grid(  rn, cn  ) |> 
             setNames(c(f_(se)$name, s_(se)$name)) |> 
             tibble::as_tibble()
  }
   
  
}

get_needed_columns <- function(.data) {
  c(f_(.data)$name, s_(.data)$name)
}

#' Convert array of quosure (e.g. c(col_a, col_b)) into character vector
#'
#' @keywords internal
#'
#' @importFrom rlang quo_name
#' @importFrom rlang quo_squash
#'
#' @param v A array of quosures (e.g. c(col_a, col_b))
#'
#' @return A character vector
#' 
#' @noRd
quo_names <- function(v) {
  v <- quo_name(quo_squash(v))
  gsub("^c\\(|`|\\)$", "", v) %>%
    strsplit(", ") %>%
    unlist()
}

#' @importFrom dplyr select
#' @importFrom rlang expr
#' @importFrom tidyselect eval_select
#'
#' @noRd
select_helper <- function(.data, ...) {
  loc <- tidyselect::eval_select(expr(c(...)), .data)
  
  dplyr::select(.data, loc)
}

outersect <- function(x, y) {
  sort(c(
    setdiff(x, y),
    setdiff(y, x)
  ))
}

#' @importFrom dplyr distinct_at
#' @importFrom dplyr vars
#' @importFrom purrr map
#' @importFrom magrittr equals
#' 
#' @noRd
get_subset_columns <- function(.data, .col) {
  
  # Comply with CRAN NOTES
  . <- NULL
  
  # Make col names
  .col <- enquo(.col)
  
  # x-annotation df
  n_x <- .data %>%
    distinct_at(vars(!!.col)) %>%
    nrow()
  
  # element wise columns
  .data %>%
    select(-!!.col) %>%
    colnames() %>%
    map(
      ~
        .x %>%
        when(
          .data %>%
            distinct_at(vars(!!.col, .x)) %>%
            nrow() %>%
            equals(n_x) ~ (.),
          ~NULL
        )
    ) %>%
    
    # Drop NULL
    {
      (.)[lengths((.)) != 0]
    } %>%
    unlist()
}

#' @importFrom purrr map_int
#' @importFrom purrr map
is_split_by_transcript <- function(.my_data) {
  
  se <- .my_data[[1]]
  tot_length <- .my_data %>% map(~ pull(.x, !!f_(se)$symbol) ) %>% unlist %>% unique() %>% length
  all_lengths <- .my_data %>% map_int(~ pull(.x, !!f_(se)$symbol) %>% unique() %>% length) 
  
  all_lengths %>% unique %>% length() %>% gt(1) |
    (all_lengths != tot_length) %>% any()
}

is_split_by_sample <- function(.my_data) {
  
  se <- .my_data[[1]]
  tot_length <- .my_data %>% map(~ pull(.x, !!s_(se)$symbol) ) %>% unlist %>% unique() %>% length
  all_lengths <- .my_data %>% map_int(~ pull(.x, !!s_(se)$symbol) %>% unique() %>% length) 
  
  all_lengths %>% unique %>% length() %>% gt(1) |
    (all_lengths != tot_length) %>% any()
}


get_GRanges_colnames <- function() {
  "GenomicRanges"
}


eliminate_GRanges_metadata_columns_also_present_in_Rowdata <- function(.my_data, se) {
  .my_data %>%
    select(-one_of(colnames(rowData(se)))) %>%
    
    # In case there is not metadata column
    suppressWarnings() 
}

subset_tibble_output <- function(.data, count_info, sample_info, gene_info, range_info, .subset) {
  # This function outputs a tibble after subsetting the columns
  .subset <- enquo(.subset)
  
  # Build template of the output
  output_colnames <- 
    slice(count_info, 0) %>%
    left_join(slice(sample_info, 0), by = s_(.data)$name) %>%
    left_join(slice(gene_info, 0), by = f_(.data)$name) %>%
    when(nrow(range_info) > 0 ~ (.) %>% left_join(range_info, by = f_(.data)$name), ~ (.)) %>%
    select(!!.subset) %>%
    colnames()
  
  
  # Sample table
  sample_info <- 
    sample_info %>%
    when(
      colnames(.) %>% intersect(output_colnames) %>% length() %>% equals(0) ~ NULL,
      select(., one_of(s_(.data)$name, output_colnames)) %>%
        suppressWarnings()
    )
  
  # Ranges table
  range_info <- 
    range_info %>%
    when(
      colnames(.) %>% intersect(output_colnames) %>% length() %>% equals(0) ~ NULL,
      select(., one_of(f_(.data)$name, output_colnames)) %>%
        suppressWarnings()
    )
  
  # Ranges table
  gene_info <- 
    gene_info %>%
    when(
      colnames(.) %>% intersect(output_colnames) %>% length() %>% equals(0) ~ NULL,
      select(., one_of(f_(.data)$name, output_colnames)) %>%
        suppressWarnings()
    )
  
  # Ranges table
  count_info <- 
    count_info %>%
    when(
      colnames(.) %>% intersect(output_colnames) %>% length() %>% equals(0) ~ NULL,
      select(., one_of(f_(.data)$name, s_(.data)$name, output_colnames)) %>%
        suppressWarnings()
    )
  
  if (
    !is.null(count_info) & 
    (
      !is.null(sample_info) & !is.null(gene_info) | 
      
      # Make exception for weirs cases (e.g. c(sample, counts))
      (colnames(count_info) %>% outersect(c(f_(.data)$name, s_(.data)$name)) %>% 
       length() %>% gt(0))
    )
  ) {
    output_df <- 
      count_info %>%
      when(!is.null(sample_info) ~ (.) %>% left_join(sample_info, by=s_(.data)$name), ~ (.)) %>%
      when(!is.null(gene_info) ~ (.) %>% left_join(gene_info, by=f_(.data)$name), ~ (.)) %>%
      when(!is.null(range_info) ~ (.) %>% left_join(range_info, by=f_(.data)$name), ~ (.))
  } else if (!is.null(sample_info) ) {
    output_df <- sample_info
  } else if (!is.null(gene_info)) {
    output_df <- gene_info %>%
      
      # If present join GRanges
      when(!is.null(range_info) ~ (.) %>% left_join(range_info, by=f_(.data)$name), ~ (.))
  }
  
  output_df %>%
    
    # Cleanup
    select(one_of(output_colnames)) %>%
    suppressWarnings()
}

#' @importFrom stringr str_replace
change_reserved_column_names <- function(col_data, .data) {
  
  # Fix  NOTEs
  . = NULL
  
  col_data %>%
    
    setNames(
      colnames(.) %>% 
        sapply(function(x) if (x == f_(.data)$name) sprintf("%s.x", f_(.data)$name) else x) %>% 
        sapply(function(x) if (x == s_(.data)$name) sprintf("%s.x", s_(.data)$name) else x) %>% 
        str_replace("^coordinate$", "coordinate.x")
    ) 
  
}

choose_name_if_present <- function(x) {
  columns_query <- c()
  for (i in 1:length(x)) {
    if (is.null(names(x[i]))) columns_query[i] <- x[i]
    else columns_query[i] <- names(x[i])
  }
  
  columns_query
}


get_ellipse_colnames <- function(...) {
  (enquos(..., .ignore_empty = "all") %>% map(~ quo_name(.x)) %>% unlist)
}

get_colnames_col <- function(x) {
  colnames(colData(x)) %>% 
    c(s_(x)$name) 
}

get_rownames_col <- function(x) {
  x %>%
    when(
      .hasSlot(., "rowData") | .hasSlot(., "elementMetadata") ~ colnames(rowData(.)), 
      TRUE ~ c()
    ) %>% 
    c(f_(x)$name) 
}

# This function is used for the change of special sample column to .sample
# Check if "sample" is included in the query and is not part of any other existing annotation
#' @importFrom stringr str_detect
#' @importFrom stringr regex
is_sample_feature_deprecated_used <- function(.data, user_columns, use_old_special_names = FALSE) {
  
  old_standard_is_used_for_sample <- 
    (
      ( any(str_detect(user_columns, regex("\\bsample\\b"))) & 
          !any(str_detect(user_columns, regex("\\W*(\\.sample)\\W*")))  ) |
        "sample" %in% user_columns 
    ) & 
    !"sample" %in% c(colnames(rowData(.data)), colnames(colData(.data)))
  
  old_standard_is_used_for_feature <- 
    (
      ( any(str_detect(user_columns, regex("\\bfeature\\b"))) & 
          !any(str_detect(user_columns, regex("\\W*(\\.feature)\\W*")))  ) |
        "feature" %in% user_columns 
    ) & 
    !"feature" %in% c(colnames(rowData(.data)), colnames(colData(.data)))
  
  old_standard_is_used <- old_standard_is_used_for_sample | old_standard_is_used_for_feature
  
  if (old_standard_is_used) {
    warning("tidySummarizedExperiment says: from version 1.3.1, the special columns including sample/feature id (colnames(se), rownames(se)) has changed to \".sample\" and \".feature\". This dataset is returned with the old-style vocabulary (feature and sample), however we suggest to update your workflow to reflect the new vocabulary (.feature, .sample)")
    
    use_old_special_names <- TRUE
  }
  
  use_old_special_names
}

data_frame_returned_message <- "tidySummarizedExperiment says: A data frame is returned for independent data analysis."
duplicated_cell_names <- "tidySummarizedExperiment says: This operation lead to duplicated feature names. A data frame is returned for independent data analysis."

# Key column names
#' @importFrom S4Vectors metadata
#' @importFrom S4Vectors metadata<-
ping_old_special_column_into_metadata <- function(.data) {
  
  metadata(.data)$feature__ <- get_special_column_name_symbol("feature")
  metadata(.data)$sample__ <- get_special_column_name_symbol("sample")
  
  .data
}

get_special_column_name_symbol <- function(name) {
  list(name = name, symbol = as.symbol(name))
}

# This function produce artificially the feature ans sample column, 
# to make optimisation before as_tibble is called
# for big datasets
simulate_feature_sample_from_tibble <- function(.data) {

    . <- NULL
    r <- rownames(.data) %>% .[rep(1:length(.), ncol(.data) )]
    c <- colnames(.data) %>% .[rep(1:length(.), each = nrow(.data) )]
    
    tibble(!!f_(.data)$symbol := r,  !!s_(.data)$symbol := c)
}

feature__ <- get_special_column_name_symbol(".feature")
sample__ <- get_special_column_name_symbol(".sample")

#' @importFrom S4Vectors metadata
f_ <- function(x) {
  # Check if old deprecated columns are used
  if ("feature__" %in% names(metadata(x))) feature__ = metadata(x)$feature__
  return(feature__)
}

#' @importFrom S4Vectors metadata
s_ <- function(x) {
  if ("sample__" %in% names(metadata(x))) sample__ = metadata(x)$sample__
  return(sample__)
}

split_SummarizedExperiment_by_feature_to_list <- function(.data) {
  if (nrow(.data) > 1000)
    message("tidySummarizedExperiment says: grouping a SummarizedExperiment by feature takes 1 minute for ~ 10,000 features.")
  map(1:nrow(.data), ~ .data[.x,])
}

is_filer_columns_in_column_selection <- function(.data, ...) {
  # columns = enquos(columns)
  tryCatch({
    .data |>
      slice(0) |>
      dplyr::filter(...)
    TRUE
  },
  error = function(e) FALSE)
}

check_if_assays_are_NOT_consistently_ordered <- function(se) {
  
  # If I have any assay at all
  assays(se) |> length() |> gt(0) &&
    
    # If I have more than one assay with colnames
    Filter(
      Negate(is.null),
      assays(se, withDimnames = FALSE) |>  
        as.list() |> 
        map(colnames)
    ) |> 
    length() |>
    gt(0) &&
    
    # If I have lack of consistency
    se |> 
    assays(withDimnames = FALSE) |>
    as.list() |>
    purrr::map_dfr(colnames) |>
    apply(1, function(x) x |> unique() |> length()) |>
    equals(1) |>
    all() |>  
    not()
}

check_if_any_dimnames_duplicated <- function(se, dim = "cols") {
    stopifnot(dim %in% c("rows", "cols"))
    if (dim == "rows") {
        dimnames_function <- rownames
        nbr_unique_dimnames_function <- function(x) length(unique(rownames(x)))
        length_function <- nrow
    } else {
        dimnames_function <- colnames
        nbr_unique_dimnames_function <- function(x) length(unique(colnames(x)))
        length_function <- ncol
    }
    
    # Check assays
    # If I have any assay at all
    assays_check <- assays(se) |> length() |> gt(0) &&
        
        # If I have at least one assay with dimnames
        Filter(
            Negate(is.null),
            assays(se, withDimnames = FALSE) |>  
                as.list() |> 
                map(dimnames_function)
        ) |> 
        length() |>
        gt(0) &&
        
        # If any named assay have fewer unique names than expected
        assays(se, withDimnames = FALSE) |>  
        as.list() |> 
        map(dimnames_function) |>
        Filter(Negate(is.null), x = _) |>
        map(unique) |> 
        map(length) |>
        reduce(min) |> 
        equals(length_function(se)) |> 
        not()
    
    # Check SE object
    se_check <- !is.null(dimnames_function(se)) &&
        nbr_unique_dimnames_function(se) != length_function(se)
    
    # Return TRUE if either of the two checks return TRUE
    assays_check || se_check
}

check_if_assays_are_NOT_overlapped <- function(se, dim = "cols") {

    stopifnot(dim %in% c("rows", "cols"))
    if (dim == "rows") {
        dimnames_function <- rownames
        length_function <- nrow
    } else {
        dimnames_function <- colnames
        length_function <- ncol
    }
    is_identical_for_reduce <- function(x,y) if (identical(x,y)) x else FALSE
    
    # If I have any assay at all
    assays(se) |> length() |> gt(0) &&
        
        # If I have at least one assay with dimnames
        Filter(
            Negate(is.null),
            assays(se, withDimnames = FALSE) |>  
                as.list() |> 
                map(dimnames_function)
        ) |> 
        length() |>
        gt(0) &&
        
        # If I have lack of consistency
        # This will be TRUE also if some assays have dimnames and other don't
        # For each assay, sort the dimnames, then check that they are all the 
        # same. Can't check for unique length, since some names may be repeated
        # If they're not all the same, the reduce() step will return FALSE; 
        # otherwise, returns the (shared) dimnames
        assays(se, withDimnames = FALSE) |>  
        as.list() |> 
        map(dimnames_function) |> 
        map(sort) |>
        reduce(is_identical_for_reduce) |> 
        is.logical()

}

order_assays_internally_to_be_consistent <- function(se) {
  se <- check_se_dimnames(se)
  se |> 
    assays(withDimnames = FALSE) =
    map2(
      assays(se, withDimnames = FALSE) %>% as.list(),
      names(assays(se)),
      ~ {
        if (!is.null(rownames(se)) && !is.null(rownames(.x)) && 
            all(rownames(se) %in% rownames(.x))) {
          .x = .x[rownames(se), , drop = FALSE]
        }
        if (!is.null(colnames(se)) && !is.null(colnames(.x)) && 
            all(colnames(se) %in% colnames(.x))) {
          .x = .x[, colnames(se), drop = FALSE]
        }
        .x
        
      })
  
  se
}

#' @importFrom SummarizedExperiment cbind
reduce_cbind_se <- function(se_list){
  
  do.call(cbind, se_list)
}

#' @importFrom purrr reduce
#' @importFrom purrr map
#' @importFrom SummarizedExperiment rbind
#' @importFrom SummarizedExperiment elementMetadata
#' @importFrom SummarizedExperiment elementMetadata<-
reduce_rbind_se <- function(se_list){
  
  # rbind does not accept elementMetadata so I merge and take it off
  element_metadata = se_list %>% map(elementMetadata) |> reduce(rbind)
  
  # Drop elementMetadata
  se_list = se_list |> map(~{
    elementMetadata(.x) = NULL
    .x
  })
  
  # Bind
  se = do.call(rbind, se_list)
  rm(se_list)
  
  # Put elementMetadata back in - THE (safe) ASSUMPTION IS THAT THE ORDER DOES NOT CHANGE
  elementMetadata(se)  = element_metadata
  
  # Return
  se
}


# Helper function to convert tibble back to DataFrame with rownames
DataFrame_rownames <- function(data, rownames_col = "rowname__") {
  if (rownames_col %in% colnames(data)) {
    # Extract rownames and remove the rownames column
    row_names <- data[[rownames_col]]
    data_without_rownames <- data[, colnames(data) != rownames_col, drop = FALSE]
    
    # Convert to DataFrame with rownames
    result <- DataFrame(data_without_rownames, row.names = row_names)
    return(result)
  } else {
    # No rownames column, just convert to DataFrame
    return(as(data, "DataFrame"))
  }
}

test_that("get_count_datasets works", {
    # Use testthat edition 3
    local_edition(3)
    
    # Generate test SE
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = list(
            mat1 = matrix(seq_len(9), nrow = 3),
            mat2 = matrix(seq(10, 18), nrow = 3),
            mat3 = matrix(seq(19, 27), nrow = 3)
        )
    )
    rownames(se) <- paste0("G", seq_len(3))
    colnames(se) <- paste0("S", seq_len(3))
    SummarizedExperiment::assays(se) <- lapply(
        SummarizedExperiment::assays(se),
        function(x) {
            rownames(x) <- rownames(se)
            colnames(x) <- colnames(se)
            x
        }
    )
    
    # Check that dimnames are as expected
    expect_equal(rownames(se), rownames(assay(se, "mat1", withDimnames = FALSE)))
    expect_equal(rownames(se), rownames(assay(se, "mat2", withDimnames = FALSE)))
    expect_equal(rownames(se), rownames(assay(se, "mat3", withDimnames = FALSE)))
    expect_equal(colnames(se), colnames(assay(se, "mat1", withDimnames = FALSE)))
    expect_equal(colnames(se), colnames(assay(se, "mat2", withDimnames = FALSE)))
    expect_equal(colnames(se), colnames(assay(se, "mat3", withDimnames = FALSE)))
    # Check that matrix values are as expected
    expect_equal(assay(se, "mat1")[, 1], c(1, 2, 3), ignore_attr = TRUE)
    expect_equal(assay(se, "mat2")[, 2], c(13, 14, 15), ignore_attr = TRUE)
    expect_equal(assay(se, "mat3")[, 3], c(25, 26, 27), ignore_attr = TRUE)
    
    # SE and all assays have the same dimnames
    cds <- get_count_datasets(se)
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE does not have dimnames, all assays have the same
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    expect_equal(colnames(assay(se1, "mat1", withDimnames = FALSE)), paste0("S", seq_len(3)))
    expect_equal(rownames(assay(se1, "mat1", withDimnames = FALSE)), paste0("G", seq_len(3)))
    expect_null(colnames(se1))
    expect_null(rownames(se1))
    expect_warning(expect_warning(cds <- get_count_datasets(se1), "have column names, but the SummarizedExperiment does not"), "have row names, but the SummarizedExperiment does not")
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE does not have dimnames, assays 1 and 3 have the same, assay 2 does not have
    # SE dimnames will be set to those of assay 1, then assay 2 dimnames to those of the SE
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- 
        colnames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    expect_warning(expect_warning(expect_warning(expect_warning(cds <- get_count_datasets(se1), "at least one of the assays in your SummarizedExperiment have column names"))))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE does not have dimnames, assays 2 and 3 have the same, assay 1 does not have
    # SE dimnames will be set to those of assay 2, then assay 1 dimnames to those of the SE
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    rownames(assay(se1, "mat1", withDimnames = FALSE)) <- 
        colnames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    expect_warning(expect_warning(expect_warning(expect_warning(cds <- get_count_datasets(se1), "at least one of the assays in your SummarizedExperiment have column names"))))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE does not have dimnames, assays have the same but in different order
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- c("S2", "S3", "S1")
    rownames(assay(se1, "mat3", withDimnames = FALSE)) <- c("G2", "G3", "G1")
    expect_warning(expect_warning(cds <- get_count_datasets(se1)))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, c(16, 17, 18, 10, 11, 12, 13, 14, 15))
    expect_equal(cds$mat3, c(21, 19, 20, 24, 22, 23, 27, 25, 26))
    
    # SE does not have dimnames, assays have nonoverlapping dimnames
    ## ...rownames
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- paste0("A", seq_len(3))
    expect_warning(expect_warning(expect_warning(cds <- get_count_datasets(se1), "at least one of the assays in your SummarizedExperiment have row names")))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 18L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, c(rep(paste0("G", seq_len(3)), 3), 
                                 rep(paste0("A", seq_len(3)), 3)))
    expect_equal(cds$.sample, rep(rep(paste0("S", seq_len(3)), each = 3), 2))
    expect_equal(cds$mat1, c(seq(1, 9), rep(NA, 9)))
    expect_equal(cds$mat2, c(rep(NA, 9), seq(10, 18)))
    expect_equal(cds$mat3, c(seq(19, 27), rep(NA, 9)))
    
    ## ...colnames
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- paste0("A", seq_len(3))
    expect_warning(expect_warning(expect_warning(cds <- get_count_datasets(se1), "at least one of the assays in your SummarizedExperiment have column names")))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 18L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(rep(paste0("G", seq_len(3)), 3), 2))
    expect_equal(cds$.sample, c(rep(paste0("S", seq_len(3)), each = 3),
                                rep(paste0("A", seq_len(3)), each = 3)))
    expect_equal(cds$mat1, c(seq(1, 9), rep(NA, 9)))
    expect_equal(cds$mat2, c(rep(NA, 9), seq(10, 18)))
    expect_equal(cds$mat3, c(seq(19, 27), rep(NA, 9)))
    
    # Neither SE nor assays have column names
    se1 <- se
    colnames(se1) <- NULL
    colnames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    cds <- get_count_datasets(se1)
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(as.character(seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # Neither SE nor assays have row names
    se1 <- se
    rownames(se1) <- NULL
    rownames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    cds <- get_count_datasets(se1)
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(as.character(seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # Neither SE nor assays have any dimnames
    se1 <- se
    rownames(se1) <- NULL
    colnames(se1) <- NULL
    rownames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    cds <- get_count_datasets(se1)
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(as.character(seq_len(3)), 3))
    expect_equal(cds$.sample, rep(as.character(seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE has dimnames, assays have the same dimnames but not overlapping with those of the SE
    se1 <- se
    rownames(se1) <- colnames(se1) <- paste0("A", seq_len(3))
    expect_warning(expect_warning(cds <- get_count_datasets(se1), "don't agree with the column names of the SummarizedExperiment"))
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    se1 <- se
    rownames(se1) <- paste0("A", seq_len(3))
    expect_warning(cds <- get_count_datasets(se1), "don't agree with the row names of the SummarizedExperiment")
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE has dimnames, none of the assays have
    se1 <- se
    rownames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat1", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    rownames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    colnames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    cds <- get_count_datasets(se1)
    expect_s3_class(cds, "tbl_df")
    expect_equal(nrow(cds), 9L)
    expect_equal(ncol(cds), 5L)
    expect_named(cds, c(".feature", ".sample", "mat1", "mat2", "mat3"))
    expect_equal(cds$.feature, rep(paste0("G", seq_len(3)), 3))
    expect_equal(cds$.sample, rep(paste0("S", seq_len(3)), each = 3))
    expect_equal(cds$mat1, seq(1, 9))
    expect_equal(cds$mat2, seq(10, 18))
    expect_equal(cds$mat3, seq(19, 27))
    
    # SE does not have dimnames, one assay has duplicated colnames, one has no colnames
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    colnames(assay(se1, "mat1", withDimnames = FALSE))[2] <- 
        colnames(assay(se1, "mat1", withDimnames = FALSE))[1]
    colnames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    expect_equal(colnames(assay(se1, "mat1", withDimnames = FALSE)), paste0("S", c(1, 1, 3)))
    expect_equal(rownames(assay(se1, "mat1", withDimnames = FALSE)), paste0("G", seq_len(3)))
    expect_null(colnames(assay(se1, "mat2", withDimnames = FALSE)))
    expect_equal(colnames(assay(se1, "mat3", withDimnames = FALSE)), paste0("S", seq_len(3)))
    expect_null(colnames(se1))
    expect_null(rownames(se1))
    expect_error(cds <- get_count_datasets(se1), "some column names are duplicated")
    
    # SE does not have dimnames, one assay has duplicated rownames, one has no rownames
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    rownames(assay(se1, "mat1", withDimnames = FALSE))[2:3] <- 
        rownames(assay(se1, "mat1", withDimnames = FALSE))[1]
    rownames(assay(se1, "mat2", withDimnames = FALSE)) <- NULL
    expect_equal(rownames(assay(se1, "mat1", withDimnames = FALSE)), paste0("G", c(1, 1, 1)))
    expect_equal(colnames(assay(se1, "mat1", withDimnames = FALSE)), paste0("S", seq_len(3)))
    expect_null(rownames(assay(se1, "mat2", withDimnames = FALSE)))
    expect_equal(rownames(assay(se1, "mat3", withDimnames = FALSE)), paste0("G", seq_len(3)))
    expect_null(colnames(se1))
    expect_null(rownames(se1))
    expect_error(cds <- get_count_datasets(se1), "some row names are duplicated")
    
    # SE has duplicated colnames
    se1 <- se
    colnames(se1) <- paste0("S", c(1, 1, 1))
    expect_error(cds <- get_count_datasets(se1), "some column names are duplicated")
    expect_true(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    
    # SE has duplicated rownames
    se1 <- se
    rownames(se1) <- paste0("G", c(1, 2, 1))
    expect_error(cds <- get_count_datasets(se1), "some row names are duplicated")
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_true(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    
    # All assays + SE have duplicated colnames
    se1 <- se
    colnames(se1)[2] <- 
        colnames(assay(se1, "mat1", withDimnames = FALSE))[2] <- 
        colnames(assay(se1, "mat2", withDimnames = FALSE))[2] <- 
        colnames(assay(se1, "mat3", withDimnames = FALSE))[2] <- "S1"
    expect_true(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    expect_false(check_if_assays_are_NOT_overlapped(se1, dim = "cols"))
    expect_false(check_if_assays_are_NOT_overlapped(se1, dim = "rows"))
    
    # Two assays + SE have duplicated colnames
    se1 <- se
    colnames(se1)[2] <- 
        colnames(assay(se1, "mat1", withDimnames = FALSE))[2] <- 
        colnames(assay(se1, "mat3", withDimnames = FALSE))[2] <- "S1"
    expect_true(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    expect_true(check_if_assays_are_NOT_overlapped(se1, dim = "cols"))
    expect_false(check_if_assays_are_NOT_overlapped(se1, dim = "rows"))
    
    # Assays have duplicated colnames in different ways
    se1 <- se
    assay(se1, "mat2") <- NULL
    colnames(assay(se1, "mat1", withDimnames = FALSE)) <- c("S1", "S1", "S2")
    colnames(assay(se1, "mat3", withDimnames = FALSE)) <- c("S1", "S2", "S2")
    expect_true(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    expect_true(check_if_assays_are_NOT_overlapped(se1, dim = "cols"))
    expect_false(check_if_assays_are_NOT_overlapped(se1, dim = "rows"))

    # All dimnames are NULL - not duplicated
    se1 <- se
    rownames(se1) <- colnames(se1) <- NULL
    rownames(assay(se1, "mat1", withDimnames = FALSE)) <- 
        colnames(assay(se1, "mat1", withDimnames = FALSE)) <- 
        rownames(assay(se1, "mat2", withDimnames = FALSE)) <- 
        colnames(assay(se1, "mat2", withDimnames = FALSE)) <- 
        rownames(assay(se1, "mat3", withDimnames = FALSE)) <- 
        colnames(assay(se1, "mat3", withDimnames = FALSE)) <- NULL
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "cols"))
    expect_false(check_if_any_dimnames_duplicated(se1, dim = "rows"))
    
    # Unnamed assay(s)
    # se1 <- SummarizedExperiment::SummarizedExperiment(
    #     assays = list(
    #         matrix(seq_len(9), nrow = 3),
    #         mat2 = matrix(seq(10, 18), nrow = 3),
    #         matrix(seq(19, 27), nrow = 3)
    #     )
    # )
    # expect_error(cds <- get_count_datasets(se1), "assays must be named")
    # 
    # se1 <- SummarizedExperiment::SummarizedExperiment(
    #     assays = list(
    #         matrix(seq_len(9), nrow = 3),
    #         matrix(seq(10, 18), nrow = 3),
    #         matrix(seq(19, 27), nrow = 3)
    #     )
    # )
    # expect_error(cds <- get_count_datasets(se1), "assays must be named")
})

context("dplyr test")

library(tidySummarizedExperiment)


test_that("append_samples", {
    pasilla_bind <- append_samples(pasilla, pasilla)

    # Check that the combined object has the expected number of samples
    expect_equal(ncol(pasilla_bind), ncol(pasilla) * 2)
    
    # Check that it's still a SummarizedExperiment
    expect_true(inherits(pasilla_bind, "SummarizedExperiment"))
})

test_that("distinct", {
    pasilla %>%
        distinct(condition) %>%
        ncol() %>%
        expect_equal(1)
})

test_that("filter", {
    pasilla %>%
        filter(condition == "untreated") %>%
        nrow() %>%
        expect_equal(14599)
})

test_that("group_by", {
    pasilla %>%
        group_by(condition) %>%
        ncol() %>%
        expect_equal(5)
})

test_that("summarise", {
    pasilla %>%
        summarise(mean(counts)) %>%
        nrow() %>%
        expect_equal(1)
})

test_that("mutate", {
    pasilla %>%
        mutate(condition = 1) %>%
        distinct(condition) %>%
        nrow() %>%
        expect_equal(1)
})

test_that("rename", {
    pasilla %>%
        rename(groups = condition, type_2 = type) %>%
        select(groups) %>%
        ncol() %>%
        expect_equal(1)
})



test_that("slice", {
    pasilla %>%
        slice(1) %>%
        ncol() %>%
        expect_equal(1)
})

test_that("select", {
    pasilla %>%
        select(-condition) %>%
        class() %>%
        as.character() %>%
        expect_equal("SummarizedExperiment")

    pasilla %>%
        select(condition) %>%
        class() %>%
        as.character() %>%
        .[1] %>%
        expect_equal("tbl_df")
})

test_that("sample_n", {
    pasilla %>%
        sample_n(50) %>%
        nrow() %>%
        expect_equal(50)
})

test_that("sample_frac", {
    pasilla %>%
        sample_frac(0.1) %>%
        nrow() %>%
        expect_equal(10219)
})

test_that("count", {
    pasilla %>%
        count(condition) %>%
        nrow() %>%
        expect_equal(2)
})


test_that("mutate counts", {
  
  se = tidySummarizedExperiment::pasilla |> mutate(counts_2 = counts) 

  se |> 
    pull(counts) |> 
    expect_equal(
      se |> pull(counts_2)
    )
  
  se = tidySummarizedExperiment::pasilla 
  assays(se, withDimnames = FALSE)$counts_2 = assays(se)$counts[,7:1]
  
  se |> 
    pull(counts) |> 
    expect_equal(
      se |> pull(counts_2)
    )
  
  se |> 
  tidySummarizedExperiment:::check_if_assays_are_NOT_overlapped(dim = "cols") |> 
    expect_equal(FALSE)
  
  se[,1] |> 
    tidySummarizedExperiment:::check_if_assays_are_NOT_overlapped(dim = "cols") |> 
    expect_equal(TRUE)
  
  })

test_that("group_split splits character columns", {
  data(pasilla)
  pasilla |> 
    group_split(condition) |> 
    length() |> 
    expect_equal(2)
})

test_that("group_split splits logical comparisons", {
  data(pasilla)
  pasilla |> 
    group_split(counts > 0) |> 
    length() |> 
    expect_equal(2)
})

test_that("group_split splits with mutliple arguments", {
  data(pasilla)
  pasilla |> 
    group_split(condition, counts > 0) |> 
    length() |> 
    expect_equal(4)
})

#' Analyze query complexity to determine analysis strategy
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param dots List of quosures from mutate expressions
#' @return List with is_simple (logical) and complexity_reasons (character vector)
#' @noRd
analyze_query_complexity <- function(se, dots) {
  
  complexity_reasons <- character(0)
  
  # Check for complex expressions
  for (i in seq_along(dots)) {
    expr_text <- rlang::quo_text(dots[[i]])
    
    # Simple assignment from existing column (variable name only)
    if (grepl("^[a-zA-Z][a-zA-Z0-9_\\.]*$", expr_text)) {
      next  # Simple column reference
    }
    
    # Simple arithmetic with constants
    if (grepl("^[a-zA-Z][a-zA-Z0-9_\\.]*\\s*[+\\-\\*/]\\s*[0-9.]+$", expr_text)) {
      next  # Simple arithmetic
    }
    
    # Simple function calls that are likely fast
    simple_functions <- c("log", "log2", "log10", "sqrt", "abs", "round", "ceiling", "floor",
                         "toupper", "tolower", "paste0", "paste", "as.character", "as.numeric")
    simple_pattern <- paste0("^(", paste(simple_functions, collapse = "|"), ")\\(")
    
    if (grepl(simple_pattern, expr_text)) {
      next  # Simple function call
    }
    
    # Check for complexity indicators
    if (grepl("ifelse|case_when|switch", expr_text)) {
      complexity_reasons <- c(complexity_reasons, "conditional_logic")
    }
    
    if (grepl("sum\\(|mean\\(|median\\(|max\\(|min\\(|sd\\(|var\\(", expr_text)) {
      complexity_reasons <- c(complexity_reasons, "aggregation_functions")
    }
    
    if (grepl("group_by|summarise|summarize", expr_text)) {
      complexity_reasons <- c(complexity_reasons, "grouping_operations")
    }
    
    if (grepl("\\[|\\$", expr_text)) {
      complexity_reasons <- c(complexity_reasons, "subsetting_operations")
    }
    
    # Long expressions (likely complex)
    if (nchar(expr_text) > 100) {
      complexity_reasons <- c(complexity_reasons, "long_expression")
    }
  }
  
  is_simple <- length(complexity_reasons) == 0
  
  return(list(
    is_simple = is_simple,
    complexity_reasons = complexity_reasons
  ))
}



#' Analyze expression dependencies to detect mixed scope operations
#'
#' This function examines the variables referenced in mutate expressions
#' to determine if they span multiple data types (assays, colData, rowData).
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param dots List of quosures from mutate expressions
#' @return List with dependency analysis results
#' @noRd
analyze_expression_dependencies <- function(se, dots) {
  
  # Get available column names from each data type
  coldata_cols <- colnames(colData(se))
  rowdata_cols <- if (.hasSlot(se, "rowData") || .hasSlot(se, "elementMetadata")) {
    colnames(rowData(se))
  } else {
    character(0)
  }
  assay_cols <- assayNames(se)
  
  # Analyze each expression
  expression_deps <- list()
  
  for (i in seq_along(dots)) {
    expr_name <- names(dots)[i]
    if (is.null(expr_name) || expr_name == "") {
      expr_name <- paste0("expr_", i)
    }
    
    # Extract variable names from the expression
    expr_text <- rlang::quo_text(dots[[i]])
    
    # Find which variables are referenced
    # Use a simple approach: check which column names appear as whole words
    uses_coldata <- if (length(coldata_cols) > 0) {
      any(sapply(coldata_cols, function(col) {
        grepl(paste0("\\b", col, "\\b"), expr_text)
      }, USE.NAMES = FALSE))
    } else {
      FALSE
    }
    
    uses_rowdata <- if (length(rowdata_cols) > 0) {
      any(sapply(rowdata_cols, function(col) {
        grepl(paste0("\\b", col, "\\b"), expr_text)
      }, USE.NAMES = FALSE))
    } else {
      FALSE
    }
    
    uses_assays <- if (length(assay_cols) > 0) {
      any(sapply(assay_cols, function(col) {
        grepl(paste0("\\b", col, "\\b"), expr_text)
      }, USE.NAMES = FALSE))
    } else {
      FALSE
    }
    
    # Count dependency types
    n_dep_types <- sum(uses_coldata, uses_rowdata, uses_assays)
    
    # Determine scope for this expression
    expr_scope <- if (n_dep_types == 0) {
      "unknown"
    } else if (n_dep_types == 1) {
      if (uses_coldata) "coldata_only"
      else if (uses_rowdata) "rowdata_only"
      else "assay_only"
    } else {
      "mixed"
    }
    
    expression_deps[[expr_name]] <- list(
      scope = expr_scope,
      uses_coldata = uses_coldata,
      uses_rowdata = uses_rowdata,
      uses_assays = uses_assays,
      expression_text = expr_text,
      referenced_coldata = if (length(coldata_cols) > 0) coldata_cols[sapply(coldata_cols, function(col) grepl(paste0("\\b", col, "\\b"), expr_text), USE.NAMES = FALSE)] else character(0),
      referenced_rowdata = if (length(rowdata_cols) > 0) rowdata_cols[sapply(rowdata_cols, function(col) grepl(paste0("\\b", col, "\\b"), expr_text), USE.NAMES = FALSE)] else character(0),
      referenced_assays = if (length(assay_cols) > 0) assay_cols[sapply(assay_cols, function(col) grepl(paste0("\\b", col, "\\b"), expr_text), USE.NAMES = FALSE)] else character(0)
    )
  }
  
  # Determine overall scope based on all expressions
  all_scopes <- sapply(expression_deps, function(x) x$scope)
  has_mixed <- any(all_scopes == "mixed")
  unique_scopes <- unique(all_scopes[all_scopes != "unknown"])
  
  overall_scope <- if (has_mixed || length(unique_scopes) > 1) {
    "mixed"
  } else if (length(unique_scopes) == 1) {
    unique_scopes[1]
  } else {
    "unknown"
  }
  
  return(list(
    overall_scope = overall_scope,
    expression_dependencies = expression_deps,
    analysis_method = "dependency_analysis",
    confidence = "high"
  ))
}

#' Analyze query scope by running on a subset of the data
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param dots List of quosures from mutate expressions
#' @return Analysis result similar to other analyze functions
#' @noRd
analyze_query_scope_subset <- function(se, dots) {
  
  # Create a small subset for fast analysis
  # Take first few rows and columns to keep it fast
  n_rows <- min(10, nrow(se))
  n_cols <- min(5, ncol(se))
  
  if (n_rows == 0 || n_cols == 0) {
    # Empty SE - cannot analyze
    return(list(
      scope = "unknown",
      targets_coldata = FALSE,
      targets_rowdata = FALSE,
      targets_assays = FALSE,
      new_coldata_cols = character(0),
      new_rowdata_cols = character(0),
      new_assay_cols = character(0),
      analysis_method = "subset_analysis",
      confidence = "low"
    ))
  }
  
  se_subset <- se[1:n_rows, 1:n_cols]
  
  # Convert to tibble and try the mutate operation
  tryCatch({
    # Convert subset to tibble
    tibble_subset <- se_subset %>% as_tibble()
    
    # Apply mutate expressions
    mutated_subset <- tibble_subset %>% dplyr::mutate(!!!dots)
    
    # Extract column names that were created/modified
    .cols <- names(dots)
    
    # Use post-operation analysis on the result
    result <- analyze_query_scope_post_operation(se_subset, .cols, mutated_subset, "mutate")
    result$analysis_method <- "subset_analysis"
    result$confidence <- "medium"  # Medium confidence due to subset
    
    return(result)
    
  }, error = function(e) {
    # If mutate fails on subset, return unknown
    return(list(
      scope = "unknown",
      targets_coldata = FALSE,
      targets_rowdata = FALSE,
      targets_assays = FALSE,
      new_coldata_cols = character(0),
      new_rowdata_cols = character(0),
      new_assay_cols = character(0),
      analysis_method = "subset_analysis",
      confidence = "low",
      error_message = as.character(e$message)
    ))
  })
}


#' Pre-mutate analysis: Analyze query scope based on column names only
#'
#' @keywords internal
#' @noRd
analyze_query_scope_pre_mutate <- function(se, .cols) {
  
  # Get existing column categories
  existing_coldata_cols <- colnames(colData(se))
  existing_rowdata_cols <- if (.hasSlot(se, "rowData") || .hasSlot(se, "elementMetadata")) {
    colnames(rowData(se))
  } else {
    c()
  }
  existing_assay_cols <- names(assays(se))
  
  # Analyze which existing categories are being modified
  modifies_coldata <- any(.cols %in% existing_coldata_cols)
  modifies_rowdata <- any(.cols %in% existing_rowdata_cols)
  modifies_assays <- any(.cols %in% existing_assay_cols)
  
  # Count modifications
  n_modifications <- sum(modifies_coldata, modifies_rowdata, modifies_assays)
  
  # For new columns, we cannot reliably determine their target without actual data
  new_cols <- setdiff(.cols, c(existing_coldata_cols, existing_rowdata_cols, existing_assay_cols))
  
  # We can only be certain about existing columns being modified
  # New columns are ambiguous without seeing the actual data
  ambiguous_cols <- new_cols
  
  # Determine scope - only based on existing column modifications
  targets_coldata <- modifies_coldata
  targets_rowdata <- modifies_rowdata  
  targets_assays <- modifies_assays
  
  # Count target types
  n_targets <- sum(targets_coldata, targets_rowdata, targets_assays)
  
  scope <- if (n_targets == 0 && length(ambiguous_cols) > 0) {
    "unknown"
  } else if (n_targets == 1) {
    if (targets_coldata) "coldata_only"
    else if (targets_rowdata) "rowdata_only"
    else "assay_only"
  } else if (n_targets > 1) {
    "mixed"
  } else {
    "unknown"
  }
  
  return(list(
    scope = scope,
    targets_coldata = targets_coldata,
    targets_rowdata = targets_rowdata,
    targets_assays = targets_assays,
    new_coldata_cols = character(0),  # Cannot determine without actual data
    new_rowdata_cols = character(0),  # Cannot determine without actual data
    new_assay_cols = character(0),    # Cannot determine without actual data
    ambiguous_cols = ambiguous_cols,
    analysis_method = "pre_mutate",
    confidence = if (length(ambiguous_cols) == 0) "high" else "low"
  ))
}

#' Analyze query scope based on modified tibble (works for any dplyr operation)
#'
#' This function can analyze the scope of any dplyr operation that modifies
#' columns by comparing the original SE with the resulting tibble.
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param .cols Character vector of column names that were modified/created
#' @param .data_modified The resulting tibble after dplyr operation
#' @param operation Character indicating the operation type (for documentation)
#' @noRd
analyze_query_scope_post_operation <- function(se, .cols, .data_modified, operation = "unknown") {
  
  # Use the existing functions to classify columns
  col_data <- extract_col_data(.data_modified, se)
  row_data <- extract_row_data(.data_modified, se, col_data = col_data)
  colnames_assay <- extract_assay_colnames(.data_modified, se, col_data, row_data)
  
  # Identify which of the specified columns fall into each category
  new_coldata_cols <- intersect(.cols, colnames(col_data))
  new_rowdata_cols <- intersect(.cols, colnames(row_data))
  new_assay_cols <- intersect(.cols, colnames_assay)
  
  # Determine targets
  targets_coldata <- length(new_coldata_cols) > 0
  targets_rowdata <- length(new_rowdata_cols) > 0
  targets_assays <- length(new_assay_cols) > 0
  
  # Count target types
  n_targets <- sum(targets_coldata, targets_rowdata, targets_assays)
  
  # Determine scope
  scope <- if (n_targets == 0) {
    "unknown"
  } else if (n_targets == 1) {
    if (targets_coldata) "coldata_only"
    else if (targets_rowdata) "rowdata_only"
    else "assay_only"
  } else {
    "mixed"
  }
  
  return(list(
    scope = scope,
    targets_coldata = targets_coldata,
    targets_rowdata = targets_rowdata,
    targets_assays = targets_assays,
    new_coldata_cols = new_coldata_cols,
    new_rowdata_cols = new_rowdata_cols,
    new_assay_cols = new_assay_cols,
    analysis_method = paste0("post_", operation),
    operation = operation,
    confidence = "high"
  ))
}




#' Apply any dplyr operation to feature metadata (rowData)
#'
#' This is a general function that allows applying any dplyr operation
#' directly to the rowData of a SummarizedExperiment object, providing
#' better performance when operations only target feature metadata.
#'
#' @param .data A SummarizedExperiment object
#' @param operation Character string specifying the dplyr operation (e.g., "mutate", "filter", "select")
#' @param ... Arguments passed to the specified dplyr operation
#'
#' @return A SummarizedExperiment with modified rowData
#'
#' @examples
#' \dontrun{
#' library(airway)
#' data(airway)
#' 
#' # Mutate operation on features
#' modify_features(airway, "mutate", gene_length_kb = gene_length / 1000)
#' 
#' # Filter operation on features  
#' modify_features(airway, "filter", gene_biotype == "protein_coding")
#' 
#' # Select operation on features
#' modify_features(airway, "select", gene_name, gene_biotype)
#' 
#' # Arrange operation on features
#' modify_features(airway, "arrange", gene_name)
#' }
#'
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#'
#' @noRd
modify_features <- function(.data, operation, ...) {
  
  # Get the dplyr function
  dplyr_fn <- get(operation, envir = asNamespace("dplyr"))
  
  # Apply the operation to rowData
  modified_rowdata <- rowData(.data) |>
    tibble::as_tibble(rownames = "rowname__") |>
    dplyr_fn(...) |>
    DataFrame_rownames()
  
  # Handle operations that might change the number of features
  if (operation %in% c("filter", "slice", "sample_n", "sample_frac", "distinct")) {
    # These operations can change the number of rows
    # We need to subset the entire SE object accordingly
    
    # Get the row indices that remain after the operation
    original_rowdata <- rowData(.data) |> tibble::as_tibble(rownames = "rowname__")
    original_rowdata$.original_index <- seq_len(nrow(original_rowdata))
    
    filtered_with_index <- original_rowdata |>
      dplyr_fn(...) 
    
    # Subset the entire SE object (works for zero or more features)
    remaining_indices <- filtered_with_index$.original_index
    result_se <- .data[remaining_indices, ]
    
    # Update rowData with the modified version (without the index column)
    rowData(result_se) <- filtered_with_index |>
      dplyr::select(-.original_index) |>
      DataFrame_rownames()
    
    return(result_se)
    
  } else {
    # Operations that don't change the number of features
    rowData(.data) <- modified_rowdata
    return(.data)
  }
}

#' Apply any dplyr operation to sample metadata (colData)
#'
#' This is a general function that allows applying any dplyr operation
#' directly to the colData of a SummarizedExperiment object, providing
#' better performance when operations only target sample metadata.
#'
#' @param .data A SummarizedExperiment object
#' @param operation Character string specifying the dplyr operation (e.g., "mutate", "filter", "select")
#' @param ... Arguments passed to the specified dplyr operation
#'
#' @return A SummarizedExperiment with modified colData
#'
#' @examples
#' \dontrun{
#' library(airway)
#' data(airway)
#' 
#' # Mutate operation on samples
#' modify_samples(airway, "mutate", new_dex = paste0("treatment_", dex))
#' 
#' # Filter operation on samples  
#' modify_samples(airway, "filter", dex == "trt")
#' 
#' # Select operation on samples
#' modify_samples(airway, "select", dex, cell)
#' 
#' # Arrange operation on samples
#' modify_samples(airway, "arrange", dex, cell)
#' }
#'
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#'
#' @noRd
modify_samples <- function(.data, operation, ...) {
  
  # Get the dplyr function
  dplyr_fn <- get(operation, envir = asNamespace("dplyr"))
  
  # Apply the operation to colData
  modified_coldata <- colData(.data) |>
    tibble::as_tibble(rownames = "rowname__") |>
    dplyr_fn(...) |>
    DataFrame_rownames()
  
  # Handle operations that might change the number of samples
  if (operation %in% c("filter", "slice", "sample_n", "sample_frac", "distinct")) {
    # These operations can change the number of rows
    # We need to subset the entire SE object accordingly
    
    # Get the row indices that remain after the operation
    original_coldata <- colData(.data) |> tibble::as_tibble(rownames = "rowname__")
    original_coldata$.original_index <- seq_len(nrow(original_coldata))
    
    filtered_with_index <- original_coldata |>
      dplyr_fn(...) 
    
    # Subset the entire SE object (works for zero or more samples)
    remaining_indices <- filtered_with_index$.original_index
    result_se <- .data[, remaining_indices]
    
    # Update colData with the modified version (without the index column)
    colData(result_se) <- filtered_with_index |>
      dplyr::select(-.original_index) |>
      DataFrame_rownames() 

    
    return(result_se)
    
  } else {
    # Operations that don't change the number of samples
    colData(.data) <- modified_coldata
    return(.data)
  }
}

#' @name bind_rows
#' @rdname bind_rows
#' @inherit ttservice::bind_rows
#' @param add.cell.ids Appends the corresponding values to
#' @importFrom rlang dots_values
#' @importFrom tidyselect all_of
#' @importFrom rlang flatten_if
#' @importFrom rlang is_spliced
#' @importFrom SummarizedExperiment cbind
#' @importFrom SummarizedExperiment assays
#' @importFrom SummarizedExperiment assays<-
#' @importFrom S4Vectors SimpleList
#' @importFrom ttservice bind_rows
#' @importFrom lifecycle deprecate_warn
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
bind_rows.SummarizedExperiment <- function(..., .id=NULL, add.cell.ids=NULL) {
    lifecycle::deprecate_warn(
        when = "1.19.5",
        what = "bind_rows()",
        with = "append_samples()",
        details = "bind_rows is not a generic method in dplyr and may cause conflicts. Use append_samples from ttservice instead."
    )
    tts <- flatten_if(dots_values(...), is_spliced)

    new_obj <- 
        tts %>%
            when(
                is_split_by_sample(.) & is_split_by_transcript(.) ~ 
                    stop("tidySummarizedExperiment says:",
                        " bind_rows cannot be applied to splits both by",
                        " sample- and feature-wise information"),
                is_split_by_sample(.) ~ cbind(.[[1]], .[[2]]) ,
                is_split_by_transcript(.) ~ rbind(.[[1]], .[[2]]),
            
                # If there is not split, then bind the samples
                ~ cbind(.[[1]], .[[2]])
            )
    

    # If duplicated sample names
    if (new_obj |> colnames() |> duplicated() |> which() |> length() |> gt(0)) {
        warning("tidySummarizedExperiment says:",
            " you have duplicated sample names, they will be made unique.")
    }
    unique_colnames <- make.unique(colnames(new_obj), sep="_")

    colnames(new_obj) <- unique_colnames

    # Change also all assays colnames
    assays(new_obj) <- assays(new_obj)@listData |> map(~ {
        colnames(.x) <- unique_colnames
        .x
    }) |> 
        SimpleList()

    new_obj
}

#' @name append_samples
#' @rdname append_samples
#' @title Append samples from multiple SummarizedExperiment objects
#' 
#' @description
#' Append samples from multiple SummarizedExperiment objects by column-binding them.
#' This function is equivalent to `cbind` but provides a tidyverse-like interface.
#' 
#' @param x First SummarizedExperiment object to combine
#' @param ... Additional SummarizedExperiment objects to combine by samples
#' @param .id Object identifier (currently not used)
#' 
#' @return A combined SummarizedExperiment object
#' 
#' @examples
#' data(se)
#' append_samples(se, se)
#' 
#' @importFrom ttservice append_samples
#' @importFrom rlang dots_values
#' @importFrom rlang flatten_if
#' @importFrom rlang is_spliced
#' @importFrom SummarizedExperiment cbind
#' @importFrom SummarizedExperiment assays
#' @importFrom SummarizedExperiment assays<-
#' @importFrom S4Vectors SimpleList
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
append_samples.SummarizedExperiment <- function(x, ..., .id = NULL) {
    # Combine all arguments into a list
    tts <- flatten_if(list(x, ...), is_spliced)
    new_obj <- do.call(cbind, tts)

    # If duplicated sample names
    if (any(duplicated(colnames(new_obj)))) {
        warning("tidySummarizedExperiment says:",
                " you have duplicated sample names, they will be made unique.")
        unique_colnames <- make.unique(colnames(new_obj), sep = "_")
        colnames(new_obj) <- unique_colnames

        # Change also all assays colnames
        assays(new_obj) <- assays(new_obj)@listData |> lapply(function(.x) {
            colnames(.x) <- unique_colnames
            .x
        }) |> SimpleList()
    }

    new_obj
}

#' @importFrom rlang flatten_if
#' @importFrom rlang is_spliced
#' @importFrom rlang dots_values
#' @importFrom ttservice bind_cols
bind_cols_internal <- function(..., .id=NULL, column_belonging=NULL) {
    tts <- tts <- flatten_if(dots_values(...), is_spliced)


    # If I have column corresponding bind directly
    # Without tranformation to tibble
    if(!is.null(column_belonging)){
      
      # For colData
      colData_additions = column_belonging[column_belonging==s_(tts[[1]] )$name] |> names()
      
      data_frame_to_attach = 
        tts[[1]] |> 
        select(!!s_(tts[[1]] )$symbol) |> 
        suppressMessages() |> 
        bind_cols(tts[[2]] |> select(all_of(colData_additions))) |> 
        distinct() 
      
      # Set row names
      data_frame_to_attach = 
        data_frame_to_attach |> 
        select(-1) |> 
        DataFrame(row.names = data_frame_to_attach |> pull(1)) 
      
      # Reorder
      data_frame_to_attach = data_frame_to_attach[match(rownames(data_frame_to_attach), colnames(tts[[1]])), , drop=FALSE]
      
      # Attach
      colData(tts[[1]]) = cbind(colData(tts[[1]]), data_frame_to_attach)
      
      # For rowData
      rowData_additions = column_belonging[column_belonging==f_(tts[[1]] )$name] |> names()
      
      data_frame_to_attach = 
        tts[[1]] |> 
        select(!!f_(tts[[1]] )$symbol) |> 
        suppressMessages() |> 
        bind_cols(tts[[2]] |> select(all_of(rowData_additions))) |> 
        distinct() 
      
      # Set row names
      data_frame_to_attach = 
        data_frame_to_attach |> 
        select(-1) |> 
        DataFrame(row.names = data_frame_to_attach |> pull(1)) 
      
      # Reorder
      data_frame_to_attach = data_frame_to_attach[match(rownames(data_frame_to_attach), rownames(tts[[1]])), , drop=FALSE]
      
      # Attach
      rowData(tts[[1]]) = cbind(rowData(tts[[1]]), data_frame_to_attach)
      
      tts[[1]]
    }
    
    # If I DON'T have column corresponding go through tibble
    else
      tts[[1]] |> 
          as_tibble(skip_GRanges = TRUE) |>
          dplyr::bind_cols(tts[[2]], .id=.id) %>%
          when(
  
              # If the column added are not sample-wise or feature-wise return tibble
              (colnames(tts[[2]]) %in% c(
                  get_subset_columns(., !!s_(tts[[1]])$symbol),
                  get_subset_columns(., !!f_(tts[[1]])$symbol)
              )
              ) |> all() ~ update_SE_from_tibble(., tts[[1]], column_belonging = column_belonging),
  
              # Return tiblle
              ~ {
                warning("tidySummarizedExperiment says:",
                        " The new columns do not include pure sample-wise",
                        " or feature-wise. A data frame is returned for",
                        " independent data analysis.")
                (.)
              }
          )

}

bind_cols_ <- function(..., .id=NULL) { bind_cols_internal(..., .id=NULL) }

#' @rdname bind_rows
#' @aliases bind_cols
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
bind_cols.SummarizedExperiment <- bind_cols_

#' @rdname bind_rows
#' @aliases bind_cols
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' @export
bind_cols.RangedSummarizedExperiment <- bind_cols_

#' @name distinct
#' @rdname distinct
#' @inherit dplyr::distinct
#'
#' @examples
#' data(pasilla)
#' pasilla |> distinct(.sample)
#'
#' @importFrom dplyr distinct
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
distinct.SummarizedExperiment <- function(.data, ..., .keep_all=FALSE) {
  
    # message(data_frame_returned_message)

    distinct_columns <- (enquos(..., .ignore_empty="all") |>
        map(~ quo_name(.x)) |>
        unlist())
  
    # If Ranges column not in query perform fast as_tibble
    skip_GRanges <- get_GRanges_colnames() %in% 
        distinct_columns |>
        not()
  
    # Deprecation of special column names
    if (is_sample_feature_deprecated_used(.data, distinct_columns)) {
        .data= ping_old_special_column_into_metadata(.data)
    }
  
    .data |>
        select(...) |> 
        as_tibble(skip_GRanges=skip_GRanges) |>
        dplyr::distinct(..., .keep_all=.keep_all)
}

#' @name group_by
#' @rdname group_by
#' @inherit dplyr::group_by
#'
#' @examples
#' data(pasilla)
#' pasilla  |> group_by(.sample)
#'     
#' @importFrom dplyr group_by_drop_default
#' @importFrom dplyr group_by
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
group_by.SummarizedExperiment <- function(.data, ...,
    .add=FALSE, .drop=group_by_drop_default(.data)) {
    message(data_frame_returned_message)

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
  
    .data |>
        as_tibble() |>
        dplyr::group_by(..., .add=.add, .drop=.drop)
}

#' @name summarise
#' @aliases summarize
#' @inherit dplyr::summarise
#' @family single table verbs
#' 
#' @examples
#' data(pasilla)
#' pasilla |> summarise(mean(counts))
#'
#' @importFrom dplyr summarise
#' @importFrom purrr map
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
summarise.SummarizedExperiment <- function(.data, ...) {
    message(data_frame_returned_message)

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
  
    # If Ranges column not in query perform fast as_tibble
    skip_GRanges <-
        get_GRanges_colnames() %in% 
            (enquos(..., .ignore_empty="all") |>
            map(~ quo_name(.x)) |>
            unlist()) |>
            not()

    .data |>
        as_tibble(skip_GRanges=skip_GRanges) |>
        dplyr::summarise(...)
}

#' @name summarise
#' @rdname summarise
#' @importFrom dplyr summarize
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
summarize.SummarizedExperiment <- summarise.SummarizedExperiment



#' @name rowwise
#' @rdname rowwise
#' @inherit dplyr::rowwise
#'
#' @examples
#' # TODO
#'
#' @importFrom dplyr rowwise
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
rowwise.SummarizedExperiment <- function(data, ...) {
    message(data_frame_returned_message)

    data |>
        as_tibble() |>
        dplyr::rowwise()
}



#' @name slice
#' @rdname slice
#' @aliases slice_head slice_tail 
#'   slice_sample slice_min slice_max
#' @inherit dplyr::slice
#' @family single table verbs
#' 
#' @examples
#' data(pasilla)
#' pasilla |> slice(1)
#'
#' @importFrom SummarizedExperiment colData
#' @importFrom dplyr slice
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
slice.SummarizedExperiment <- function(.data, ..., .preserve=FALSE) {
  
    slice_optimised(.data, ..., .preserve=.preserve)
    
    # .data |>
    #     as_tibble(skip_GRanges = T) |>
    #     dplyr::slice(..., .preserve=.preserve) %>%
    #     when(
    # 
    #         # If duplicated sample-feature pair returns tibble
    #         !is_not_duplicated(., .data) | 
    #         !is_rectangular(., .data) ~ {
    #             message(duplicated_cell_names)
    #             (.)
    #         },
    # 
    #         # Otherwise return updated tidySummarizedExperiment
    #         ~ update_SE_from_tibble(., .data)
    #     )
}


#' @name sample_n
#' @rdname sample_n
#' @aliases sample_frac
#' @inherit dplyr::sample_n
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' data(pasilla)
#' pasilla |> sample_n(50)
#' pasilla |> sample_frac(0.1)
#' 
#' @importFrom SummarizedExperiment colData
#' @importFrom dplyr sample_n
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
sample_n.SummarizedExperiment <- function(tbl, size, replace=FALSE,
    weight=NULL, .env=NULL, ...) {
    lifecycle::signal_superseded("1.0.0", "sample_n()", "slice_sample()")

    message(data_frame_returned_message)

    tbl |>
        as_tibble() |>
        dplyr::sample_n(size, replace=replace, weight=weight, .env=.env, ...)
}

#' @rdname sample_n
#' @importFrom SummarizedExperiment colData
#' @importFrom dplyr sample_frac
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
sample_frac.SummarizedExperiment <- function(tbl, size=1, replace=FALSE,
    weight=NULL, .env=NULL, ...) {
    lifecycle::signal_superseded("1.0.0", "sample_frac()", "slice_sample()")

    message(data_frame_returned_message)

    tbl |>
        as_tibble() |>
        dplyr::sample_frac(size, replace=replace, weight=weight, .env=.env, ...)
}

#' @name count
#' @rdname count
#' @inherit dplyr::count
#' 
#' @examples
#' data(se)
#' se |> count(dex)
#'     
#' @importFrom dplyr count
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
count.SummarizedExperiment <- function(x, ..., wt=NULL,
    sort=FALSE, name=NULL, .drop=group_by_drop_default(x)) {
    message(data_frame_returned_message)

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(x, .cols)) {
        x <- ping_old_special_column_into_metadata(x)
    }
  
  
    # If Ranges column not in query perform fast as_tibble
    skip_GRanges <-
        get_GRanges_colnames() %in% 
        (enquos(..., .ignore_empty = "all") |>
            map(~ quo_name(.x)) |> unlist()) |>
        not()
  
    x |>
        as_tibble(skip_GRanges=skip_GRanges) |>
        dplyr::count(..., wt=!!enquo(wt), sort=sort, name=name, .drop=.drop)
}

#' @name pull
#' @rdname pull
#' @inherit dplyr::pull
#' 
#' @examples
#' data(pasilla)
#' pasilla |> pull(feature)
#'     
#' @importFrom ellipsis check_dots_used
#' @importFrom dplyr pull
#' @importFrom SummarizedExperiment assay
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
pull.SummarizedExperiment <- function(.data, var=-1, name=NULL, ...) {
  
    # Fix NOTEs
    . <- NULL
  
    var <- enquo(var)
    name <- enquo(name)

    quo_name_name <- name %>% when(quo_is_null(.) ~ NULL, quo_name(name))
    
    # Deprecation of special column names
    if (is_sample_feature_deprecated_used(
        .data, 
        quo_name(var)
    )) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
    
    # If Ranges column not in query perform fast as_tibble
    skip_GRanges <- 
        get_GRanges_colnames() %in% 
        quo_name(var) |>
        not()
    
    # Subset column annotation
    if (all(c(quo_names(var), quo_name_name) %in% colnames(colData(.data)))) {
        return(colData(.data)[, quo_names(var)] %>%
            .[rep(1:length(.), each=nrow(.data) )])
    }
    
    # Subset row annotation
    if(all(c(quo_names(var), quo_name_name) %in% colnames(rowData(.data)))) {
        return(colData(.data)[,quo_names(var)] %>%
            .[rep(1:length(.), ncol(.data) )])
    }
    
    # This returns a vector column wise. With the first sample and all features, 
    # second sample and all features, etc..
    if(all(c(quo_names(var), quo_name_name) %in% names(.data@assays@data))){

        # Warning if column names of assays do not overlap
        if (check_if_assays_are_NOT_consistently_ordered(.data)) {
            warning(
                "tidySummarizedExperiment says:",
                " the assays in your SummarizedExperiment have column names, ",
                "but their order is not the same. Pulling assays can return ",
                "data in a order you don't expect. To avoid unwanted behaviour",
                " it is highly recommended to have assays with the same order",
                " of colnames and rownames" 
            )
            
            # reorder assay colnames before printing
            # Rearrange if assays has colnames and rownames
            .data <- order_assays_internally_to_be_consistent(.data)
        
        }
        return(assay(.data, quo_names(var)) |> as.matrix() |> as.vector())       
    }
    
    # Subset rowranges
    if (all(c(quo_names(var), quo_name_name) %in%
            colnames(as.data.frame(rowRanges(.data))))) {
        return( as.data.frame(rowRanges(.data))[,quo_names(var)] %>%
            .[rep(1:length(.), ncol(.data) )])        
    }
    
    # Otherwise (SHOULD NOT HAPPEN) use the long general procedure
    colData(.data) <- colData(.data)[,colnames(colData(.data)) %in%
        c(quo_names(var), quo_name_name), drop=FALSE ]
    rowData(.data) <- rowData(.data)[,colnames(rowData(.data)) %in%
        c(quo_names(var), quo_name_name), drop=FALSE ]
  
    .data |>
        as_tibble(skip_GRanges=skip_GRanges) |>
        dplyr::pull(var=!!var, name=!!name, ...)
}

#' @name group_split
#' @rdname group_split
#' @inherit dplyr::group_split
#' 
#' @examples
#' data(pasilla, package = "tidySummarizedExperiment")
#' pasilla |> group_split(condition)
#' pasilla |> group_split(counts > 0)
#' pasilla |> group_split(condition, counts > 0)
#' 
#' @importFrom ellipsis check_dots_used
#' @importFrom dplyr group_split
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
group_split.SummarizedExperiment <- function(.tbl, ..., .keep = TRUE) {
  
  var_list <- enquos(...)
  data_nested <- NULL
  
  nested <- .tbl |> 
    mutate(!!!var_list) |> 
    nest(data_nested = -(substring(as.character(var_list), 2)))
  
  if(.keep) {
    grouped_data <- nested |> 
      pull(data_nested)
    
    grouping_cols <- nested |> 
      select(substring(as.character(var_list), 2))
    
    for(i in 1:length(grouped_data)) {
      grouped_data[[i]] <- grouped_data[[i]] |> 
        mutate(grouping_cols[i,])
    }
    
    grouped_data
    
  } else {
    nested |> 
      pull(data_nested)
  }
    
}

#' @name unnest
#' @rdname unnest
#' @inherit tidyr::unnest
#' @aliases unnest_summarized_experiment
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' tidySummarizedExperiment::pasilla |>
#'     nest(data=-condition) |>
#'     unnest(data)
#' 
#' @importFrom tidyr unnest
#' @importFrom rlang quo_name
#' @importFrom purrr imap
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
unnest.tidySummarizedExperiment_nested <- function(data, cols, ...,
    keep_empty=FALSE, ptype=NULL, names_sep=NULL,
    names_repair="check_unique", .drop, .id, .sep, .preserve) {
    
    cols <- enquo(cols)
    
    unnest_summarized_experiment(data, !!cols, ...,
        keep_empty=keep_empty, ptype=ptype,
        names_sep=names_sep, names_repair=names_repair)
   
}


#' @rdname unnest
#' @examples
#' tidySummarizedExperiment::pasilla |>
#'     nest(data=-condition) |>
#'     unnest_summarized_experiment(data)
#' 
#' @importFrom tidyr unnest
#' @importFrom rlang quo_name
#' @importFrom purrr imap
#' @importFrom purrr map_lgl
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
unnest_summarized_experiment <- function(data, cols, ...,
    keep_empty=FALSE, ptype=NULL, names_sep=NULL,
    names_repair="check_unique", .drop, .id, .sep, .preserve) {
    . <- NULL

    # Need this otherwise crashes map
    .data_ <- data
  
    cols <- enquo(cols)
  
    # If the column is not SE do normal stuff
    if (
        data %>%
        pull(!!cols) %>%
        .[[1]] %>%
        class() %>%
        as.character() %in%
        c("SummarizedExperiment",
            "RangedSummarizedExperiment") %>%
        all() %>%
        not()
    ) {
        return(
            data %>%
            drop_class("tidySummarizedExperiment_nested") %>%
            tidyr::unnest(!!cols, ..., keep_empty=keep_empty,
                ptype=ptype, names_sep=names_sep,
                names_repair=names_repair) %>%
            add_class("tidySummarizedExperiment_nested")
        )
    }


    # If both nested by transcript and sample
    if (s_(se)$name %in% colnames(data) &
        f_(se)$name %in% colnames(data) ) {
        stop("tidySummarizedExperiment says:",
            " for the moment nesting both by sample- and feature-wise",
            " information is not possible. Please ask this feature",
            " to github/stemangiola/tidySummarizedExperiment")
    }
  
    # If both nested not by transcript nor sample
    if(!s_(se)$name %in% colnames(data) &
        !f_(se)$name %in% colnames(data)) {
    
        my_se <- pull(.data_, !!cols) %>% .[[1]] 

    
        # Mark if columns belong to feature or sample
        my_unnested_tibble =
          data |> 
          mutate(!!cols := map(!!cols, ~ as_tibble(.x))) |>
          select(-any_of(c(s_(my_se)$name, f_(my_se)$name))) |> 
          unnest(!!cols)
    
        # Get which column is relative to feature or sample
        sample_columns <- my_unnested_tibble %>%
            get_subset_columns(!!s_(my_se)$symbol)
        transcript_columns <- my_unnested_tibble %>%
            get_subset_columns(!!f_(my_se)$symbol)
    
        source_column <-
            c(
                rep(s_(my_se)$name,
                    length(sample_columns)) %>%
                    setNames(sample_columns),
                rep(f_(my_se)$name,
                    length(transcript_columns)) %>%
                    setNames(transcript_columns)
            )
    
        # Drop if SE is null
        if (data |> filter(map_lgl(!!cols, is.null)) |> nrow() > 0) {
            warning("tidySummarizedcExperiment says:",
                " some SummarizedExperiment objects to",
                " unnest were <NULL>, and were elminated")
            data <- data |> filter(!map_lgl(!!cols, is.null))
        }
    
        # Do my trick to unnest
    data = 
      data |>
      
      # I have to use this because imap behave strangely
      rowid_to_column(var = "i___") |> 
      mutate(!!cols := map2(
        !!cols, i___, ~ .x %>% 
          bind_cols_internal(
            
            # Attach back the columns used for nesting
            .data_ %>%
              select(-!!cols, -any_of(c(s_(my_se)$name, f_(my_se)$name))) %>%
              slice(rep(as.integer(.y), ncol(.x) * nrow(.x))),
            
            # Column sample-wise or feature-wise
            column_belonging =
              source_column[
                .data_ %>%
                  select(-!!cols, -any_of(c(s_(my_se)$name, f_(my_se)$name))) %>%
                  colnames()
              ]
          )
      )) |> 
      
      # I have to use this because imap behave strangely
      select(-i___)
    
        # Understand if split was done feature 
        if(identical(
            data |> pull(!!cols) |> magrittr::extract2(1) |>
                colnames() |> sort(),
            data |> pull(!!cols) |> map(colnames) |> 
                reduce(intersect) |> sort()
        )) {
            return(data |> pull(!!cols) |> reduce_rbind_se())
        } 
        # Understand if split was done sample 
        else if (identical(
            data |> pull(!!cols) |> magrittr::extract2(1) |>
                rownames() |> sort(),
            data |> pull(!!cols) |> map(rownames) |>
                reduce(intersect) |> sort()
        )) {
            return(data |> pull(!!cols) |> reduce_cbind_se())
        }
        # If neither there is something wrong
        else {
            stop("tidySummarizedcExperiment says: not the sample names",
                " nor the feature names overlap through your nesting.",
                " The nesting (due to the underlying",
                " SummarizedExperiment::cbind and",
                " SummarizedExperiment::rbind requirements)",
                " needs to be rectangular.)")
        }

    }
  
    # If column is SE nd only feature
    if (f_(se)$name %in% colnames(data)) {
        se <- do.call(SummarizedExperiment::rbind, pull(data, !!cols))
        rowData(se) <- cbind(rowData(se),
            data %>% select(-!!cols, -!!f_(se)$symbol))
        return(se)
    }
  
    # If column is SE nd only sample
    if (s_(se)$name %in% colnames(data)) {
        se <- data |> pull(!!cols) |> reduce_cbind_se()
        colData(se) <- cbind(colData(se),
            data %>% select(-!!cols, -!!s_(se)$symbol))
        return(se)
    }
}

#' @name nest
#' @rdname nest
#' @inherit tidyr::nest
#' @return `tidySummarizedExperiment_nested`
#'
#' @examples
#' tidySummarizedExperiment::pasilla |>
#'     nest(data=-condition)
#'     
#' @importFrom rlang enquos
#' @importFrom rlang :=
#' @importFrom tidyselect all_of
#' @importFrom tidyselect any_of
#' @importFrom stats setNames
#' @importFrom purrr pmap
#' @importFrom tidyr nest
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
nest.SummarizedExperiment <- function(.data, ..., .names_sep=NULL) {
    cols <- enquos(...)
    col_name_data <- names(cols)

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }
    
    # if the data does not have raw, names or clumn names
    # we have to add them, otherwise the nesting and a nesting will get confused with 
    # the link between Sample wise, columns, and Sample IDs
    if(rownames(.data) |> is.null() | colnames(.data) |> is.null() )
      warning("tidySummarizedExperiment says: the nesting and unnesting operations require row names and column names to avoid side-effects. Therefore, doors will be added as \"1\", \"2\", \"3\".")
    if(rownames(.data) |> is.null() ) rownames(.data) = .data |> nrow() |> seq_len() |> as.character()
    if(colnames(.data) |> is.null() ) colnames(.data) = .data |> ncol() |> seq_len() |> as.character()
    
    my_data__ <- .data 
    
    # Names
    sample_name <- s_(my_data__)$name
    feature_name <- f_(my_data__)$name
    sample_symbol <- s_(my_data__)$symbol
    feature_symbol <- f_(my_data__)$symbol
    
    # Check if the nesting is too complicated
    # for the moment without optimisation
    my_test_nest <- 
        my_data__[min(1, nrow(my_data__)),min(1, ncol(my_data__))] %>%
        as_tibble() %>%
        tidyr::nest(...) 

    # Understand what the nesting is about
    my_nesting_column <- my_test_nest |>
        select(-!!as.symbol(col_name_data)) |>
        colnames()

    # Check that sample or feature are in the nesting
    if(
        # Check column intersection
        c(f_(.data)$name) %>%
            intersect(colnames(my_test_nest)) %>%
            length() %>% `>` (0) &
      
        # Check that other column are there
        length(colnames(my_test_nest)) > 2
    ) {
        stop("tidySummarizedExperiment says:",
            " You cannot have the columns feature among the nesting",
            " mixed with other nesting for efficiency reasons.",
            " Please consider to convert to_tibble() first.",
            " We are working for optimising a generalised solution of nest().")
    }

    # If I nest only for .feature -> THIS WORKS ONLY WITH THE CHECK ABOVE
    if (feature_name %in% colnames(my_test_nest)) {
        return(
            my_data__ %>%
            # This is needed otherwise nest goes into loop and fails
            as_tibble() %>%
            tidyr::nest(...) %>% 
            mutate(
                !!as.symbol(col_name_data) := 
                 split_SummarizedExperiment_by_feature_to_list(!!.data)
            ) %>%
            # Coerce to tidySummarizedExperiment_nested for unnesting
            add_class("tidySummarizedExperiment_nested")
        )
    } 
    

    my_data__ %>%
        select(!!sample_symbol, !!feature_symbol, all_of(my_nesting_column)) |> 
        as_tibble() %>%
        tidyr::nest(...) |> 

          mutate(
            !!as.symbol(col_name_data) := pmap(

              # Add sample feature to map if nesting by those
                list(!!as.symbol(col_name_data)) %>%

                  # Check if nested by sample
                  when(sample_name %in% colnames(my_test_nest) ~ c(., list(!!sample_symbol)), ~ (.)) %>%

                  # Check if nested by feature
                  when(feature_name %in% colnames(my_test_nest) ~ c(., list(!!feature_symbol)), ~ (.)) , ~ { 
                    
                    # VERY COMPLICATE WAY TO DO THIS. SIMPLIFY IN THE FUTURE
                    
                    # Check if nested by sample
                    if(sample_name %in% colnames(my_test_nest)) { my_samples=..2 }
                    
                    # Here I am filtering because if I have 0 samples this leads to failure
                    else my_samples= ..1 |> filter(!is.na(!!sample_symbol)) |> pull(!!sample_symbol)

                    # Check if nested by feature and sample
                    if(sample_name %in% colnames(my_test_nest) & feature_name %in% colnames(my_test_nest)) {my_transcripts=..3}
                    else if(feature_name %in% colnames(my_test_nest)) my_transcripts=..2
                    
                    # Here I am filtering because if I have 0 features this leads to failure
                    else my_transcripts= ..1 |> filter(!is.na(!!feature_symbol)) |>  pull(!!feature_symbol)
                    
                    # if the summarised experiment does not have feature ID or Sample ID, 
                    # convert back those to integers
                    # Note to self: this is convoluted, because if feature ID and sample ID 
                    # were to stay integers all along, these will not be needed
                    if(rownames(my_data__) |> is.null()) my_transcripts = as.integer(my_transcripts)
                    if(colnames(my_data__) |> is.null()) my_samples = as.integer(my_samples)
                    
                    my_data__[unique(my_transcripts),unique(my_samples)] |>
                      select(-any_of(
                        my_nesting_column |> 
                          setdiff(c(sample_name, feature_name))
                      )) 
                 
                }
            )
        ) %>%
        # Coerce to tidySummarizedExperiment_nested for unnesting
        add_class("tidySummarizedExperiment_nested")
}

#' @name extract
#' @rdname extract
#' @inherit tidyr::extract
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' tidySummarizedExperiment::pasilla |>
#'     extract(type, into="sequencing", regex="([a-z]*)_end", convert=TRUE)
#' 
#' @importFrom SummarizedExperiment colData
#' @importFrom tidyr extract
#' @importFrom rlang enquo
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
extract.SummarizedExperiment <- function(data, col,
    into, regex="([[:alnum:]]+)", remove=TRUE,
    convert=FALSE, ...) {

    . <- NULL
    se <- tidySummarizedExperiment::se
    col <- enquo(col)

    # Deprecation of special column names
    if (is_sample_feature_deprecated_used(
        data, c(quo_name(col), into)
    )) {
        data <- ping_old_special_column_into_metadata(data)
    }

    
    special_columns <- get_special_columns(  
        # Decrease the size of the dataset
        data[1:min(100, nrow(data)), 1:min(20, ncol(data))]
    ) |> 
        c(get_needed_columns(data))
    
    tst <- intersect(quo_names(into),  special_columns) %>%
        length() %>%
        gt(0) & remove


    if (tst) {
        columns <- special_columns |>  paste(collapse=", ")
        stop(
            "tidySummarizedExperiment says:",
            " you are trying to rename a column that is view only",
            columns,
            "(it is not present in the colData).",
            " If you want to mutate a view-only column,",
            " make a copy and mutate that one."
        )
    }

    # Subset column annotation
    if (
        (
            all(quo_names(col) %in% colnames(colData(data))) |
            (quo_name(col) == s_(se)$name & !remove)
        ) & 
        !s_(se)$name %in% into
    ) {
        colData(data) <- colData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames=s_(data)$name) %>% 
            tidyr::extract(col=!!col, into=into, regex=regex,
                remove=remove, convert=convert, ...) %>% 
            data.frame(row.names=pull(., !!s_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!s_(se)$symbol) %>%
            DataFrame(check.names=FALSE)
      
        return(data)
    }
     
    # Subset row annotation
    if (
        (
            all( quo_names(col) %in% colnames(rowData(data))) | 
            (quo_name(col) == f_(se)$name & !remove)
        ) & 
        !f_(se)$name %in% into
    ) {
        rowData(data) <- rowData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames=f_(data)$name) %>% 
            tidyr::extract(col=!!col, into=into, regex=regex,
                remove=remove, convert=convert, ...) %>% 
            data.frame(row.names=pull(., !!f_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!f_(se)$symbol) %>%
            DataFrame(check.names=FALSE)
      
        return(data)
    }
    
    data %>%
        as_tibble(skip_GRanges=TRUE) %>%
        tidyr::extract(col=!!col, into=into, regex=regex,
            remove=remove, convert=convert, ...) %>%
        update_SE_from_tibble(data)
}

#' @name pivot_longer
#' @rdname pivot_longer
#' @inherit tidyr::pivot_longer
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' # See vignette("pivot") for examples and explanation
#' library(dplyr)
#' tidySummarizedExperiment::pasilla %>%
#'     pivot_longer(c(condition, type),
#'         names_to="name", values_to="value")
#' 
#' @importFrom tidyr pivot_longer
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
pivot_longer.SummarizedExperiment <- function(data,
    cols, ..., cols_vary = "fastest", names_to = "name", 
    names_prefix = NULL, names_sep = NULL, names_pattern = NULL, 
    names_ptypes = NULL, names_transform = NULL, names_repair = "check_unique", 
    values_to = "value", values_drop_na = FALSE, values_ptypes = NULL, 
    values_transform = NULL) {

    cols <- enquo(cols)

    message(data_frame_returned_message)

    # Deprecation of special column names
    if(is_sample_feature_deprecated_used(
        data, 
        c(quo_names(cols))
    )) {
        data <- ping_old_special_column_into_metadata(data)
    }
    
    data %>%
        as_tibble(skip_GRanges=TRUE) %>%
        tidyr::pivot_longer(!!cols, ..., cols_vary=cols_vary, 
            names_to=names_to, names_prefix=names_prefix, 
            names_sep=names_sep, names_pattern=names_pattern, 
            names_ptypes=names_ptypes, names_transform=names_transform,
            names_repair=names_repair, values_to=values_to,
            values_drop_na=values_drop_na, values_ptypes=values_ptypes, 
            values_transform=values_transform
        )
}

#' @name pivot_wider
#' @rdname pivot_wider
#' @inherit tidyr::pivot_wider
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' # See vignette("pivot") for examples and explanation
#' library(dplyr)
#' tidySummarizedExperiment::pasilla %>%
#'     pivot_wider(names_from=feature, values_from=counts)
#' 
#' @importFrom tidyr pivot_wider
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
pivot_wider.SummarizedExperiment <- function(data,
    ..., id_cols = NULL, id_expand = FALSE, names_from = name,
    names_prefix = "", names_sep = "_", names_glue = NULL,
    names_sort = FALSE, names_vary = "fastest", names_expand = FALSE,
    names_repair = "check_unique", values_from = value,
    values_fill = NULL, values_fn = NULL, unused_fn = NULL) {
    id_cols <- enquo(id_cols)
    name <- enquo(names_from)
    value <- enquo(values_from)

    message(data_frame_returned_message)

    # Deprecation of special column names
    if (is_sample_feature_deprecated_used(
        data, 
        c(quo_names(id_cols), quo_names(name), quo_names(value))
    )) {
        data <- ping_old_special_column_into_metadata(data)
    }
  
    data %>%
        as_tibble(skip_GRanges=TRUE) %>%
        tidyr::pivot_wider(..., id_cols=!!id_cols, id_expand=id_expand,
            names_from=!!name, names_prefix=names_prefix,
            names_sep=names_sep, names_glue=names_glue,
            names_sort=names_sort, names_vary=names_vary,
            names_expand=names_expand, names_repair=names_repair,
            values_from=!!value, values_fill=values_fill,
            values_fn=values_fn, unused_fn=unused_fn
        )
}

#' @name unite
#' @rdname unite
#' @inherit tidyr::unite
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' tidySummarizedExperiment::pasilla |>
#'     unite("group", c(condition, type))
#'     
#' @importFrom SummarizedExperiment colData
#' @importFrom SummarizedExperiment colData<-
#' @importFrom rlang enquo enquos quo_name
#' @importFrom tidyr unite
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
unite.SummarizedExperiment <- function(data, col, ...,
    sep="_", remove=TRUE, na.rm=FALSE) {
    
    se <- tidySummarizedExperiment::se
    . <- NULL
    
    # Check that we are not modifying a key column
    cols <- enquo(col)

    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(data, .cols)) {
        data <- ping_old_special_column_into_metadata(data)
    }
  
    special_columns <- get_special_columns(
        # Decrease the size of the dataset
        data[1:min(100, nrow(data)), 1:min(20, ncol(data))]
    ) |> 
        c(get_needed_columns(data))
    
    tst <-
        intersect(
            cols %>% quo_names(),
            special_columns
        ) %>%
        length() %>%
        gt(0) & remove

    if (tst) {
        columns <- special_columns |>  paste(collapse=", ")
        stop(
            "tidySummarizedExperiment says:",
            " you are trying to rename a column that is view only",
            columns,
            "(it is not present in the colData).",
            " If you want to mutate a view-only column,",
            " make a copy and mutate that one."
        )
    }

    columns_to_unite <- data[1,1] %>% select(...) %>% colnames()
    
    # Subset column annotation
    if (all(columns_to_unite %in% colnames(colData(data))) &
        !s_(se)$name %in% col) {
        colData(data) <-
            colData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames=s_(data)$name) %>% 
            tidyr::unite(!!cols, ..., sep=sep,
                remove=remove, na.rm=na.rm) %>%
            data.frame(row.names=pull(., !!s_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!s_(se)$symbol) %>%
            DataFrame(check.names=FALSE)

        return(data)
    }
    
    # Subset row annotation
    if (all(columns_to_unite %in% colnames(rowData(data))) &
        !f_(se)$name %in% col) {
        rowData(data) <-
            rowData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames=f_(data)$name) %>% 
            tidyr::unite(!!cols, ..., sep=sep,
                remove=remove, na.rm=na.rm) %>%
            data.frame(row.names=pull(., !!f_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!f_(se)$symbol) %>%
            DataFrame(check.names = FALSE)

        return(data)
    }

    # Otherwise go simple and slow
    data %>%
        as_tibble(skip_GRanges=TRUE) %>%
        tidyr::unite(!!cols, ..., sep=sep, remove=remove, na.rm=na.rm) %>%
        update_SE_from_tibble(data)
}

#' @name separate
#' @rdname separate
#' @inherit tidyr::separate
#' @return `tidySummarizedExperiment`
#' 
#' @examples
#' un <- tidySummarizedExperiment::pasilla |>
#'     unite("group", c(condition, type))
#' un |> separate(col=group, into=c("condition", "type"))
#' 
#' @importFrom SummarizedExperiment colData
#' @importFrom SummarizedExperiment colData<-
#' @importFrom tidyr separate
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
#' @export
separate.SummarizedExperiment <- function(data, col,
    into, sep="[^[:alnum:]]+", remove=TRUE,
    convert=FALSE, extra="warn", fill="warn", ...) {

    # Fix NOTEs
    . <- NULL
    se <- tidySummarizedExperiment::se
  
    # Check that we are not modifying a key column
    cols <- enquo(col)

    # Deprecation of special column names
    if (is_sample_feature_deprecated_used(
        data, 
        c(quo_names(cols))
    )) {
        data <- ping_old_special_column_into_metadata(data)
    }
    
    special_columns <- get_special_columns(
        # Decrease the size of the dataset
        data[1:min(100, nrow(data)), 1:min(20, ncol(data))]
    ) |> 
        c(get_needed_columns(data))
    
    tst <-
        intersect(
            cols %>% quo_names(),
            special_columns
        ) %>%
        length() %>%
        gt(0) & remove
 
    if (tst) {
        columns <- special_columns |>  paste(collapse=", ")
        stop(
            "tidySummarizedExperiment says:",
            " you are trying to rename a column that is view only",
            columns,
            "(it is not present in the colData).",
            " If you want to mutate a view-only column,",
            " make a copy and mutate that one."
        )
    }


    columns_to_unite <- data[1,1] %>% select(!!cols) %>%
        suppressMessages() %>% colnames()
    
    # Subset column annotation
    if (all(columns_to_unite %in% colnames(colData(data))) &
        (!s_(data)$name %in% into)) {
        colData(data) <-
            colData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames=s_(data)$name) %>% 
            tidyr::separate(!!cols, into=into, sep=sep,
                remove=remove, convert=convert,
                extra=extra, fill=fill, ...) %>%
            data.frame(row.names=pull(., !!s_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!s_(se)$symbol) %>%
            DataFrame(check.names=FALSE)
      
        return(data)
    }
    
    # Subset row annotation
    if (all(columns_to_unite %in% colnames(rowData(data))) &
        (!f_(data)$name %in% into)) {
        rowData(data) <-
            rowData(data) %>% 
            as.data.frame() %>% 
            as_tibble(rownames = f_(data)$name) %>% 
            tidyr::separate(!!cols, into=into, sep=sep,
                remove=remove, convert=convert,
                extra=extra, fill=fill, ...) %>%
            data.frame(row.names=pull(., !!f_(se)$symbol),
                check.names=FALSE) %>%
            select(-!!f_(data)$symbol) %>%
            DataFrame(check.names=FALSE)

        return(data)
    }
    
    # Otherwise go simple and slow
    data %>%
        as_tibble(skip_GRanges=TRUE) %>%
        tidyr::separate(!!cols, into=into, sep=sep,
            remove=remove, convert=convert,
            extra=extra, fill=fill, ...) %>%
        update_SE_from_tibble(data)
}

core <- c("dplyr", "tidyr", "ttservice", "ggplot2")

core_unloaded <- function() {
    search <- paste0("package:", core)
    core[!search %in% search()]
}

# Attach the package from the same library it was loaded from before.
# [source: https://github.com/tidy-biology/tidyverse/issues/171]
same_library <- function(pkg) {
    loc <- if (pkg %in% loadedNamespaces()) 
        dirname(getNamespaceInfo(pkg, "path"))
    library(pkg, lib.loc=loc, character.only=TRUE, warn.conflicts=FALSE)
}

tidyverse_attach <- function() {
    to_load <- core_unloaded()
    
    suppressPackageStartupMessages(
        lapply(to_load, same_library))
    
    invisible(to_load)
}

#' Read counts of RNA-seq samples of Pasilla knock-down by Brooks et al.
#'
#' A SummarizedExperiment dataset containing 
#' the transcriptome information for Drosophila Melanogaster.
#'
#' @format  containing 14599 features and 7 biological replicates.
#'
#' @source \url{https://bioconductor.org/packages/release/data/experiment/html/pasilla.html}
#' @usage data(pasilla)
"pasilla"

#' Read counts of RNA-seq samples derived from 
#' Pasilla knock-down by Brooks et al.
#'
#' A SummarizedExperiment dataset containing 
#' the transcriptome information for Drosophila Melanogaster.
#'
#' @format  containing 14599 features and 7 biological replicates.
#'
#' @source \url{https://bioconductor.org/packages/release/data/experiment/html/pasilla.html}
#' @usage data(se)
"se"

#' @name rename
#' @rdname rename
#' @inherit dplyr::rename
#' @family single table verbs
#'
#' @examples
#' data(pasilla)
#' pasilla |> rename(cond=condition)
#'
#' @importFrom tidyselect eval_select
#' @importFrom SummarizedExperiment colData
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment colData<-
#' @importFrom SummarizedExperiment rowData<-
#' @importFrom dplyr rename
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
rename.SummarizedExperiment <- function(.data, ...) {

    # Check if query is composed (multiple expressions)
    if (is_composed("rename", ...)) {
        return(decompose_tidy_operation("rename", ...)(.data))
    }

    # Analyze the scope of the rename operation
    dots <- enquos(...)
    # In rename, the old names are the values (what we're renaming FROM)
    old_names <- sapply(dots, quo_name)
    
    # Determine which domain the columns belong to
    coldata_cols <- old_names[old_names %in% colnames(colData(.data))]
    rowdata_cols <- old_names[old_names %in% colnames(rowData(.data))]
    

    
    # Check for special/view-only columns
    special_columns <- get_special_columns(
        # Decrease the size of the dataset
        .data[1:min(100, nrow(.data)), 1:min(20, ncol(.data))]
    ) |> c(get_needed_columns(.data))
    
    if (any(old_names %in% special_columns)) {
        columns <- intersect(old_names, special_columns) |> paste(collapse=", ")
        stop(
            "tidySummarizedExperiment says:",
            " you are trying to rename a column that is view only: ",
            columns,
            " (it is not present in the colData or rowData).",
            " If you want to mutate a view-only column,",
            " make a copy and mutate that one."
        )
    }
    
    # Dispatch to appropriate domain-specific function
    if (length(coldata_cols) > 0) {
        # ColData-only rename
        return(modify_samples(.data, "rename", ...))
    } else if (length(rowdata_cols) > 0) {
        # RowData-only rename  
        return(modify_features(.data, "rename", ...))
    } else {
        # No matching columns found
        stop("tidySummarizedExperiment says:",
            " the columns you are trying to rename (",
            paste(old_names, collapse=", "),
            ") are not found in colData or rowData.")
    }
}

#' Analyze the scope of a filter query to determine target data types
#'
#' This function analyzes a filter query to determine whether it targets:
#' - Only colData (sample metadata)
#' - Only rowData (feature metadata)
#' - Only assays (expression/count data)
#' - Mixed operations (combination of the above)
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param ... Filter expressions (same as dplyr::filter)
#' @return A list containing scope information and expression dependencies
#' @noRd
analyze_query_scope_filter <- function(se, ...) {
  
  # Capture the filter expressions
  dots <- rlang::enquos(...)
  
  # If no predicates provided, scope is unknown (no-op)
  if (length(dots) == 0) {
    return(list(
      scope = "unknown",
      targets_coldata = FALSE,
      targets_rowdata = FALSE,
      targets_assays = FALSE,
      analysis_method = "no_predicates",
      confidence = "low",
      expression_dependencies = list()
    ))
  }
  
  # Use dependency analysis to infer scope
  dependency_result <- analyze_expression_dependencies(se, dots)
  
  return(list(
    scope = dependency_result$overall_scope,
    targets_coldata = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_coldata)),
    targets_rowdata = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_rowdata)),
    targets_assays = any(sapply(dependency_result$expression_dependencies, function(x) x$uses_assays)),
    analysis_method = dependency_result$analysis_method,
    confidence = dependency_result$confidence,
    expression_dependencies = dependency_result$expression_dependencies
  ))
}


#' @name filter
#' @rdname filter
#' @inherit dplyr::filter
#' 
#' @examples
#' data(pasilla)
#' pasilla |>  filter(.sample == "untrt1")
#'
#' # Learn more in ?dplyr_tidy_eval
#' 
#' @importFrom purrr map
#' @importFrom dplyr filter
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
filter.SummarizedExperiment <- function(.data, ..., .preserve=FALSE) {
    # Deprecation of special column names
    .cols <- enquos(..., .ignore_empty="all") %>% 
        map(~ quo_name(.x)) %>% unlist()
    if (is_sample_feature_deprecated_used(.data, .cols)) {
        .data <- ping_old_special_column_into_metadata(.data)
    }

    # Decompose composed queries (multiple predicates)
    if (is_composed("filter", ...)) {
        return(decompose_tidy_operation("filter", ..., .preserve = .preserve)(.data))
    }

    # Analyze scope and dispatch
    scope_report <- analyze_query_scope_filter(.data, ...)
    scope <- scope_report$scope

    result <-
    if (scope == "coldata_only") modify_samples(.data, "filter", ..., .preserve = .preserve)
    else if (scope == "rowdata_only") modify_features(.data, "filter", ..., .preserve = .preserve)
    else if (scope == "mixed") modify_se_plyxp(.data, "filter", scope_report, ..., .preserve = .preserve)
    else {
        # Fallback: perform via tibble and map back if rectangular
        new_meta <- .data |>
            as_tibble(skip_GRanges=TRUE) |>
            dplyr::filter(..., .preserve=.preserve)

        if (!is_rectangular(new_meta, .data)) {
            message("tidySummarizedExperiment says:",
                " The resulting data frame is not rectangular",
                " (all genes for all samples), a tibble is returned",
                " for independent data analysis.")
            return(new_meta)
        } else {
            .data[  
                unique(pull(new_meta,!!f_(.data)$symbol)), 
                unique(pull(new_meta,!!s_(.data)$symbol)) 
            ]
        }
    }

    # Record latest filter scope into metadata for testing/introspection
    meta <- S4Vectors::metadata(result)
    if (is.null(meta)) meta <- list()
    meta$latest_filter_scope_report <- scope_report
    S4Vectors::metadata(result) <- meta

    return(result)
}

#' @importFrom magrittr equals
#' @importFrom dplyr n
is_rectangular <- function(.data, se) {
    is_rectangular_sample <-
        .data %>%
        count(!!s_(se)$symbol ) %>%
        count(n, name="nn") %>%
        nrow() %>%
        st(2)

    is_rectangular_transcript <-
        .data %>%
        count(!!f_(se)$symbol) %>%
        count(n, name="nn") %>%
        nrow() %>%
        st(2)

    is_rectangular_sample & is_rectangular_transcript
}

is_not_duplicated <- function(.data, se) {
    .data %>%
        count(!!s_(se)$symbol , !!f_(se)$symbol) %>%
        filter(n > 1) %>%
        nrow() %>%
        equals(0)
}

#' Analyze scope of join keys (sample vs feature) for joins
#'
#' @keywords internal
#' @param se A SummarizedExperiment object
#' @param join_keys Character vector of join key column names (already resolved)
#' @return List with scope ("coldata_only", "rowdata_only", "mixed", or "unknown") and details
#' @noRd
analyze_query_scope_join <- function(se, join_keys) {
  col_keys <- intersect(join_keys, colnames(colData(se)))
  row_keys <- if (.hasSlot(se, "rowData") || .hasSlot(se, "elementMetadata")) {
    intersect(join_keys, colnames(rowData(se)))
  } else character(0)

  uses_col <- length(col_keys) > 0
  uses_row <- length(row_keys) > 0

  scope <- if (uses_col && uses_row) {
    "mixed"
  } else if (uses_col) {
    "coldata_only"
  } else if (uses_row) {
    "rowdata_only"
  } else {
    "unknown"
  }

  list(
    scope = scope,
    targets_coldata = uses_col,
    targets_rowdata = uses_row,
    join_keys_coldata = col_keys,
    join_keys_rowdata = row_keys
  )
}

join_efficient_for_SE <- function(x, y, by = NULL, copy = FALSE,
                                  suffix = c(".x", ".y"), join_function, 
                                  force_tibble_route = FALSE,
                                  ...) {
  
  # Comply to CRAN notes 
  . <- NULL 
  
  # Deprecation of special column names
  if (is_sample_feature_deprecated_used(x, when(by, !is.null(.) ~ by, ~ colnames(y)))) {
    x <- ping_old_special_column_into_metadata(x)
  }
  
  # Get the colnames of samples and feature datasets
  colnames_col <- get_colnames_col(x)
  colnames_row <- get_rownames_col(x)
  
  # See if join done by sample, feature or both
  columns_query <- by %>% when(
    !is.null(.) ~ choose_name_if_present(.), 
    ~ colnames(y) %>% intersect(c(colnames_col, colnames_row))
  )
  
  # Analyze join scope
  scope_report <- analyze_query_scope_join(x, columns_query)
  
  if (
    # Complex/mixed scope joins go via tibble route
    scope_report$scope %in% c("mixed", "unknown") |
    
    # If join is with something else, the inefficient generic solution might work, 
    # or delegate the proper error downstream
    (!any(columns_query %in% colnames_row) & !any(columns_query %in% colnames_col)) |
    
    # Needed for internal recurrence if outcome is not valid
    force_tibble_route) {
    
    # If I have a big dataset
    if (ncol(x) > 100) message("tidySummarizedExperiment says: if you are joining a dataframe both sample-wise and feature-wise, for efficiency (until further development), it is better to separate your joins and join datasets sample-wise OR feature-wise.")
    
    out <- x %>%
      as_tibble(skip_GRanges = TRUE) %>%
      join_function(y, by = by, copy = copy, suffix = suffix, ...) %>%
      when(
        
        # If duplicated sample-feature pair returns tibble
        !is_not_duplicated(., x) | !is_rectangular(., x) ~ {
          message(duplicated_cell_names)
          message(data_frame_returned_message)
          (.)
        },
        
        # Otherwise return updated tidySummarizedExperiment
        ~ update_SE_from_tibble(., x)
      )
    
    # Attach metadata if we returned an SE
    if (methods::is(out, "SummarizedExperiment")) {
      meta <- S4Vectors::metadata(out)
      if (is.null(meta)) meta <- list()
      meta$latest_join_scope_report <- scope_report
      S4Vectors::metadata(out) <- meta
    }
    
    return(out)
  }
  
  # Join only feature-wise
  else if (scope_report$scope == "rowdata_only") {
    
    row_data_tibble <-  
      rowData(x) %>% 
      as_tibble(rownames = f_(x)$name) %>%  
      join_function(y, by = by, copy = copy, suffix = suffix, ...) 
    
    # Check if the result is not SE then take the tibble route
    if (
      is.na(pull(row_data_tibble, !!f_(x)$symbol)) %>% any | 
      duplicated(pull(row_data_tibble, !!f_(x)$symbol)) %>% any |
      pull(row_data_tibble, !!f_(x)$symbol) %>% setdiff(rownames(colData(x))) %>% length() %>% gt(0)
    ) return(join_efficient_for_SE(x, y, by = by, copy = copy, suffix = suffix, 
                                   join_function, force_tibble_route = TRUE, ...))
    
    row_data <- 
      row_data_tibble %>% 
      data.frame(row.names = pull(., !!f_(x)$symbol)) %>%
      select(-!!f_(x)$symbol) %>%
      DataFrame()
    
    # Subset in case of an inner join, or a right join
    x <- x[rownames(row_data),]  
    
    # Tranfer annotation
    rowData(x) <- row_data
    
    # Attach latest join scope metadata
    meta <- S4Vectors::metadata(x)
    if (is.null(meta)) meta <- list()
    meta$latest_join_scope_report <- scope_report
    S4Vectors::metadata(x) <- meta
    
    # Return
    x
  }
  
  # Join only sample-wise
  else if (scope_report$scope == "coldata_only") {
    
    col_data_tibble <- 
      colData(x) %>% 
      as_tibble(rownames = s_(x)$name) %>%  
      join_function(y, by = by, copy = copy, suffix = suffix, ...)
    
    # Check if the result is not SE then take the tibble route
    if (
      is.na(pull(col_data_tibble, !!s_(x)$symbol)) %>% any | 
      duplicated(pull(col_data_tibble, !!s_(x)$symbol)) %>% any |
      pull(col_data_tibble, !!s_(x)$symbol) %>% setdiff(rownames(colData(x))) %>% length() %>% gt(0)
    ) return(join_efficient_for_SE(x, y, by = by, copy = copy, suffix = suffix, 
                                   join_function, force_tibble_route = TRUE, ...))
    
    col_data <- 
      col_data_tibble %>% 
      data.frame(row.names = pull(., !!s_(x)$symbol)) %>%
      select(-!!s_(x)$symbol) %>%
      DataFrame()
    
    # Subset in case of an inner join, or a right join
    x <- x[,rownames(col_data)]  
    
    # Transfer annotation
    colData(x) <- col_data
    
    # Attach latest join scope metadata
    meta <- S4Vectors::metadata(x)
    if (is.null(meta)) meta <- list()
    meta$latest_join_scope_report <- scope_report
    S4Vectors::metadata(x) <- meta
    
    # Return
    x
  }
  
  else stop("tidySummarizedExperiment says: ERROR FOR DEVELOPERS: this option should not exist. In join utility.")
}

#' @name left_join
#' @rdname left_join
#' @inherit dplyr::left_join
#'
#' @examples
#' data(pasilla)
#' 
#' tt <- pasilla 
#' tt |> left_join(tt |>
#'     distinct(condition) |>
#'     mutate(new_column=1:2) |>
#'     slice(1))
#'
#' @importFrom dplyr left_join
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
left_join.SummarizedExperiment <- function(x, y, by = NULL,
    copy = FALSE, suffix = c(".x", ".y"), ...) {
  
    join_efficient_for_SE(x, y, by = by, copy = copy,
        suffix = suffix, dplyr::left_join, ...)

}

#' @name inner_join
#' @rdname inner_join
#' @inherit dplyr::inner_join
#'
#' @examples
#' data(pasilla)
#' 
#' tt <- pasilla 
#' tt |> inner_join(tt |>
#'     distinct(condition) |>
#'     mutate(new_column=1:2) |>
#'     slice(1))
#'
#' @importFrom dplyr inner_join
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
inner_join.SummarizedExperiment <- function(x, y, by=NULL,
    copy=FALSE, suffix=c(".x", ".y"), ...) {
  
    join_efficient_for_SE(x, y, by=by, copy=copy,
        suffix=suffix, dplyr::inner_join, ...)

}

#' @name right_join
#' @rdname right_join
#' @inherit dplyr::right_join
#'
#' @examples
#' data(pasilla)
#' 
#' tt <- pasilla
#' tt |> right_join(tt |>
#'     distinct(condition) |>
#'     mutate(new_column=1:2) |>
#'     slice(1))
#'
#' @importFrom dplyr right_join
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
right_join.SummarizedExperiment <- function(x, y, by=NULL,
    copy=FALSE, suffix=c(".x", ".y"), ...) {
  
    join_efficient_for_SE(x, y, by=by, copy=copy,
        suffix=suffix, dplyr::right_join, ...)
}

#' @name full_join
#' @rdname full_join
#' @inherit dplyr::full_join
#'
#' @examples
#' data(pasilla)
#' 
#' tt <- pasilla
#' tt |> full_join(tibble::tibble(condition="treated", dose=10))
#'
#' @importFrom dplyr full_join
#' @references
#' Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
#' 
#' Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
#' @export
full_join.SummarizedExperiment <- function(x, y, by=NULL,
    copy=FALSE, suffix=c(".x", ".y"), ...) {

    join_efficient_for_SE(x, y, by=by, copy=copy,
        suffix=suffix, dplyr::full_join, ...)
}

context("select function tests with scope analysis and fallback paths")

library(tidySummarizedExperiment)
library(SummarizedExperiment)
library(S4Vectors)
library(dplyr)
library(airway)

# Helper: airway-based test SE (subset for speed)
create_airway_test_se <- function() {
    data(airway)
    se <- airway
    se <- se[1:200, ]
    se
}

test_that("select coldata-only returns tibble expanded by rows and stores metadata", {
    se <- create_airway_test_se()

    res <- se %>% select(.sample, dex)

    expect_true(tibble::is_tibble(res))
    # Expect nrow expanded by number of features
    expect_equal(nrow(res), nrow(se) * ncol(se))
    expect_true(all(c(".sample", "dex") %in% colnames(res)))
})

test_that("select rowdata-only returns tibble expanded by columns and stores metadata", {
    se <- create_airway_test_se()

    res <- se %>% select(.feature, gene_biotype)

    expect_true(tibble::is_tibble(res))
    # Expect nrow expanded by number of samples
    expect_equal(nrow(res), ncol(se) * nrow(se))
    expect_true(all(c(".feature", "gene_biotype") %in% colnames(res)))
})

test_that("select assays-only without key columns falls back to tibble", {
    se <- create_airway_test_se()

    # Select only the assay 'counts' leaving key columns implicit
    res <- se %>% select(counts)

    expect_true(tibble::is_tibble(res))
    expect_true("counts" %in% colnames(res))
})

test_that("select mixed scope returns SE with selected row/col/assay pieces and metadata", {
    se <- create_airway_test_se()

    res <- se %>% select(.sample, .feature, counts)

    expect_s4_class(res, "SummarizedExperiment")
    expect_true("counts" %in% names(assays(res)))
    meta <- S4Vectors::metadata(res)
    expect_true(!is.null(meta$latest_select_scope_report))
    expect_true(meta$latest_select_scope_report$scope %in% c("mixed", "unknown"))
})

test_that("fallback when key columns missing converts to tibble and selects via dplyr", {
    se <- create_airway_test_se()

    # Force missing of key columns by selecting a non-key from colData only, but not .sample/.feature
    res <- se %>% select(dex)

    expect_true(tibble::is_tibble(res))
    expect_true("dex" %in% colnames(res))
})

context("join tests")

library(tidySummarizedExperiment)


test_that("left_join", {
    res_left <- pasilla %>%
        left_join(pasilla %>%
                      distinct(condition) %>%
                      mutate(new_column = 1:2), by = "condition")

    expect_equal(
        res_left %>%
            colData() %>%
            ncol(),
        pasilla %>%
            colData() %>%
            ncol() %>%
            sum(1)
    )

    # Metadata: scope should be coldata_only when joining by a colData key (condition)
    meta <- S4Vectors::metadata(res_left)
    expect_true(!is.null(meta$latest_join_scope_report))
    expect_equal(meta$latest_join_scope_report$scope, "coldata_only")
})

test_that("left_join 0 samples", {
 
    res_zero <- pasilla[0,] %>%
      left_join(pasilla %>%
                  distinct(condition) %>%
                  mutate(new_column = 1), by = "condition")

    # still SE; metadata should be set
    expect_s4_class(res_zero, "SummarizedExperiment")
    meta0 <- S4Vectors::metadata(res_zero)
    expect_true(!is.null(meta0$latest_join_scope_report))
    expect_equal(meta0$latest_join_scope_report$scope, "coldata_only")

    res_zero %>%
      as_tibble() |> 
      pull(new_column) %>%
      unique() |> 
      expect_equal(1)
  
})

test_that("inner_join", {
    res_inner <- pasilla %>% inner_join(pasilla %>%
                          distinct(condition) %>%
                          mutate(new_column = 1:2) %>%
                          slice(1), by = "condition")
    res_inner %>% ncol() %>% expect_equal(4)

    meta <- S4Vectors::metadata(res_inner)
    expect_true(!is.null(meta$latest_join_scope_report))
    expect_equal(meta$latest_join_scope_report$scope, "coldata_only")
})

test_that("right_join", {
    res_right <- pasilla %>% right_join(pasilla %>%
                          distinct(condition) %>%
                          mutate(new_column = 1:2) %>%
                          slice(1), by = "condition")
    res_right %>% ncol() %>% expect_equal(4)

    meta <- S4Vectors::metadata(res_right)
    expect_true(!is.null(meta$latest_join_scope_report))
    expect_equal(meta$latest_join_scope_report$scope, "coldata_only")
})

test_that("full_join", {
    res_full <- pasilla %>%
        full_join(tibble::tibble(condition = "A",     other = 1:4), by = "condition")
    res_full %>% nrow() %>% expect_equal(102197)

    if (methods::is(res_full, "SummarizedExperiment")) {
      meta <- S4Vectors::metadata(res_full)
      expect_true(!is.null(meta$latest_join_scope_report))
      expect_equal(meta$latest_join_scope_report$scope, "coldata_only")
    }
})

context("tidyr test")

library(magrittr)
library(tidySummarizedExperiment)

tt <-
    pasilla %>%
    mutate(col2="other_col")

# Create SummarizedExperiment object for testing
nrows <- 200
ncols <- 6
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
rowRanges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                     IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                     strand=sample(c("+", "-"), 200, TRUE),
                     feature_id=sprintf("ID%03d", 1:200))
colData <- DataFrame(Treatment=rep(c("ChIP", "Input"), 3),
                     row.names=LETTERS[1:6])
rse <- SummarizedExperiment(assays=SimpleList(counts=counts),
                            rowRanges=rowRanges, colData=colData)
rownames(rse) <- sprintf("ID%03d", 1:200)

test_that("RangedSummarizedExperiment_nest_unnest", {
  tryCatch({
    rse_nested <- rse %>%
      nest(data = -.sample)

    rse_unnested <- rse_nested %>%
      unnest(data)
  })
  
  expect_equal(rse@colData, rse_unnested@colData)
  expect_equal(rse@rowRanges, rse_unnested@rowRanges)
})

test_that("nest_unnest", {

    y <- tibble::tibble(
        .sample = c(
            "untrt1",
            "untrt2",
            "untrt3",
            "untrt4",
            "trt1",
            "trt2",
            "trt3"
        ),
        counts = c(0L, 0L, 0L, 0L, 0L, 0L, 1L)
    )

    x <- tt %>%
        nest(data = -condition) %>%
        unnest(data) %>%
        head(n = 1) %>%
        select(.sample, counts)


    expect_equal(x, y)
})

test_that("nest_unnest_slice_1",{
    
    tt %>%
        nest(data = -condition) %>% 
        slice(1) %>% 
        unnest(data)
    
})

test_that("nest_0_samples",{
  
  rowData(tt)$n = rep(1, nrow(tt))
  
  tt[,0] |> 
    nest(data = -n) 
  
})

test_that("unite separate", {
    un <- tt %>% unite("new_col", c(condition, col2), sep = ":")

    un %>%
        select(new_col) %>%
        slice(1) %>%
        pull(new_col) %>%
        expect_equal("untreated:other_col")

    se <-
        un %>%
        separate(
            col = new_col,
            into = c( "condition", "col2"),
            sep = ":"
        )

    se %>%
        select(.sample) %>%
        ncol() %>%
        expect_equal(1)
})

test_that("extract()", {
    tt %>%
        extract(col2,
            into="g", regex="other_([a-z]+)",
            convert = TRUE) %>%
        pull(g) %>%
        class() %>%
        expect_equal("character")
})

test_that("pivot_longer()", {
    tt %>%
        pivot_longer(c(.sample, condition), names_to = "name",
            values_to = "value") %>%
        class() %>%
        .[1] %>%
        expect_equal("tbl_df")
})

test_that("nest_unnest_by_feature_chunk", {
  
  chunks =
    tibble::tibble(.feature = rownames(tt)) |>
    mutate(chunk___ = c( 
      rep(1, times = floor(dplyr::n()/2)), 
      rep(2, times = ceiling(dplyr::n()/2))
    ))
  
  statistics_for_features = 
    tibble::tibble(.feature = rownames(tt)) |>
    mutate(pvalue = runif( dplyr::n(), min = 0, max = 1))
  
  tt = tt |> left_join(statistics_for_features)
    
  tt_unnested = 
    tt |> 
    left_join(chunks) |>
    nest(se_chunk = -chunk___) |> 
    unnest(se_chunk) |> 
    select(-chunk___)
  
  identical(tt, tt_unnested)
  
})

context("felix test")

library(magrittr)
library(tidySummarizedExperiment)

# Create dataset
nrows <- 200; ncols <- 6
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
rowRanges <- GRanges(rep(c("chr1", "chr2"), c(50, 150)),
                     IRanges(floor(runif(200, 1e5, 1e6)), width=100),
                     strand=sample(c("+", "-"), 200, TRUE),
                     feature_id=sprintf("ID%03d", 1:200))
colData <- DataFrame(Treatment=rep(c("ChIP", "Input"), 3),
                     row.names=LETTERS[1:6])
rse <- SummarizedExperiment(assays=SimpleList(counts=counts),
                            rowRanges=rowRanges, colData=colData)



test_that("Example 1 all columns included", {
    
    rse  %>% 
        as_tibble() %>%
        nrow() %>%
        expect_equal(1200)
})


test_that("Example 2", {
    
    colData(rse)$sample <- seq_len(ncol(rse))
    rowData(rse)$transcript <- seq_len(nrow(rse))
    rse  %>% 
        as_tibble() %>%
        nrow() %>%
        expect_equal(1200)
})

test_that("Example 3", {
    
    # rowRanges(rse) <- split(rowRanges(rse),seq_len(nrow(rse)))
    # 
    # rse  %>% 
    #     as_tibble() %>%
    #     nrow() %>%
    #     expect_equal(1200)
    
    rowData(rse)$transcript <- seq_len(nrow(rse))
    
    rse  %>% 
        as_tibble() %>%
        nrow() %>%
        expect_equal(1200)
    
    colnames(rse) <- NULL
    
    rse  %>% 
        as_tibble() %>%
        select(.sample, .feature) %>%
        ncol() %>%
        expect_equal(2) 
})

test_that("Example 4 from tidybulk", {
    
   x = se %>% as_tibble()
})

---
title: "Overview of the tidySummarizedExperiment package"
author: "Stefano Mangiola"
date: "`r Sys.Date()`"
package: tidySummarizedExperiment
output:
  prettydoc::html_pretty:
    theme: cayman
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
    df_print: paged
bibliography: tidySummarizedExperiment.bib
vignette: >
  %\VignetteEngine{knitr::knitr}
  %\VignetteIndexEntry{Overview of the tidySummarizedExperiment package}
  %\usepackage[UTF-8]{inputenc}
---

<!-- badges: start -->
[![Lifecycle:maturing](https://img.shields.io/badge/lifecycle-maturing-blue.svg)](https://www.tidyverse.org/lifecycle/#maturing)
<!-- badges: end -->


**Brings SummarizedExperiment to the tidyverse!**

website: [stemangiola.github.io/tidySummarizedExperiment/](https://tidyomics.github.io/tidySummarizedExperiment/)

Please also have a look at

- [tidySingleCellExperiment](https://tidyomics.github.io/tidySingleCellExperiment/) for tidy manipulation of SingleCellExperiment objects
- [tidyseurat](https://stemangiola.github.io/tidyseurat/) for tidy manipulation of Seurat objects
- [tidybulk](https://stemangiola.github.io/tidybulk/) for tidy analysis of RNA sequencing data
- [tidygate](https://github.com/stemangiola/tidygate) for adding custom gate information to your tibble
- [tidyHeatmap](https://stemangiola.github.io/tidyHeatmap/) for heatmaps produced with tidy principles


```{r, echo=FALSE, include=FALSE}
library(knitr)
knitr::opts_chunk$set(warning=FALSE, message=FALSE)
```

# Introduction

tidySummarizedExperiment provides a bridge between Bioconductor [SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html) [@morgan2020summarized] and the tidyverse [@wickham2019welcome]. It creates an invisible layer that enables viewing the
Bioconductor *SummarizedExperiment* object as a tidyverse tibble, and provides SummarizedExperiment-compatible *dplyr*, *tidyr*, *ggplot* and *plotly* functions. This allows users to get the best of both Bioconductor and tidyverse worlds.


## Functions/utilities available

SummarizedExperiment-compatible Functions | Description
------------ | -------------
`all` | After all `tidySummarizedExperiment` is a SummarizedExperiment object, just better

tidyverse Packages | Description
------------ | -------------
`dplyr` | Almost all `dplyr` APIs like for any tibble
`tidyr` | Almost all `tidyr` APIs like for any tibble
`ggplot2` | `ggplot` like for any tibble
`plotly` | `plot_ly` like for any tibble

Utilities | Description
------------ | -------------
`as_tibble` | Convert cell-wise information to a `tbl_df`

## Installation

```{r, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE)) {
      install.packages("BiocManager")
  }

BiocManager::install("tidySummarizedExperiment")
```

From Github (development)
```{r, eval=FALSE}
remotes::install_github("stemangiola/tidySummarizedExperiment")
```

Load libraries used in the examples.

```{r}
library(ggplot2)
library(dplyr)
library(tidySummarizedExperiment)
```


# Create `tidySummarizedExperiment`, the best of both worlds!

This is a SummarizedExperiment object but it is evaluated as a tibble. So it is fully compatible both with SummarizedExperiment and tidyverse APIs.

```{r}
pasilla_tidy <- tidySummarizedExperiment::pasilla 
```

**It looks like a tibble**

```{r}
pasilla_tidy
```

**But it is a SummarizedExperiment object after all**

```{r}
assays(pasilla_tidy)
```


# Tidyverse commands

We can use tidyverse commands to explore the tidy SummarizedExperiment object.

We can use `slice` to choose rows by position, for example to choose the first row.

```{r}
pasilla_tidy %>%
    dplyr::slice(1)
```

We can use `filter` to choose rows by criteria.

```{r}
pasilla_tidy %>%
    filter(condition == "untreated")
```

We can use `select` to choose columns.

```{r}
pasilla_tidy %>%
    select(.sample)
```

We can use `count` to count how many rows we have for each sample.

```{r}
pasilla_tidy %>%
    dplyr::count(.sample)
```

We can use `distinct` to see what distinct sample information we have.

```{r}
pasilla_tidy %>%
    distinct(.sample, condition, type)
```

We could use `rename` to rename a column. For example, to modify the type column name.

```{r}
pasilla_tidy %>%
    dplyr::rename(sequencing=type)
```

We could use `mutate` to create a column. For example, we could create a new type column that contains single
and paired instead of single_end and paired_end.

```{r}
pasilla_tidy %>%
    mutate(type=gsub("_end", "", type))
```

We could use `unite` to combine multiple columns into a single column.

```{r}
pasilla_tidy %>%
    unite("group", c(condition, type))
```

We can use `append_samples` to combine multiple SummarizedExperiment objects by samples. It is equivalent to `cbind` but it is a tidyverse-like function.

```{r}
# Create two subsets of the data
pasilla_subset1 <- pasilla_tidy %>%
    filter(condition == "untreated")

pasilla_subset2 <- pasilla_tidy %>%
    filter(condition == "treated")

# Combine them using append_samples
combined_data <- append_samples(pasilla_subset1, pasilla_subset2)
combined_data
```

We can also combine commands with the tidyverse pipe `%>%`.

For example, we could combine `group_by` and `summarise` to get the total counts for each sample.

```{r}
pasilla_tidy %>%
    group_by(.sample) %>%
    summarise(total_counts=sum(counts))
```

We could combine `group_by`, `mutate` and `filter` to get the transcripts with mean count > 0.

```{r}
pasilla_tidy %>%
    group_by(.feature) %>%
    mutate(mean_count=mean(counts)) %>%
    filter(mean_count > 0)
```


# Plotting

```{r}
my_theme <-
    list(
        scale_fill_brewer(palette="Set1"),
        scale_color_brewer(palette="Set1"),
        theme_bw() +
            theme(
                panel.border=element_blank(),
                axis.line=element_line(),
                panel.grid.major=element_line(size=0.2),
                panel.grid.minor=element_line(size=0.1),
                text=element_text(size=12),
                legend.position="bottom",
                aspect.ratio=1,
                strip.background=element_blank(),
                axis.title.x=element_text(margin=margin(t=10, r=10, b=10, l=10)),
                axis.title.y=element_text(margin=margin(t=10, r=10, b=10, l=10))
            )
    )
```

We can treat `pasilla_tidy` as a normal tibble for plotting.

Here we plot the distribution of counts per sample.

```{r plot1}
pasilla_tidy %>%
    ggplot(aes(counts + 1, group=.sample, color=`type`)) +
    geom_density() +
    scale_x_log10() +
    my_theme
```

# Session Info

```{r}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{extract}
\alias{extract}
\alias{extract.SummarizedExperiment}
\title{Extract a character column into multiple columns using regular
expression groups}
\usage{
\method{extract}{SummarizedExperiment}(
  data,
  col,
  into,
  regex = "([[:alnum:]]+)",
  remove = TRUE,
  convert = FALSE,
  ...
)
}
\arguments{
\item{data}{A data frame.}

\item{col}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> Column to expand.}

\item{into}{Names of new variables to create as character vector.
Use \code{NA} to omit the variable in the output.}

\item{regex}{A string representing a regular expression used to extract the
desired values. There should be one group (defined by \verb{()}) for each
element of \code{into}.}

\item{remove}{If \code{TRUE}, remove input column from output data frame.}

\item{convert}{If \code{TRUE}, will run \code{\link[=type.convert]{type.convert()}} with
\code{as.is = TRUE} on new columns. This is useful if the component
columns are integer, numeric or logical.

NB: this will cause string \code{"NA"}s to be converted to \code{NA}s.}

\item{...}{Additional arguments passed on to methods.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#superseded}{\figure{lifecycle-superseded.svg}{options: alt='[Superseded]'}}}{\strong{[Superseded]}}

\code{extract()} has been superseded in favour of \code{\link[tidyr:separate_wider_regex]{separate_wider_regex()}}
because it has a more polished API and better handling of problems.
Superseded functions will not go away, but will only receive critical bug
fixes.

Given a regular expression with capturing groups, \code{extract()} turns
each group into a new column. If the groups don't match, or the input
is NA, the output will be NA.
}
\examples{
tidySummarizedExperiment::pasilla |>
    extract(type, into="sequencing", regex="([a-z]*)_end", convert=TRUE)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}
\seealso{
\code{\link[tidyr:separate]{separate()}} to split up by a separator.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{summarise}
\alias{summarise}
\alias{summarise.SummarizedExperiment}
\alias{summarize}
\alias{summarize.SummarizedExperiment}
\title{Summarise each group down to one row}
\usage{
\method{summarise}{SummarizedExperiment}(.data, ...)

\method{summarize}{SummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Name-value pairs of
summary functions. The name will be the name of the variable in the result.

The value can be:
\itemize{
\item A vector of length 1, e.g. \code{min(x)}, \code{n()}, or \code{sum(is.na(y))}.
\item A data frame, to add multiple columns from a single expression.
}

\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} Returning values with size 0 or >1 was
deprecated as of 1.1.0. Please use \code{\link[dplyr:reframe]{reframe()}} for this instead.}
}
\value{
An object \emph{usually} of the same type as \code{.data}.
\itemize{
\item The rows come from the underlying \code{\link[dplyr:group_keys]{group_keys()}}.
\item The columns are a combination of the grouping keys and the summary
expressions that you provide.
\item The grouping structure is controlled by the \verb{.groups=} argument, the
output may be another \link[dplyr]{grouped_df}, a \link[dplyr]{tibble} or a \link[dplyr]{rowwise} data frame.
\item Data frame attributes are \strong{not} preserved, because \code{summarise()}
fundamentally creates a new data frame.
}
}
\description{
\code{summarise()} creates a new data frame. It returns one row for each
combination of grouping variables; if there are no grouping variables, the
output will have a single row summarising all observations in the input. It
will contain one column for each grouping variable and one column for each of
the summary statistics that you have specified.

\code{summarise()} and \code{summarize()} are synonyms.
}
\section{Useful functions}{


\itemize{
\item Center: \code{\link[=mean]{mean()}}, \code{\link[=median]{median()}}
\item Spread: \code{\link[=sd]{sd()}}, \code{\link[=IQR]{IQR()}}, \code{\link[=mad]{mad()}}
\item Range: \code{\link[=min]{min()}}, \code{\link[=max]{max()}},
\item Position: \code{\link[dplyr:first]{first()}}, \code{\link[dplyr:last]{last()}}, \code{\link[dplyr:nth]{nth()}},
\item Count: \code{\link[dplyr:n]{n()}}, \code{\link[dplyr:n_distinct]{n_distinct()}}
\item Logical: \code{\link[=any]{any()}}, \code{\link[=all]{all()}}
}

}

\section{Backend variations}{



The data frame backend supports creating a variable and using it in the
same summary. This means that previously created summary variables can be
further transformed or combined within the summary, as in \code{\link[dplyr:mutate]{mutate()}}.
However, it also means that summary variables with the same names as previous
variables overwrite them, making those variables unavailable to later summary
variables.

This behaviour may not be supported in other backends. To avoid unexpected
results, consider using new names for your summary variables, especially when
creating multiple summaries.

}

\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("summarise")}.

}

\examples{
data(pasilla)
pasilla |> summarise(mean(counts))

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link{mutate}()},
\code{\link{rename}()},
\code{\link{slice}()}
}
\concept{single table verbs}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{group_by}
\alias{group_by}
\alias{group_by.SummarizedExperiment}
\title{Group by one or more variables}
\usage{
\method{group_by}{SummarizedExperiment}(.data, ..., .add = FALSE, .drop = group_by_drop_default(.data))
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{In \code{group_by()}, variables or computations to group by.
Computations are always done on the ungrouped data frame.
To perform computations on the grouped data, you need to use
a separate \code{mutate()} step before the \code{group_by()}.
Computations are not allowed in \code{nest_by()}.
In \code{ungroup()}, variables to remove from the grouping.}

\item{.add}{When \code{FALSE}, the default, \code{group_by()} will
override existing groups. To add to the existing groups, use
\code{.add = TRUE}.

This argument was previously called \code{add}, but that prevented
creating a new grouping variable called \code{add}, and conflicts with
our naming conventions.}

\item{.drop}{Drop groups formed by factor levels that don't appear in the
data? The default is \code{TRUE} except when \code{.data} has been previously
grouped with \code{.drop = FALSE}. See \code{\link[dplyr:group_by_drop_default]{group_by_drop_default()}} for details.}
}
\value{
A grouped data frame with class \code{\link[dplyr]{grouped_df}},
unless the combination of \code{...} and \code{add} yields a empty set of
grouping columns, in which case a tibble will be returned.
}
\description{
Most data operations are done on groups defined by variables.
\code{group_by()} takes an existing tbl and converts it into a grouped tbl
where operations are performed "by group". \code{ungroup()} removes grouping.
}
\section{Methods}{


These function are \strong{generic}s, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

Methods available in currently loaded packages:
\itemize{
\item \code{group_by()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("group_by")}.
\item \code{ungroup()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("ungroup")}.
}

}

\section{Ordering}{


Currently, \code{group_by()} internally orders the groups in ascending order. This
results in ordered output from functions that aggregate groups, such as
\code{\link[dplyr:summarise]{summarise()}}.

When used as grouping columns, character vectors are ordered in the C locale
for performance and reproducibility across R sessions. If the resulting
ordering of your grouped operation matters and is dependent on the locale,
you should follow up the grouped operation with an explicit call to
\code{\link[dplyr:arrange]{arrange()}} and set the \code{.locale} argument. For example:

\if{html}{\out{<div class="sourceCode">}}\preformatted{data \%>\%
  group_by(chr) \%>\%
  summarise(avg = mean(x)) \%>\%
  arrange(chr, .locale = "en")
}\if{html}{\out{</div>}}

This is often useful as a preliminary step before generating content intended
for humans, such as an HTML table.
\subsection{Legacy behavior}{

Prior to dplyr 1.1.0, character vector grouping columns were ordered in the
system locale. If you need to temporarily revert to this behavior, you can
set the global option \code{dplyr.legacy_locale} to \code{TRUE}, but this should be
used sparingly and you should expect this option to be removed in a future
version of dplyr. It is better to update existing code to explicitly call
\code{arrange(.locale = )} instead. Note that setting \code{dplyr.legacy_locale} will
also force calls to \code{\link[dplyr:arrange]{arrange()}} to use the system locale.
}

}

\examples{
data(pasilla)
pasilla  |> group_by(.sample)
    
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other grouping functions: 
\code{\link[dplyr]{group_map}()},
\code{\link[dplyr]{group_nest}()},
\code{\link[dplyr]{group_split}()},
\code{\link[dplyr]{group_trim}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{pivot_wider}
\alias{pivot_wider}
\alias{pivot_wider.SummarizedExperiment}
\title{Pivot data from long to wide}
\usage{
\method{pivot_wider}{SummarizedExperiment}(
  data,
  ...,
  id_cols = NULL,
  id_expand = FALSE,
  names_from = name,
  names_prefix = "",
  names_sep = "_",
  names_glue = NULL,
  names_sort = FALSE,
  names_vary = "fastest",
  names_expand = FALSE,
  names_repair = "check_unique",
  values_from = value,
  values_fill = NULL,
  values_fn = NULL,
  unused_fn = NULL
)
}
\arguments{
\item{data}{A data frame to pivot.}

\item{...}{Additional arguments passed on to methods.}

\item{id_cols}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> A set of columns that
uniquely identify each observation. Typically used when you have
redundant variables, i.e. variables whose values are perfectly correlated
with existing variables.

Defaults to all columns in \code{data} except for the columns specified through
\code{names_from} and \code{values_from}. If a tidyselect expression is supplied, it
will be evaluated on \code{data} after removing the columns specified through
\code{names_from} and \code{values_from}.}

\item{id_expand}{Should the values in the \code{id_cols} columns be expanded by
\code{\link[tidyr:expand]{expand()}} before pivoting? This results in more rows, the output will
contain a complete expansion of all possible values in \code{id_cols}. Implicit
factor levels that aren't represented in the data will become explicit.
Additionally, the row values corresponding to the expanded \code{id_cols} will
be sorted.}

\item{names_from, values_from}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> A pair of
arguments describing which column (or columns) to get the name of the
output column (\code{names_from}), and which column (or columns) to get the
cell values from (\code{values_from}).

If \code{values_from} contains multiple values, the value will be added to the
front of the output column.}

\item{names_prefix}{String added to the start of every variable name. This is
particularly useful if \code{names_from} is a numeric vector and you want to
create syntactic variable names.}

\item{names_sep}{If \code{names_from} or \code{values_from} contains multiple
variables, this will be used to join their values together into a single
string to use as a column name.}

\item{names_glue}{Instead of \code{names_sep} and \code{names_prefix}, you can supply
a glue specification that uses the \code{names_from} columns (and special
\code{.value}) to create custom column names.}

\item{names_sort}{Should the column names be sorted? If \code{FALSE}, the default,
column names are ordered by first appearance.}

\item{names_vary}{When \code{names_from} identifies a column (or columns) with
multiple unique values, and multiple \code{values_from} columns are provided,
in what order should the resulting column names be combined?
\itemize{
\item \code{"fastest"} varies \code{names_from} values fastest, resulting in a column
naming scheme of the form: \verb{value1_name1, value1_name2, value2_name1, value2_name2}. This is the default.
\item \code{"slowest"} varies \code{names_from} values slowest, resulting in a column
naming scheme of the form: \verb{value1_name1, value2_name1, value1_name2, value2_name2}.
}}

\item{names_expand}{Should the values in the \code{names_from} columns be expanded
by \code{\link[tidyr:expand]{expand()}} before pivoting? This results in more columns, the output
will contain column names corresponding to a complete expansion of all
possible values in \code{names_from}. Implicit factor levels that aren't
represented in the data will become explicit. Additionally, the column
names will be sorted, identical to what \code{names_sort} would produce.}

\item{names_repair}{What happens if the output has invalid column names?
The default, \code{"check_unique"} is to error if the columns are duplicated.
Use \code{"minimal"} to allow duplicates in the output, or \code{"unique"} to
de-duplicated by adding numeric suffixes. See \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}
for more options.}

\item{values_fill}{Optionally, a (scalar) value that specifies what each
\code{value} should be filled in with when missing.

This can be a named list if you want to apply different fill values to
different value columns.}

\item{values_fn}{Optionally, a function applied to the value in each cell
in the output. You will typically use this when the combination of
\code{id_cols} and \code{names_from} columns does not uniquely identify an
observation.

This can be a named list if you want to apply different aggregations
to different \code{values_from} columns.}

\item{unused_fn}{Optionally, a function applied to summarize the values from
the unused columns (i.e. columns not identified by \code{id_cols},
\code{names_from}, or \code{values_from}).

The default drops all unused columns from the result.

This can be a named list if you want to apply different aggregations
to different unused columns.

\code{id_cols} must be supplied for \code{unused_fn} to be useful, since otherwise
all unspecified columns will be considered \code{id_cols}.

This is similar to grouping by the \code{id_cols} then summarizing the
unused columns using \code{unused_fn}.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
\code{pivot_wider()} "widens" data, increasing the number of columns and
decreasing the number of rows. The inverse transformation is
\code{\link[tidyr:pivot_longer]{pivot_longer()}}.

Learn more in \code{vignette("pivot")}.
}
\details{
\code{pivot_wider()} is an updated approach to \code{\link[tidyr:spread]{spread()}}, designed to be both
simpler to use and to handle more use cases. We recommend you use
\code{pivot_wider()} for new code; \code{spread()} isn't going away but is no longer
under active development.
}
\examples{
# See vignette("pivot") for examples and explanation
library(dplyr)
tidySummarizedExperiment::pasilla \%>\%
    pivot_wider(names_from=feature, values_from=counts)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}
\seealso{
\code{\link[tidyr:pivot_wider_spec]{pivot_wider_spec()}} to pivot "by hand" with a data frame that
defines a pivoting specification.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mutate.R
\name{mutate}
\alias{mutate}
\alias{mutate.SummarizedExperiment}
\title{Create, modify, and delete columns}
\usage{
\method{mutate}{SummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Name-value pairs.
The name gives the name of the column in the output.

The value can be:
\itemize{
\item A vector of length 1, which will be recycled to the correct length.
\item A vector the same length as the current group (or the whole data frame
if ungrouped).
\item \code{NULL}, to remove the column.
\item A data frame or tibble, to create multiple columns in the output.
}}
}
\value{
An object of the same type as \code{.data}. The output has the following
properties:
\itemize{
\item Columns from \code{.data} will be preserved according to the \code{.keep} argument.
\item Existing columns that are modified by \code{...} will always be returned in
their original location.
\item New columns created through \code{...} will be placed according to the
\code{.before} and \code{.after} arguments.
\item The number of rows is not affected.
\item Columns given the value \code{NULL} will be removed.
\item Groups will be recomputed if a grouping variable is mutated.
\item Data frame attributes are preserved.
}
}
\description{
\code{mutate()} creates new columns that are functions of existing variables.
It can also modify (if the name is the same as an existing
column) and delete columns (by setting their value to \code{NULL}).
}
\section{Useful mutate functions}{


\itemize{
\item \code{\link{+}}, \code{\link{-}}, \code{\link[=log]{log()}}, etc., for their usual mathematical meanings
\item \code{\link[dplyr:lead]{lead()}}, \code{\link[dplyr:lag]{lag()}}
\item \code{\link[dplyr:dense_rank]{dense_rank()}}, \code{\link[dplyr:min_rank]{min_rank()}}, \code{\link[dplyr:percent_rank]{percent_rank()}}, \code{\link[dplyr:row_number]{row_number()}},
\code{\link[dplyr:cume_dist]{cume_dist()}}, \code{\link[dplyr:ntile]{ntile()}}
\item \code{\link[=cumsum]{cumsum()}}, \code{\link[dplyr:cummean]{cummean()}}, \code{\link[=cummin]{cummin()}}, \code{\link[=cummax]{cummax()}}, \code{\link[dplyr:cumany]{cumany()}}, \code{\link[dplyr:cumall]{cumall()}}
\item \code{\link[dplyr:na_if]{na_if()}}, \code{\link[dplyr:coalesce]{coalesce()}}
\item \code{\link[dplyr:if_else]{if_else()}}, \code{\link[dplyr:recode]{recode()}}, \code{\link[dplyr:case_when]{case_when()}}
}

}

\section{Grouped tibbles}{



Because mutating expressions are computed within groups, they may
yield different results on grouped tibbles. This will be the case
as soon as an aggregating, lagging, or ranking function is
involved. Compare this ungrouped mutate:

\if{html}{\out{<div class="sourceCode">}}\preformatted{starwars \%>\%
  select(name, mass, species) \%>\%
  mutate(mass_norm = mass / mean(mass, na.rm = TRUE))
}\if{html}{\out{</div>}}

With the grouped equivalent:

\if{html}{\out{<div class="sourceCode">}}\preformatted{starwars \%>\%
  select(name, mass, species) \%>\%
  group_by(species) \%>\%
  mutate(mass_norm = mass / mean(mass, na.rm = TRUE))
}\if{html}{\out{</div>}}

The former normalises \code{mass} by the global average whereas the
latter normalises by the averages within species levels.

}

\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

Methods available in currently loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("mutate")}.

}

\examples{
data(pasilla)
pasilla |> mutate(logcounts=log2(counts))

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link{rename}()},
\code{\link{slice}()},
\code{\link{summarise}()}
}
\concept{single table verbs}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{pivot_longer}
\alias{pivot_longer}
\alias{pivot_longer.SummarizedExperiment}
\title{Pivot data from wide to long}
\usage{
\method{pivot_longer}{SummarizedExperiment}(
  data,
  cols,
  ...,
  cols_vary = "fastest",
  names_to = "name",
  names_prefix = NULL,
  names_sep = NULL,
  names_pattern = NULL,
  names_ptypes = NULL,
  names_transform = NULL,
  names_repair = "check_unique",
  values_to = "value",
  values_drop_na = FALSE,
  values_ptypes = NULL,
  values_transform = NULL
)
}
\arguments{
\item{data}{A data frame to pivot.}

\item{cols}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> Columns to pivot into
longer format.}

\item{...}{Additional arguments passed on to methods.}

\item{cols_vary}{When pivoting \code{cols} into longer format, how should the
output rows be arranged relative to their original row number?
\itemize{
\item \code{"fastest"}, the default, keeps individual rows from \code{cols} close
together in the output. This often produces intuitively ordered output
when you have at least one key column from \code{data} that is not involved in
the pivoting process.
\item \code{"slowest"} keeps individual columns from \code{cols} close together in the
output. This often produces intuitively ordered output when you utilize
all of the columns from \code{data} in the pivoting process.
}}

\item{names_to}{A character vector specifying the new column or columns to
create from the information stored in the column names of \code{data} specified
by \code{cols}.
\itemize{
\item If length 0, or if \code{NULL} is supplied, no columns will be created.
\item If length 1, a single column will be created which will contain the
column names specified by \code{cols}.
\item If length >1, multiple columns will be created. In this case, one of
\code{names_sep} or \code{names_pattern} must be supplied to specify how the
column names should be split. There are also two additional character
values you can take advantage of:
\itemize{
\item \code{NA} will discard the corresponding component of the column name.
\item \code{".value"} indicates that the corresponding component of the column
name defines the name of the output column containing the cell values,
overriding \code{values_to} entirely.
}
}}

\item{names_prefix}{A regular expression used to remove matching text
from the start of each variable name.}

\item{names_sep, names_pattern}{If \code{names_to} contains multiple values,
these arguments control how the column name is broken up.

\code{names_sep} takes the same specification as \code{\link[tidyr:separate]{separate()}}, and can either
be a numeric vector (specifying positions to break on), or a single string
(specifying a regular expression to split on).

\code{names_pattern} takes the same specification as \code{\link[tidyr:extract]{extract()}}, a regular
expression containing matching groups (\verb{()}).

If these arguments do not give you enough control, use
\code{pivot_longer_spec()} to create a spec object and process manually as
needed.}

\item{names_ptypes, values_ptypes}{Optionally, a list of column name-prototype
pairs. Alternatively, a single empty prototype can be supplied, which will
be applied to all columns. A prototype (or ptype for short) is a
zero-length vector (like \code{integer()} or \code{numeric()}) that defines the type,
class, and attributes of a vector. Use these arguments if you want to
confirm that the created columns are the types that you expect. Note that
if you want to change (instead of confirm) the types of specific columns,
you should use \code{names_transform} or \code{values_transform} instead.}

\item{names_transform, values_transform}{Optionally, a list of column
name-function pairs. Alternatively, a single function can be supplied,
which will be applied to all columns. Use these arguments if you need to
change the types of specific columns. For example, \code{names_transform = list(week = as.integer)} would convert a character variable called \code{week}
to an integer.

If not specified, the type of the columns generated from \code{names_to} will
be character, and the type of the variables generated from \code{values_to}
will be the common type of the input columns used to generate them.}

\item{names_repair}{What happens if the output has invalid column names?
The default, \code{"check_unique"} is to error if the columns are duplicated.
Use \code{"minimal"} to allow duplicates in the output, or \code{"unique"} to
de-duplicated by adding numeric suffixes. See \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}
for more options.}

\item{values_to}{A string specifying the name of the column to create
from the data stored in cell values. If \code{names_to} is a character
containing the special \code{.value} sentinel, this value will be ignored,
and the name of the value column will be derived from part of the
existing column names.}

\item{values_drop_na}{If \code{TRUE}, will drop rows that contain only \code{NA}s
in the \code{value_to} column. This effectively converts explicit missing values
to implicit missing values, and should generally be used only when missing
values in \code{data} were created by its structure.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
\code{pivot_longer()} "lengthens" data, increasing the number of rows and
decreasing the number of columns. The inverse transformation is
\code{\link[tidyr:pivot_wider]{pivot_wider()}}

Learn more in \code{vignette("pivot")}.
}
\details{
\code{pivot_longer()} is an updated approach to \code{\link[tidyr:gather]{gather()}}, designed to be both
simpler to use and to handle more use cases. We recommend you use
\code{pivot_longer()} for new code; \code{gather()} isn't going away but is no longer
under active development.
}
\examples{
# See vignette("pivot") for examples and explanation
library(dplyr)
tidySummarizedExperiment::pasilla \%>\%
    pivot_longer(c(condition, type),
        names_to="name", values_to="value")

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{group_split}
\alias{group_split}
\alias{group_split.SummarizedExperiment}
\title{Split data frame by groups}
\usage{
\method{group_split}{SummarizedExperiment}(.tbl, ..., .keep = TRUE)
}
\arguments{
\item{.tbl}{A tbl.}

\item{...}{If \code{.tbl} is an ungrouped data frame, a grouping specification,
forwarded to \code{\link[dplyr:group_by]{group_by()}}.}

\item{.keep}{Should the grouping columns be kept?}
}
\value{
A list of tibbles. Each tibble contains the rows of \code{.tbl} for the
associated group and all the columns, including the grouping variables.
Note that this returns a \link[vctrs:list_of]{list_of} which is slightly
stricter than a simple list but is useful for representing lists where
every element has the same type.
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

\code{\link[dplyr:group_split]{group_split()}} works like \code{\link[base:split]{base::split()}} but:
\itemize{
\item It uses the grouping structure from \code{\link[dplyr:group_by]{group_by()}} and therefore is subject
to the data mask
\item It does not name the elements of the list based on the grouping as this
only works well for a single character grouping variable. Instead,
use \code{\link[dplyr:group_keys]{group_keys()}} to access a data frame that defines the groups.
}

\code{group_split()} is primarily designed to work with grouped data frames.
You can pass \code{...} to group and split an ungrouped data frame, but this
is generally not very useful as you want have easy access to the group
metadata.
}
\section{Lifecycle}{


\code{group_split()} is not stable because you can achieve very similar results by
manipulating the nested column returned from
\code{\link[tidyr:nest]{tidyr::nest(.by =)}}. That also retains the group keys all
within a single data structure. \code{group_split()} may be deprecated in the
future.

}

\examples{
data(pasilla, package = "tidySummarizedExperiment")
pasilla |> group_split(condition)
pasilla |> group_split(counts > 0)
pasilla |> group_split(condition, counts > 0)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other grouping functions: 
\code{\link[dplyr]{group_by}()},
\code{\link[dplyr]{group_map}()},
\code{\link[dplyr]{group_nest}()},
\code{\link[dplyr]{group_trim}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/join.R
\name{inner_join}
\alias{inner_join}
\alias{inner_join.SummarizedExperiment}
\title{Mutating joins}
\usage{
\method{inner_join}{SummarizedExperiment}(x, y, by = NULL, copy = FALSE, suffix = c(".x", ".y"), ...)
}
\arguments{
\item{x, y}{A pair of data frames, data frame extensions (e.g. a tibble), or
lazy data frames (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{by}{A join specification created with \code{\link[dplyr:join_by]{join_by()}}, or a character
vector of variables to join by.

If \code{NULL}, the default, \verb{*_join()} will perform a natural join, using all
variables in common across \code{x} and \code{y}. A message lists the variables so
that you can check they're correct; suppress the message by supplying \code{by}
explicitly.

To join on different variables between \code{x} and \code{y}, use a \code{\link[dplyr:join_by]{join_by()}}
specification. For example, \code{join_by(a == b)} will match \code{x$a} to \code{y$b}.

To join by multiple variables, use a \code{\link[dplyr:join_by]{join_by()}} specification with
multiple expressions. For example, \code{join_by(a == b, c == d)} will match
\code{x$a} to \code{y$b} and \code{x$c} to \code{y$d}. If the column names are the same between
\code{x} and \code{y}, you can shorten this by listing only the variable names, like
\code{join_by(a, c)}.

\code{\link[dplyr:join_by]{join_by()}} can also be used to perform inequality, rolling, and overlap
joins. See the documentation at \link[dplyr:join_by]{?join_by} for details on
these types of joins.

For simple equality joins, you can alternatively specify a character vector
of variable names to join by. For example, \code{by = c("a", "b")} joins \code{x$a}
to \code{y$a} and \code{x$b} to \code{y$b}. If variable names differ between \code{x} and \code{y},
use a named character vector like \code{by = c("x_a" = "y_a", "x_b" = "y_b")}.

To perform a cross-join, generating all combinations of \code{x} and \code{y}, see
\code{\link[dplyr:cross_join]{cross_join()}}.}

\item{copy}{If \code{x} and \code{y} are not from the same data source,
and \code{copy} is \code{TRUE}, then \code{y} will be copied into the
same src as \code{x}.  This allows you to join tables across srcs, but
it is a potentially expensive operation so you must opt into it.}

\item{suffix}{If there are non-joined duplicate variables in \code{x} and
\code{y}, these suffixes will be added to the output to disambiguate them.
Should be a character vector of length 2.}

\item{...}{Other parameters passed onto methods.}
}
\value{
An object of the same type as \code{x} (including the same groups). The order of
the rows and columns of \code{x} is preserved as much as possible. The output has
the following properties:
\itemize{
\item The rows are affect by the join type.
\itemize{
\item \code{inner_join()} returns matched \code{x} rows.
\item \code{left_join()} returns all \code{x} rows.
\item \code{right_join()}  returns matched of \code{x} rows, followed by unmatched \code{y} rows.
\item \code{full_join()}  returns all \code{x} rows, followed by unmatched \code{y} rows.
}
\item Output columns include all columns from \code{x} and all non-key columns from
\code{y}. If \code{keep = TRUE}, the key columns from \code{y} are included as well.
\item If non-key columns in \code{x} and \code{y} have the same name, \code{suffix}es are added
to disambiguate. If \code{keep = TRUE} and key columns in \code{x} and \code{y} have
the same name, \code{suffix}es are added to disambiguate these as well.
\item If \code{keep = FALSE}, output columns included in \code{by} are coerced to their
common type between \code{x} and \code{y}.
}
}
\description{
Mutating joins add columns from \code{y} to \code{x}, matching observations based on
the keys. There are four mutating joins: the inner join, and the three outer
joins.
\subsection{Inner join}{

An \code{inner_join()} only keeps observations from \code{x} that have a matching key
in \code{y}.

The most important property of an inner join is that unmatched rows in either
input are not included in the result. This means that generally inner joins
are not appropriate in most analyses, because it is too easy to lose
observations.
}

\subsection{Outer joins}{

The three outer joins keep observations that appear in at least one of the
data frames:
\itemize{
\item A \code{left_join()} keeps all observations in \code{x}.
\item A \code{right_join()} keeps all observations in \code{y}.
\item A \code{full_join()} keeps all observations in \code{x} and \code{y}.
}
}
}
\section{Many-to-many relationships}{



By default, dplyr guards against many-to-many relationships in equality joins
by throwing a warning. These occur when both of the following are true:
\itemize{
\item A row in \code{x} matches multiple rows in \code{y}.
\item A row in \code{y} matches multiple rows in \code{x}.
}

This is typically surprising, as most joins involve a relationship of
one-to-one, one-to-many, or many-to-one, and is often the result of an
improperly specified join. Many-to-many relationships are particularly
problematic because they can result in a Cartesian explosion of the number of
rows returned from the join.

If a many-to-many relationship is expected, silence this warning by
explicitly setting \code{relationship = "many-to-many"}.

In production code, it is best to preemptively set \code{relationship} to whatever
relationship you expect to exist between the keys of \code{x} and \code{y}, as this
forces an error to occur immediately if the data doesn't align with your
expectations.

Inequality joins typically result in many-to-many relationships by nature, so
they don't warn on them by default, but you should still take extra care when
specifying an inequality join, because they also have the capability to
return a large number of rows.

Rolling joins don't warn on many-to-many relationships either, but many
rolling joins follow a many-to-one relationship, so it is often useful to
set \code{relationship = "many-to-one"} to enforce this.

Note that in SQL, most database providers won't let you specify a
many-to-many relationship between two tables, instead requiring that you
create a third \emph{junction table} that results in two one-to-many relationships
instead.

}

\section{Methods}{


These functions are \strong{generic}s, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

Methods available in currently loaded packages:
\itemize{
\item \code{inner_join()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("inner_join")}.
\item \code{left_join()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("left_join")}.
\item \code{right_join()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("right_join")}.
\item \code{full_join()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("full_join")}.
}

}

\examples{
data(pasilla)

tt <- pasilla 
tt |> inner_join(tt |>
    distinct(condition) |>
    mutate(new_column=1:2) |>
    slice(1))

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other joins: 
\code{\link[dplyr]{cross_join}()},
\code{\link[dplyr]{filter-joins}},
\code{\link[dplyr]{nest_join}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{slice}
\alias{slice}
\alias{slice.SummarizedExperiment}
\alias{slice_head}
\alias{slice_tail}
\alias{slice_sample}
\alias{slice_min}
\alias{slice_max}
\title{Subset rows using their positions}
\usage{
\method{slice}{SummarizedExperiment}(.data, ..., .preserve = FALSE)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{For \code{slice()}: <\code{\link[rlang:args_data_masking]{data-masking}}>
Integer row values.

Provide either positive values to keep, or negative values to drop.
The values provided must be either all positive or all negative.
Indices beyond the number of rows in the input are silently ignored.

For \verb{slice_*()}, these arguments are passed on to methods.}

\item{.preserve}{Relevant when the \code{.data} input is grouped.
If \code{.preserve = FALSE} (the default), the grouping structure
is recalculated based on the resulting data, otherwise the grouping is kept as is.}
}
\value{
An object of the same type as \code{.data}. The output has the following
properties:
\itemize{
\item Each row may appear 0, 1, or many times in the output.
\item Columns are not modified.
\item Groups are not modified.
\item Data frame attributes are preserved.
}
}
\description{
\code{slice()} lets you index rows by their (integer) locations. It allows you
to select, remove, and duplicate rows. It is accompanied by a number of
helpers for common use cases:
\itemize{
\item \code{slice_head()} and \code{slice_tail()} select the first or last rows.
\item \code{slice_sample()} randomly selects rows.
\item \code{slice_min()} and \code{slice_max()} select rows with the smallest or largest
values of a variable.
}

If \code{.data} is a \link[dplyr]{grouped_df}, the operation will be performed on each group,
so that (e.g.) \code{slice_head(df, n = 5)} will select the first five rows in
each group.
}
\details{
Slice does not work with relational databases because they have no
intrinsic notion of row order. If you want to perform the equivalent
operation, use \code{\link[dplyr:filter]{filter()}} and \code{\link[dplyr:row_number]{row_number()}}.
}
\section{Methods}{


These function are \strong{generic}s, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

Methods available in currently loaded packages:
\itemize{
\item \code{slice()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice")}.
\item \code{slice_head()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice_head")}.
\item \code{slice_tail()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice_tail")}.
\item \code{slice_min()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice_min")}.
\item \code{slice_max()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice_max")}.
\item \code{slice_sample()}: \Sexpr[stage=render,results=rd]{dplyr:::methods_rd("slice_sample")}.
}

}

\examples{
data(pasilla)
pasilla |> slice(1)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link{mutate}()},
\code{\link{rename}()},
\code{\link{summarise}()}
}
\concept{single table verbs}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{count}
\alias{count}
\alias{count.SummarizedExperiment}
\title{Count the observations in each group}
\usage{
\method{count}{SummarizedExperiment}(
  x,
  ...,
  wt = NULL,
  sort = FALSE,
  name = NULL,
  .drop = group_by_drop_default(x)
)
}
\arguments{
\item{x}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr).}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Variables to group
by.}

\item{wt}{<\code{\link[rlang:args_data_masking]{data-masking}}> Frequency weights.
Can be \code{NULL} or a variable:
\itemize{
\item If \code{NULL} (the default), counts the number of rows in each group.
\item If a variable, computes \code{sum(wt)} for each group.
}}

\item{sort}{If \code{TRUE}, will show the largest groups at the top.}

\item{name}{The name of the new column in the output.

If omitted, it will default to \code{n}. If there's already a column called \code{n},
it will use \code{nn}. If there's a column called \code{n} and \code{nn}, it'll use
\code{nnn}, and so on, adding \code{n}s until it gets a new name.}

\item{.drop}{Handling of factor levels that don't appear in the data, passed
on to \code{\link[dplyr:group_by]{group_by()}}.

For \code{count()}: if \code{FALSE} will include counts for empty groups (i.e. for
levels of factors that don't exist in the data).

\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} For \code{add_count()}: deprecated since it
can't actually affect the output.}
}
\value{
An object of the same type as \code{.data}. \code{count()} and \code{add_count()}
group transiently, so the output has the same groups as the input.
}
\description{
\code{count()} lets you quickly count the unique values of one or more variables:
\code{df \%>\% count(a, b)} is roughly equivalent to
\code{df \%>\% group_by(a, b) \%>\% summarise(n = n())}.
\code{count()} is paired with \code{tally()}, a lower-level helper that is equivalent
to \code{df \%>\% summarise(n = n())}. Supply \code{wt} to perform weighted counts,
switching the summary from \code{n = n()} to \code{n = sum(wt)}.

\code{add_count()} and \code{add_tally()} are equivalents to \code{count()} and \code{tally()}
but use \code{mutate()} instead of \code{summarise()} so that they add a new column
with group-wise counts.
}
\examples{
data(se)
se |> count(dex)
    
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{pull}
\alias{pull}
\alias{pull.SummarizedExperiment}
\title{Extract a single column}
\usage{
\method{pull}{SummarizedExperiment}(.data, var = -1, name = NULL, ...)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{var}{A variable specified as:
\itemize{
\item a literal variable name
\item a positive integer, giving the position counting from the left
\item a negative integer, giving the position counting from the right.
}

The default returns the last column (on the assumption that's the
column you've created most recently).

This argument is taken by expression and supports
\link[rlang:topic-inject]{quasiquotation} (you can unquote column
names and column locations).}

\item{name}{An optional parameter that specifies the column to be used
as names for a named vector. Specified in a similar manner as \code{var}.}

\item{...}{For use by methods.}
}
\value{
A vector the same size as \code{.data}.
}
\description{
\code{pull()} is similar to \code{$}. It's mostly useful because it looks a little
nicer in pipes, it also works with remote data frames, and it can optionally
name the output.
}
\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("pull")}.

}

\examples{
data(pasilla)
pasilla |> pull(feature)
    
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tibble_methods.R
\name{as_tibble}
\alias{as_tibble}
\alias{as_tibble.SummarizedExperiment}
\title{Coerce lists, matrices, and more to data frames}
\usage{
\method{as_tibble}{SummarizedExperiment}(
  x,
  ...,
  .name_repair = c("check_unique", "unique", "universal", "minimal"),
  rownames = pkgconfig::get_config("tibble::rownames", NULL)
)
}
\arguments{
\item{x}{A data frame, list, matrix, or other object that could reasonably be
coerced to a tibble.}

\item{...}{Unused, for extensibility.}

\item{.name_repair}{Treatment of problematic column names:
\itemize{
\item \code{"minimal"}: No name repair or checks, beyond basic existence,
\item \code{"unique"}: Make sure names are unique and not empty,
\item \code{"check_unique"}: (default value), no name repair, but check they are
\code{unique},
\item \code{"universal"}: Make the names \code{unique} and syntactic
\item \code{"unique_quiet"}: Same as \code{"unique"}, but "quiet"
\item \code{"universal_quiet"}: Same as \code{"universal"}, but "quiet"
\item a function: apply custom name repair (e.g., \code{.name_repair = make.names}
for names in the style of base R).
\item A purrr-style anonymous function, see \code{\link[rlang:as_function]{rlang::as_function()}}
}

This argument is passed on as \code{repair} to \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}.
See there for more details on these terms and the strategies used
to enforce them.}

\item{rownames}{How to treat existing row names of a data frame or matrix:
\itemize{
\item \code{NULL}: remove row names. This is the default.
\item \code{NA}: keep row names.
\item A string: the name of a new column. Existing rownames are transferred
into this column and the \code{row.names} attribute is deleted.
No name repair is applied to the new column name, even if \code{x} already contains
a column of that name.
Use \code{as_tibble(rownames_to_column(...))} to safeguard against this case.
}

Read more in \link[tibble]{rownames}.}
}
\value{
\code{tibble}
}
\description{
\code{as_tibble()} turns an existing object, such as a data frame or
matrix, into a so-called tibble, a data frame with class \code{\link[tibble]{tbl_df}}. This is
in contrast with \code{\link[tibble:tibble]{tibble()}}, which builds a tibble from individual columns.
\code{as_tibble()} is to \code{\link[tibble:tibble]{tibble()}} as \code{\link[base:as.data.frame]{base::as.data.frame()}} is to
\code{\link[base:data.frame]{base::data.frame()}}.

\code{as_tibble()} is an S3 generic, with methods for:
\itemize{
\item \code{\link[base:data.frame]{data.frame}}: Thin wrapper around the \code{list} method
that implements tibble's treatment of \link[tibble]{rownames}.
\item \code{\link[base:matrix]{matrix}}, \code{\link[stats:poly]{poly}},
\code{\link[stats:ts]{ts}}, \code{\link[base:table]{table}}
\item Default: Other inputs are first coerced with \code{\link[base:as.data.frame]{base::as.data.frame()}}.
}

\code{as_tibble_row()} converts a vector to a tibble with one row.
If the input is a list, all elements must have size one.

\code{as_tibble_col()} converts a vector to a tibble with one column.
}
\section{Row names}{


The default behavior is to silently remove row names.

New code should explicitly convert row names to a new column using the
\code{rownames} argument.

For existing code that relies on the retention of row names, call
\code{pkgconfig::set_config("tibble::rownames" = NA)} in your script or in your
package's \code{\link[=.onLoad]{.onLoad()}}  function.

}

\section{Life cycle}{


Using \code{as_tibble()} for vectors is superseded as of version 3.0.0,
prefer the more expressive \code{as_tibble_row()} and
\code{as_tibble_col()} variants for new code.

}

\examples{
tidySummarizedExperiment::pasilla \%>\%
    as_tibble()
    
tidySummarizedExperiment::pasilla \%>\%
    as_tibble(.subset=-c(condition, type))

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Müller, K., Wickham, H. (2023). tibble: Simple Data Frames. R package version 3.2.1, https://CRAN.R-project.org/package=tibble
}
\seealso{
\code{\link[tibble:tibble]{tibble()}} constructs a tibble from individual columns. \code{\link[tibble:enframe]{enframe()}}
converts a named vector to a tibble with a column of names and column of
values. Name repair is implemented using \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{rowwise}
\alias{rowwise}
\alias{rowwise.SummarizedExperiment}
\title{Group input by rows}
\usage{
\method{rowwise}{SummarizedExperiment}(data, ...)
}
\arguments{
\item{data}{Input data frame.}

\item{...}{<\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> Variables to be preserved
when calling \code{\link[dplyr:summarise]{summarise()}}. This is typically a set of variables whose
combination uniquely identify each row.

\strong{NB}: unlike \code{group_by()} you can not create new variables here but
instead you can select multiple variables with (e.g.) \code{everything()}.}
}
\value{
A row-wise data frame with class \code{rowwise_df}. Note that a
\code{rowwise_df} is implicitly grouped by row, but is not a \code{grouped_df}.
}
\description{
\code{rowwise()} allows you to compute on a data frame a row-at-a-time.
This is most useful when a vectorised function doesn't exist.

Most dplyr verbs preserve row-wise grouping. The exception is \code{\link[dplyr:summarise]{summarise()}},
which return a \link[dplyr]{grouped_df}. You can explicitly ungroup with \code{\link[dplyr:ungroup]{ungroup()}}
or \code{\link[dplyr:as_tibble]{as_tibble()}}, or convert to a \link[dplyr]{grouped_df} with \code{\link[dplyr:group_by]{group_by()}}.
}
\section{List-columns}{


Because a rowwise has exactly one row per group it offers a small
convenience for working with list-columns. Normally, \code{summarise()} and
\code{mutate()} extract a groups worth of data with \code{[}. But when you index
a list in this way, you get back another list. When you're working with
a \code{rowwise} tibble, then dplyr will use \code{[[} instead of \code{[} to make your
life a little easier.

}

\examples{
# TODO

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
\code{\link[dplyr:nest_by]{nest_by()}} for a convenient way of creating rowwise data frames
with nested data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{append_samples}
\alias{append_samples}
\alias{append_samples.SummarizedExperiment}
\title{Append samples from multiple SummarizedExperiment objects}
\usage{
\method{append_samples}{SummarizedExperiment}(x, ..., .id = NULL)
}
\arguments{
\item{x}{First SummarizedExperiment object to combine}

\item{...}{Additional SummarizedExperiment objects to combine by samples}

\item{.id}{Object identifier (currently not used)}
}
\value{
A combined SummarizedExperiment object
}
\description{
Append samples from multiple SummarizedExperiment objects by column-binding them.
This function is equivalent to \code{cbind} but provides a tidyverse-like interface.
}
\examples{
data(se)
append_samples(se, se)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/select.R
\name{select}
\alias{select}
\alias{select.SummarizedExperiment}
\title{Keep or drop columns using their names and types}
\usage{
\method{select}{SummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{<\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> One or more unquoted
expressions separated by commas. Variable names can be used as if they
were positions in the data frame, so expressions like \code{x:y} can
be used to select a range of variables.}
}
\value{
An object of the same type as \code{.data}. The output has the following
properties:
\itemize{
\item Rows are not affected.
\item Output columns are a subset of input columns, potentially with a different
order. Columns will be renamed if \code{new_name = old_name} form is used.
\item Data frame attributes are preserved.
\item Groups are maintained; you can't select off grouping variables.
}
}
\description{
Select (and optionally rename) variables in a data frame, using a concise
mini-language that makes it easy to refer to variables based on their name
(e.g. \code{a:f} selects all columns from \code{a} on the left to \code{f} on the
right) or type (e.g. \code{where(is.numeric)} selects all numeric columns).
\subsection{Overview of selection features}{

Tidyverse selections implement a dialect of R where operators make
it easy to select variables:
\itemize{
\item \code{:} for selecting a range of consecutive variables.
\item \code{!} for taking the complement of a set of variables.
\item \code{&} and \code{|} for selecting the intersection or the union of two
sets of variables.
\item \code{c()} for combining selections.
}

In addition, you can use \strong{selection helpers}. Some helpers select specific
columns:
\itemize{
\item \code{\link[tidyselect:everything]{everything()}}: Matches all variables.
\item \code{\link[tidyselect:everything]{last_col()}}: Select last variable, possibly with an offset.
\item \code{\link[dplyr:group_cols]{group_cols()}}: Select all grouping columns.
}

Other helpers select variables by matching patterns in their names:
\itemize{
\item \code{\link[tidyselect:starts_with]{starts_with()}}: Starts with a prefix.
\item \code{\link[tidyselect:starts_with]{ends_with()}}: Ends with a suffix.
\item \code{\link[tidyselect:starts_with]{contains()}}: Contains a literal string.
\item \code{\link[tidyselect:starts_with]{matches()}}: Matches a regular expression.
\item \code{\link[tidyselect:starts_with]{num_range()}}: Matches a numerical range like x01, x02, x03.
}

Or from variables stored in a character vector:
\itemize{
\item \code{\link[tidyselect:all_of]{all_of()}}: Matches variable names in a character vector. All
names must be present, otherwise an out-of-bounds error is
thrown.
\item \code{\link[tidyselect:all_of]{any_of()}}: Same as \code{all_of()}, except that no error is thrown
for names that don't exist.
}

Or using a predicate function:
\itemize{
\item \code{\link[tidyselect:where]{where()}}: Applies a function to all variables and selects those
for which the function returns \code{TRUE}.
}
}
}
\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("select")}.

}

\section{Examples}{



Here we show the usage for the basic selection operators. See the
specific help pages to learn about helpers like \code{\link[dplyr:starts_with]{starts_with()}}.

The selection language can be used in functions like
\code{dplyr::select()} or \code{tidyr::pivot_longer()}. Let's first attach
the tidyverse:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{library(tidyverse)

# For better printing
iris <- as_tibble(iris)
}\if{html}{\out{</div>}}

Select variables by name:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{starwars \%>\% select(height)
#> # A tibble: 87 x 1
#>   height
#>    <int>
#> 1    172
#> 2    167
#> 3     96
#> 4    202
#> # i 83 more rows

iris \%>\% pivot_longer(Sepal.Length)
#> # A tibble: 150 x 6
#>   Sepal.Width Petal.Length Petal.Width Species name         value
#>         <dbl>        <dbl>       <dbl> <fct>   <chr>        <dbl>
#> 1         3.5          1.4         0.2 setosa  Sepal.Length   5.1
#> 2         3            1.4         0.2 setosa  Sepal.Length   4.9
#> 3         3.2          1.3         0.2 setosa  Sepal.Length   4.7
#> 4         3.1          1.5         0.2 setosa  Sepal.Length   4.6
#> # i 146 more rows
}\if{html}{\out{</div>}}

Select multiple variables by separating them with commas. Note how
the order of columns is determined by the order of inputs:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{starwars \%>\% select(homeworld, height, mass)
#> # A tibble: 87 x 3
#>   homeworld height  mass
#>   <chr>      <int> <dbl>
#> 1 Tatooine     172    77
#> 2 Tatooine     167    75
#> 3 Naboo         96    32
#> 4 Tatooine     202   136
#> # i 83 more rows
}\if{html}{\out{</div>}}

Functions like \code{tidyr::pivot_longer()} don't take variables with
dots. In this case use \code{c()} to select multiple variables:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{iris \%>\% pivot_longer(c(Sepal.Length, Petal.Length))
#> # A tibble: 300 x 5
#>   Sepal.Width Petal.Width Species name         value
#>         <dbl>       <dbl> <fct>   <chr>        <dbl>
#> 1         3.5         0.2 setosa  Sepal.Length   5.1
#> 2         3.5         0.2 setosa  Petal.Length   1.4
#> 3         3           0.2 setosa  Sepal.Length   4.9
#> 4         3           0.2 setosa  Petal.Length   1.4
#> # i 296 more rows
}\if{html}{\out{</div>}}
\subsection{Operators:}{

The \code{:} operator selects a range of consecutive variables:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{starwars \%>\% select(name:mass)
#> # A tibble: 87 x 3
#>   name           height  mass
#>   <chr>           <int> <dbl>
#> 1 Luke Skywalker    172    77
#> 2 C-3PO             167    75
#> 3 R2-D2              96    32
#> 4 Darth Vader       202   136
#> # i 83 more rows
}\if{html}{\out{</div>}}

The \code{!} operator negates a selection:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{starwars \%>\% select(!(name:mass))
#> # A tibble: 87 x 11
#>   hair_color skin_color  eye_color birth_year sex   gender    homeworld species
#>   <chr>      <chr>       <chr>          <dbl> <chr> <chr>     <chr>     <chr>  
#> 1 blond      fair        blue            19   male  masculine Tatooine  Human  
#> 2 <NA>       gold        yellow         112   none  masculine Tatooine  Droid  
#> 3 <NA>       white, blue red             33   none  masculine Naboo     Droid  
#> 4 none       white       yellow          41.9 male  masculine Tatooine  Human  
#> # i 83 more rows
#> # i 3 more variables: films <list>, vehicles <list>, starships <list>

iris \%>\% select(!c(Sepal.Length, Petal.Length))
#> # A tibble: 150 x 3
#>   Sepal.Width Petal.Width Species
#>         <dbl>       <dbl> <fct>  
#> 1         3.5         0.2 setosa 
#> 2         3           0.2 setosa 
#> 3         3.2         0.2 setosa 
#> 4         3.1         0.2 setosa 
#> # i 146 more rows

iris \%>\% select(!ends_with("Width"))
#> # A tibble: 150 x 3
#>   Sepal.Length Petal.Length Species
#>          <dbl>        <dbl> <fct>  
#> 1          5.1          1.4 setosa 
#> 2          4.9          1.4 setosa 
#> 3          4.7          1.3 setosa 
#> 4          4.6          1.5 setosa 
#> # i 146 more rows
}\if{html}{\out{</div>}}

\code{&} and \code{|} take the intersection or the union of two selections:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{iris \%>\% select(starts_with("Petal") & ends_with("Width"))
#> # A tibble: 150 x 1
#>   Petal.Width
#>         <dbl>
#> 1         0.2
#> 2         0.2
#> 3         0.2
#> 4         0.2
#> # i 146 more rows

iris \%>\% select(starts_with("Petal") | ends_with("Width"))
#> # A tibble: 150 x 3
#>   Petal.Length Petal.Width Sepal.Width
#>          <dbl>       <dbl>       <dbl>
#> 1          1.4         0.2         3.5
#> 2          1.4         0.2         3  
#> 3          1.3         0.2         3.2
#> 4          1.5         0.2         3.1
#> # i 146 more rows
}\if{html}{\out{</div>}}

To take the difference between two selections, combine the \code{&} and
\code{!} operators:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{iris \%>\% select(starts_with("Petal") & !ends_with("Width"))
#> # A tibble: 150 x 1
#>   Petal.Length
#>          <dbl>
#> 1          1.4
#> 2          1.4
#> 3          1.3
#> 4          1.5
#> # i 146 more rows
}\if{html}{\out{</div>}}
}

}

\examples{
data(pasilla)
pasilla |> select(.sample, .feature, counts)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link[dplyr]{arrange}()},
\code{\link[dplyr]{filter}()},
\code{\link[dplyr]{mutate}()},
\code{\link[dplyr]{reframe}()},
\code{\link[dplyr]{rename}()},
\code{\link[dplyr]{slice}()},
\code{\link[dplyr]{summarise}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ggplot2_methods.R
\name{ggplot}
\alias{ggplot}
\alias{ggplot.SummarizedExperiment}
\title{Create a new \code{ggplot} from a \code{SummarizedExperiment}}
\usage{
\method{ggplot}{SummarizedExperiment}(data = NULL, mapping = aes(), ..., environment = parent.frame())
}
\arguments{
\item{data}{Default dataset to use for plot. If not already a data.frame,
will be converted to one by \code{\link[ggplot2:fortify]{fortify()}}. If not specified,
must be supplied in each layer added to the plot.}

\item{mapping}{Default list of aesthetic mappings to use for plot.
If not specified, must be supplied in each layer added to the plot.}

\item{...}{Other arguments passed on to methods. Not currently used.}

\item{environment}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} Used prior to tidy
evaluation.}
}
\value{
\code{ggplot}
}
\description{
\code{ggplot()} initializes a ggplot object. It can be used to
declare the input data frame for a graphic and to specify the
set of plot aesthetics intended to be common throughout all
subsequent layers unless specifically overridden.
}
\details{
\code{ggplot()} is used to construct the initial plot object,
and is almost always followed by a plus sign (\code{+}) to add
components to the plot.

There are three common patterns used to invoke \code{ggplot()}:
\itemize{
\item \verb{ggplot(data = df, mapping = aes(x, y, other aesthetics))}
\item \code{ggplot(data = df)}
\item \code{ggplot()}
}

The first pattern is recommended if all layers use the same
data and the same set of aesthetics, although this method
can also be used when adding a layer using data from another
data frame.

The second pattern specifies the default data frame to use
for the plot, but no aesthetics are defined up front. This
is useful when one data frame is used predominantly for the
plot, but the aesthetics vary from one layer to another.

The third pattern initializes a skeleton \code{ggplot} object, which
is fleshed out as layers are added. This is useful when
multiple data frames are used to produce different layers, as
is often the case in complex graphics.

The \verb{data =} and \verb{mapping =} specifications in the arguments are optional
(and are often omitted in practice), so long as the data and the mapping
values are passed into the function in the right order. In the examples
below, however, they are left in place for clarity.
}
\examples{
library(ggplot2)
data(pasilla)
pasilla \%>\%
    ggplot(aes(.sample, counts)) +
    geom_boxplot()

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H. (2016). ggplot2: Elegant Graphics for Data Analysis. Springer-Verlag New York. ISBN 978-3-319-24277-4, https://ggplot2.tidyverse.org
}
\seealso{
The \href{https://ggplot2-book.org/getting-started}{first steps chapter} of the online ggplot2 book.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{sample_n}
\alias{sample_n}
\alias{sample_n.SummarizedExperiment}
\alias{sample_frac}
\alias{sample_frac.SummarizedExperiment}
\title{Sample n rows from a table}
\usage{
\method{sample_n}{SummarizedExperiment}(tbl, size, replace = FALSE, weight = NULL, .env = NULL, ...)

\method{sample_frac}{SummarizedExperiment}(tbl, size = 1, replace = FALSE, weight = NULL, .env = NULL, ...)
}
\arguments{
\item{tbl}{A data.frame.}

\item{size}{<\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}>
For \code{sample_n()}, the number of rows to select.
For \code{sample_frac()}, the fraction of rows to select.
If \code{tbl} is grouped, \code{size} applies to each group.}

\item{replace}{Sample with or without replacement?}

\item{weight}{<\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> Sampling weights.
This must evaluate to a vector of non-negative numbers the same length as
the input. Weights are automatically standardised to sum to 1.}

\item{.env}{DEPRECATED.}

\item{...}{ignored}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#superseded}{\figure{lifecycle-superseded.svg}{options: alt='[Superseded]'}}}{\strong{[Superseded]}}
\code{sample_n()} and \code{sample_frac()} have been superseded in favour of
\code{\link[dplyr:slice_sample]{slice_sample()}}. While they will not be deprecated in the near future,
retirement means that we will only perform critical bug fixes, so we recommend
moving to the newer alternative.

These functions were superseded because we realised it was more convenient to
have two mutually exclusive arguments to one function, rather than two
separate functions. This also made it to clean up a few other smaller
design issues with \code{sample_n()}/\code{sample_frac}:
\itemize{
\item The connection to \code{slice()} was not obvious.
\item The name of the first argument, \code{tbl}, is inconsistent with other
single table verbs which use \code{.data}.
\item The \code{size} argument uses tidy evaluation, which is surprising and
undocumented.
\item It was easier to remove the deprecated \code{.env} argument.
\item \code{...} was in a suboptimal position.
}
}
\examples{
data(pasilla)
pasilla |> sample_n(50)
pasilla |> sample_frac(0.1)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{distinct}
\alias{distinct}
\alias{distinct.SummarizedExperiment}
\title{Keep distinct/unique rows}
\usage{
\method{distinct}{SummarizedExperiment}(.data, ..., .keep_all = FALSE)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Optional variables to
use when determining uniqueness. If there are multiple rows for a given
combination of inputs, only the first row will be preserved. If omitted,
will use all variables in the data frame.}

\item{.keep_all}{If \code{TRUE}, keep all variables in \code{.data}.
If a combination of \code{...} is not distinct, this keeps the
first row of values.}
}
\value{
An object of the same type as \code{.data}. The output has the following
properties:
\itemize{
\item Rows are a subset of the input but appear in the same order.
\item Columns are not modified if \code{...} is empty or \code{.keep_all} is \code{TRUE}.
Otherwise, \code{distinct()} first calls \code{mutate()} to create new columns.
\item Groups are not modified.
\item Data frame attributes are preserved.
}
}
\description{
Keep only unique/distinct rows from a data frame. This is similar
to \code{\link[=unique.data.frame]{unique.data.frame()}} but considerably faster.
}
\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("distinct")}.

}

\examples{
data(pasilla)
pasilla |> distinct(.sample)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{nest}
\alias{nest}
\alias{nest.SummarizedExperiment}
\title{Nest rows into a list-column of data frames}
\usage{
\method{nest}{SummarizedExperiment}(.data, ..., .names_sep = NULL)
}
\arguments{
\item{.data}{A data frame.}

\item{...}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> Columns to nest; these will
appear in the inner data frames.

Specified using name-variable pairs of the form
\code{new_col = c(col1, col2, col3)}. The right hand side can be any valid
tidyselect expression.

If not supplied, then \code{...} is derived as all columns \emph{not} selected by
\code{.by}, and will use the column name from \code{.key}.

\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}:
previously you could write \code{df \%>\% nest(x, y, z)}.
Convert to \code{df \%>\% nest(data = c(x, y, z))}.}

\item{.names_sep}{If \code{NULL}, the default, the inner names will come from
the former outer names. If a string, the  new inner names will use the
outer names with \code{names_sep} automatically stripped. This makes
\code{names_sep} roughly symmetric between nesting and unnesting.}
}
\value{
\code{tidySummarizedExperiment_nested}
}
\description{
Nesting creates a list-column of data frames; unnesting flattens it back out
into regular columns. Nesting is implicitly a summarising operation: you
get one row for each group defined by the non-nested columns. This is useful
in conjunction with other summaries that work with whole datasets, most
notably models.

Learn more in \code{vignette("nest")}.
}
\details{
If neither \code{...} nor \code{.by} are supplied, \code{nest()} will nest all variables,
and will use the column name supplied through \code{.key}.
}
\section{New syntax}{


tidyr 1.0.0 introduced a new syntax for \code{nest()} and \code{unnest()} that's
designed to be more similar to other functions. Converting to the new syntax
should be straightforward (guided by the message you'll receive) but if
you just need to run an old analysis, you can easily revert to the previous
behaviour using \code{\link[tidyr:nest_legacy]{nest_legacy()}} and \code{\link[tidyr:unnest_legacy]{unnest_legacy()}} as follows:

\if{html}{\out{<div class="sourceCode">}}\preformatted{library(tidyr)
nest <- nest_legacy
unnest <- unnest_legacy
}\if{html}{\out{</div>}}

}

\section{Grouped data frames}{


\code{df \%>\% nest(data = c(x, y))} specifies the columns to be nested; i.e. the
columns that will appear in the inner data frame. \code{df \%>\% nest(.by = c(x, y))} specifies the columns to nest \emph{by}; i.e. the columns that will remain in
the outer data frame. An alternative way to achieve the latter is to \code{nest()}
a grouped data frame created by \code{\link[dplyr:group_by]{dplyr::group_by()}}. The grouping variables
remain in the outer data frame and the others are nested. The result
preserves the grouping of the input.

Variables supplied to \code{nest()} will override grouping variables so that
\code{df \%>\% group_by(x, y) \%>\% nest(data = !z)} will be equivalent to
\code{df \%>\% nest(data = !z)}.

You can't supply \code{.by} with a grouped data frame, as the groups already
represent what you are nesting by.

}

\examples{
tidySummarizedExperiment::pasilla |>
    nest(data=-condition)
    
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\docType{package}
\name{tidySummarizedExperiment-package}
\alias{tidySummarizedExperiment-package}
\alias{tidySummarizedExperiment}
\title{tidySummarizedExperiment: Bringing SummarizedExperiment to the Tidyverse}
\description{
The tidySummarizedExperiment package provides a bridge between Bioconductor
SummarizedExperiment objects and the tidyverse. It creates an invisible layer
that enables viewing the Bioconductor SummarizedExperiment object as a tidyverse
tibble, and provides SummarizedExperiment-compatible dplyr, tidyr, ggplot2 and
plotly functions. This allows users to get the best of both Bioconductor and
tidyverse worlds.
}
\details{
The main functions and methods are:

\itemize{
\item \code{\link{tidy}} - Convert SummarizedExperiment to tidy format
\item \code{\link{as_tibble}} - Convert to tibble representation
\item \code{\link{filter}}, \code{\link{select}}, \code{\link{mutate}}, \code{\link{arrange}} - dplyr verbs
\item \code{\link{pivot_longer}}, \code{\link{pivot_wider}}, \code{\link{nest}}, \code{\link{unnest}} - tidyr functions
\item \code{\link{ggplot}} - ggplot2 visualization
\item \code{\link{left_join}}, \code{\link{inner_join}}, \code{\link{right_join}}, \code{\link{full_join}} - dplyr joins
}

For detailed information on usage, see the package vignette, by typing
\code{vignette("introduction", package = "tidySummarizedExperiment")}.

All software-related questions should be posted to the Bioconductor Support Site:

\url{https://support.bioconductor.org}

The code can be viewed at the GitHub repository:

\url{https://github.com/stemangiola/tidySummarizedExperiment}
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics
ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024).
\doi{10.1038/s41592-024-02299-2}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/stemangiola/tidySummarizedExperiment}
  \item Report bugs at \url{https://github.com/stemangiola/tidySummarizedExperiment/issues}
}

}
\author{
Stefano Mangiola
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotly_methods.R
\name{plot_ly}
\alias{plot_ly}
\alias{plot_ly.tbl_df}
\alias{plot_ly.SummarizedExperiment}
\title{Initiate a plotly visualization}
\usage{
\method{plot_ly}{tbl_df}(
  data = data.frame(),
  ...,
  type = NULL,
  name = NULL,
  color = NULL,
  colors = NULL,
  alpha = NULL,
  stroke = NULL,
  strokes = NULL,
  alpha_stroke = 1,
  size = NULL,
  sizes = c(10, 100),
  span = NULL,
  spans = c(1, 20),
  symbol = NULL,
  symbols = NULL,
  linetype = NULL,
  linetypes = NULL,
  split = NULL,
  frame = NULL,
  width = NULL,
  height = NULL,
  source = "A"
)

\method{plot_ly}{SummarizedExperiment}(
  data = data.frame(),
  ...,
  type = NULL,
  name = NULL,
  color = NULL,
  colors = NULL,
  alpha = NULL,
  stroke = NULL,
  strokes = NULL,
  alpha_stroke = 1,
  size = NULL,
  sizes = c(10, 100),
  span = NULL,
  spans = c(1, 20),
  symbol = NULL,
  symbols = NULL,
  linetype = NULL,
  linetypes = NULL,
  split = NULL,
  frame = NULL,
  width = NULL,
  height = NULL,
  source = "A"
)
}
\arguments{
\item{data}{A data frame (optional) or \link[crosstalk:SharedData]{crosstalk::SharedData} object.}

\item{...}{Arguments (i.e., attributes) passed along to the trace \code{type}.
See \code{\link[plotly:schema]{schema()}} for a list of acceptable attributes for a given trace \code{type}
(by going to \code{traces} -> \code{type} -> \code{attributes}). Note that attributes
provided at this level may override other arguments
(e.g. \code{plot_ly(x = 1:10, y = 1:10, color = I("red"), marker = list(color = "blue"))}).}

\item{type}{A character string specifying the trace type (e.g. \code{"scatter"}, \code{"bar"}, \code{"box"}, etc).
If specified, it \emph{always} creates a trace, otherwise}

\item{name}{Values mapped to the trace's name attribute. Since a trace can
only have one name, this argument acts very much like \code{split} in that it
creates one trace for every unique value.}

\item{color}{Values mapped to relevant 'fill-color' attribute(s)
(e.g. \href{https://plotly.com/r/reference/#scatter-fillcolor}{fillcolor},
\href{https://plotly.com/r/reference/#scatter-marker-color}{marker.color},
\href{https://plotly.com/r/reference/#scatter-textfont-color}{textfont.color}, etc.).
The mapping from data values to color codes may be controlled using
\code{colors} and \code{alpha}, or avoided altogether via \code{\link[=I]{I()}} (e.g., \code{color = I("red")}).
Any color understood by \code{\link[grDevices:col2rgb]{grDevices::col2rgb()}} may be used in this way.}

\item{colors}{Either a colorbrewer2.org palette name (e.g. "YlOrRd" or "Blues"),
or a vector of colors to interpolate in hexadecimal "#RRGGBB" format,
or a color interpolation function like \code{colorRamp()}.}

\item{alpha}{A number between 0 and 1 specifying the alpha channel applied to \code{color}.
Defaults to 0.5 when mapping to \href{https://plotly.com/r/reference/#scatter-fillcolor}{fillcolor} and 1 otherwise.}

\item{stroke}{Similar to \code{color}, but values are mapped to relevant 'stroke-color' attribute(s)
(e.g., \href{https://plotly.com/r/reference/#scatter-marker-line-color}{marker.line.color}
and \href{https://plotly.com/r/reference/#scatter-line-color}{line.color}
for filled polygons). If not specified, \code{stroke} inherits from \code{color}.}

\item{strokes}{Similar to \code{colors}, but controls the \code{stroke} mapping.}

\item{alpha_stroke}{Similar to \code{alpha}, but applied to \code{stroke}.}

\item{size}{(Numeric) values mapped to relevant 'fill-size' attribute(s)
(e.g., \href{https://plotly.com/r/reference/#scatter-marker-size}{marker.size},
\href{https://plotly.com/r/reference/#scatter-textfont-size}{textfont.size},
and \href{https://plotly.com/r/reference/#scatter-error_x-width}{error_x.width}).
The mapping from data values to symbols may be controlled using
\code{sizes}, or avoided altogether via \code{\link[=I]{I()}} (e.g., \code{size = I(30)}).}

\item{sizes}{A numeric vector of length 2 used to scale \code{size} to pixels.}

\item{span}{(Numeric) values mapped to relevant 'stroke-size' attribute(s)
(e.g.,
\href{https://plotly.com/r/reference/#scatter-marker-line-width}{marker.line.width},
\href{https://plotly.com/r/reference/#scatter-line-width}{line.width} for filled polygons,
and \href{https://plotly.com/r/reference/#scatter-error_x-thickness}{error_x.thickness})
The mapping from data values to symbols may be controlled using
\code{spans}, or avoided altogether via \code{\link[=I]{I()}} (e.g., \code{span = I(30)}).}

\item{spans}{A numeric vector of length 2 used to scale \code{span} to pixels.}

\item{symbol}{(Discrete) values mapped to \href{https://plotly.com/r/reference/#scatter-marker-symbol}{marker.symbol}.
The mapping from data values to symbols may be controlled using
\code{symbols}, or avoided altogether via \code{\link[=I]{I()}} (e.g., \code{symbol = I("pentagon")}).
Any \link{pch} value or \href{https://plotly.com/r/reference/#scatter-marker-symbol}{symbol name} may be used in this way.}

\item{symbols}{A character vector of \link{pch} values or \href{https://plotly.com/r/reference/#scatter-marker-symbol}{symbol names}.}

\item{linetype}{(Discrete) values mapped to \href{https://plotly.com/r/reference/#scatter-line-dash}{line.dash}.
The mapping from data values to symbols may be controlled using
\code{linetypes}, or avoided altogether via \code{\link[=I]{I()}} (e.g., \code{linetype = I("dash")}).
Any \code{lty} (see \link{par}) value or \href{https://plotly.com/r/reference/#scatter-line-dash}{dash name} may be used in this way.}

\item{linetypes}{A character vector of \code{lty} values or \href{https://plotly.com/r/reference/#scatter-line-dash}{dash names}}

\item{split}{(Discrete) values used to create multiple traces (one trace per value).}

\item{frame}{(Discrete) values used to create animation frames.}

\item{width}{Width in pixels (optional, defaults to automatic sizing).}

\item{height}{Height in pixels (optional, defaults to automatic sizing).}

\item{source}{a character string of length 1. Match the value of this string
with the source argument in \code{\link[plotly:event_data]{event_data()}} to retrieve the
event data corresponding to a specific plot (shiny apps can have multiple plots).}
}
\value{
\code{plotly}

\code{plotly}
}
\description{
This function maps R objects to \href{https://plotly.com/javascript/}{plotly.js},
an (MIT licensed) web-based interactive charting library. It provides
abstractions for doing common things (e.g. mapping data values to
fill colors (via \code{color}) or creating \link[plotly]{animation}s (via \code{frame})) and sets
some different defaults to make the interface feel more 'R-like'
(i.e., closer to \code{\link[=plot]{plot()}} and \code{\link[ggplot2:qplot]{ggplot2::qplot()}}).
}
\details{
Unless \code{type} is specified, this function just initiates a plotly
object with 'global' attributes that are passed onto downstream uses of
\code{\link[plotly:add_trace]{add_trace()}} (or similar). A \link{formula} must always be used when
referencing column name(s) in \code{data} (e.g. \code{plot_ly(mtcars, x = ~wt)}).
Formulas are optional when supplying values directly, but they do
help inform default axis/scale titles
(e.g., \code{plot_ly(x = mtcars$wt)} vs \code{plot_ly(x = ~mtcars$wt)})
}
\examples{
data(se)
se |>
    plot_ly(x = ~counts)

data(se)
se |>
    plot_ly(x = ~counts)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
}
\seealso{
\itemize{
\item For initializing a plotly-geo object: \code{\link[plotly:plot_geo]{plot_geo()}}
\item For initializing a plotly-mapbox object: \code{\link[plotly:plot_mapbox]{plot_mapbox()}}
\item For translating a ggplot2 object to a plotly object: \code{\link[plotly:ggplotly]{ggplotly()}}
\item For modifying any plotly object: \code{\link[plotly:layout]{layout()}}, \code{\link[plotly:add_trace]{add_trace()}}, \code{\link[plotly:style]{style()}}
\item For linked brushing: \code{\link[plotly:highlight]{highlight()}}
\item For arranging multiple plots: \code{\link[plotly:subplot]{subplot()}}, \code{\link[crosstalk:bscols]{crosstalk::bscols()}}
\item For inspecting plotly objects: \code{\link[plotly:plotly_json]{plotly_json()}}
\item For quick, accurate, and searchable plotly.js reference: \code{\link[plotly:schema]{schema()}}
}
}
\author{
Carson Sievert
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{separate}
\alias{separate}
\alias{separate.SummarizedExperiment}
\title{Separate a character column into multiple columns with a regular
expression or numeric locations}
\usage{
\method{separate}{SummarizedExperiment}(
  data,
  col,
  into,
  sep = "[^[:alnum:]]+",
  remove = TRUE,
  convert = FALSE,
  extra = "warn",
  fill = "warn",
  ...
)
}
\arguments{
\item{data}{A data frame.}

\item{col}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> Column to expand.}

\item{into}{Names of new variables to create as character vector.
Use \code{NA} to omit the variable in the output.}

\item{sep}{Separator between columns.

If character, \code{sep} is interpreted as a regular expression. The default
value is a regular expression that matches any sequence of
non-alphanumeric values.

If numeric, \code{sep} is interpreted as character positions to split at. Positive
values start at 1 at the far-left of the string; negative value start at -1 at
the far-right of the string. The length of \code{sep} should be one less than
\code{into}.}

\item{remove}{If \code{TRUE}, remove input column from output data frame.}

\item{convert}{If \code{TRUE}, will run \code{\link[=type.convert]{type.convert()}} with
\code{as.is = TRUE} on new columns. This is useful if the component
columns are integer, numeric or logical.

NB: this will cause string \code{"NA"}s to be converted to \code{NA}s.}

\item{extra}{If \code{sep} is a character vector, this controls what
happens when there are too many pieces. There are three valid options:
\itemize{
\item \code{"warn"} (the default): emit a warning and drop extra values.
\item \code{"drop"}: drop any extra values without a warning.
\item \code{"merge"}: only splits at most \code{length(into)} times
}}

\item{fill}{If \code{sep} is a character vector, this controls what
happens when there are not enough pieces. There are three valid options:
\itemize{
\item \code{"warn"} (the default): emit a warning and fill from the right
\item \code{"right"}: fill with missing values on the right
\item \code{"left"}: fill with missing values on the left
}}

\item{...}{Additional arguments passed on to methods.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#superseded}{\figure{lifecycle-superseded.svg}{options: alt='[Superseded]'}}}{\strong{[Superseded]}}

\code{separate()} has been superseded in favour of \code{\link[tidyr:separate_wider_position]{separate_wider_position()}}
and \code{\link[tidyr:separate_wider_delim]{separate_wider_delim()}} because the two functions make the two uses
more obvious, the API is more polished, and the handling of problems is
better. Superseded functions will not go away, but will only receive
critical bug fixes.

Given either a regular expression or a vector of character positions,
\code{separate()} turns a single character column into multiple columns.
}
\examples{
un <- tidySummarizedExperiment::pasilla |>
    unite("group", c(condition, type))
un |> separate(col=group, into=c("condition", "type"))

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}
\seealso{
\code{\link[tidyr:unite]{unite()}}, the complement, \code{\link[tidyr:extract]{extract()}} which uses regular
expression capturing groups.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rename.R
\name{rename}
\alias{rename}
\alias{rename.SummarizedExperiment}
\title{Rename columns}
\usage{
\method{rename}{SummarizedExperiment}(.data, ...)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{For \code{rename()}: <\code{\link[dplyr:dplyr_tidy_select]{tidy-select}}> Use
\code{new_name = old_name} to rename selected variables.

For \code{rename_with()}: additional arguments passed onto \code{.fn}.}
}
\value{
An object of the same type as \code{.data}. The output has the following
properties:
\itemize{
\item Rows are not affected.
\item Column names are changed; column order is preserved.
\item Data frame attributes are preserved.
\item Groups are updated to reflect new names.
}
}
\description{
\code{rename()} changes the names of individual variables using
\code{new_name = old_name} syntax; \code{rename_with()} renames columns using a
function.
}
\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("rename")}.

}

\examples{
data(pasilla)
pasilla |> rename(cond=condition)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link{mutate}()},
\code{\link{slice}()},
\code{\link{summarise}()}
}
\concept{single table verbs}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{se}
\alias{se}
\title{Read counts of RNA-seq samples derived from
Pasilla knock-down by Brooks et al.}
\format{
containing 14599 features and 7 biological replicates.
}
\source{
\url{https://bioconductor.org/packages/release/data/experiment/html/pasilla.html}
}
\usage{
data(se)
}
\description{
A SummarizedExperiment dataset containing
the transcriptome information for Drosophila Melanogaster.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dplyr_methods.R
\name{bind_rows}
\alias{bind_rows}
\alias{bind_rows.SummarizedExperiment}
\alias{bind_cols.SummarizedExperiment}
\alias{bind_cols}
\alias{bind_cols.RangedSummarizedExperiment}
\title{Efficiently bind multiple data frames by row and column}
\usage{
\method{bind_rows}{SummarizedExperiment}(..., .id = NULL, add.cell.ids = NULL)

\method{bind_cols}{SummarizedExperiment}(..., .id = NULL)

\method{bind_cols}{RangedSummarizedExperiment}(..., .id = NULL)
}
\arguments{
\item{...}{Data frames to combine.

  Each argument can either be a data frame, a list that could be a data
  frame, or a list of data frames.

  When row-binding, columns are matched by name, and any missing
  columns will be filled with NA.

  When column-binding, rows are matched by position, so all data
  frames must have the same number of rows. To match by value, not
  position, see mutate-joins.}

\item{.id}{Data frame identifier.

  When `.id` is supplied, a new column of identifiers is
  created to link each row to its original data frame. The labels
  are taken from the named arguments to `bind_rows()`. When a
  list of data frames is supplied, the labels are taken from the
  names of the list. If no names are found a numeric sequence is
  used instead.}

\item{add.cell.ids}{Appends the corresponding values to}
}
\value{
`bind_rows()` and `bind_cols()` return the same type as
  the first input, either a data frame, `tbl_df`, or `grouped_df`.

`bind_rows()` and `bind_cols()` return the same type as
  the first input, either a data frame, `tbl_df`, or `grouped_df`.
}
\description{
This is an efficient implementation of the common pattern of
`do.call(rbind, dfs)` or `do.call(cbind, dfs)` for binding many
data frames into one.

This is an efficient implementation of the common pattern of
`do.call(rbind, dfs)` or `do.call(cbind, dfs)` for binding many
data frames into one.
}
\details{
The output of `bind_rows()` will contain a column if that column
appears in any of the inputs.

The output of `bind_rows()` will contain a column if that column
appears in any of the inputs.
}
\examples{
print("small_pbmc |> bind_rows(small_pbmc)")



print("small_pbmc |> bind_cols(annotation_column)")
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{unnest}
\alias{unnest}
\alias{unnest.tidySummarizedExperiment_nested}
\alias{unnest_summarized_experiment}
\title{Unnest a list-column of data frames into rows and columns}
\usage{
\method{unnest}{tidySummarizedExperiment_nested}(
  data,
  cols,
  ...,
  keep_empty = FALSE,
  ptype = NULL,
  names_sep = NULL,
  names_repair = "check_unique",
  .drop,
  .id,
  .sep,
  .preserve
)

unnest_summarized_experiment(
  data,
  cols,
  ...,
  keep_empty = FALSE,
  ptype = NULL,
  names_sep = NULL,
  names_repair = "check_unique",
  .drop,
  .id,
  .sep,
  .preserve
)
}
\arguments{
\item{data}{A data frame.}

\item{cols}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> List-columns to unnest.

When selecting multiple columns, values from the same row will be recycled
to their common size.}

\item{...}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}:
previously you could write \code{df \%>\% unnest(x, y, z)}.
Convert to \code{df \%>\% unnest(c(x, y, z))}. If you previously created a new
variable in \code{unnest()} you'll now need to do it explicitly with \code{mutate()}.
Convert \code{df \%>\% unnest(y = fun(x, y, z))}
to \code{df \%>\% mutate(y = fun(x, y, z)) \%>\% unnest(y)}.}

\item{keep_empty}{By default, you get one row of output for each element
of the list that you are unchopping/unnesting. This means that if there's a
size-0 element (like \code{NULL} or an empty data frame or vector), then that
entire row will be dropped from the output. If you want to preserve all
rows, use \code{keep_empty = TRUE} to replace size-0 elements with a single row
of missing values.}

\item{ptype}{Optionally, a named list of column name-prototype pairs to
coerce \code{cols} to, overriding the default that will be guessed from
combining the individual values. Alternatively, a single empty ptype
can be supplied, which will be applied to all \code{cols}.}

\item{names_sep}{If \code{NULL}, the default, the outer names will come from the
inner names. If a string, the outer names will be formed by pasting
together the outer and the inner column names, separated by \code{names_sep}.}

\item{names_repair}{Used to check that output data frame has valid
names. Must be one of the following options:
\itemize{
\item \verb{"minimal}": no name repair or checks, beyond basic existence,
\item \verb{"unique}": make sure names are unique and not empty,
\item \verb{"check_unique}": (the default), no name repair, but check they are unique,
\item \verb{"universal}": make the names unique and syntactic
\item a function: apply custom name repair.
\item \link[tidyr]{tidyr_legacy}: use the name repair from tidyr 0.8.
\item a formula: a purrr-style anonymous function (see \code{\link[rlang:as_function]{rlang::as_function()}})
}

See \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}} for more details on these terms and the
strategies used to enforce them.}

\item{.drop, .preserve}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}:
all list-columns are now preserved; If there are any that you
don't want in the output use \code{select()} to remove them prior to
unnesting.}

\item{.id}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}:
convert \code{df \%>\% unnest(x, .id = "id")} to \verb{df \%>\% mutate(id = names(x)) \%>\% unnest(x))}.}

\item{.sep}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}:
use \code{names_sep} instead.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
Unnest expands a list-column containing data frames into rows and columns.
}
\section{New syntax}{


tidyr 1.0.0 introduced a new syntax for \code{nest()} and \code{unnest()} that's
designed to be more similar to other functions. Converting to the new syntax
should be straightforward (guided by the message you'll receive) but if
you just need to run an old analysis, you can easily revert to the previous
behaviour using \code{\link[tidyr:nest_legacy]{nest_legacy()}} and \code{\link[tidyr:unnest_legacy]{unnest_legacy()}} as follows:

\if{html}{\out{<div class="sourceCode">}}\preformatted{library(tidyr)
nest <- nest_legacy
unnest <- unnest_legacy
}\if{html}{\out{</div>}}

}

\examples{
tidySummarizedExperiment::pasilla |>
    nest(data=-condition) |>
    unnest(data)

tidySummarizedExperiment::pasilla |>
    nest(data=-condition) |>
    unnest_summarized_experiment(data)

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}
\seealso{
Other rectangling: 
\code{\link[tidyr]{hoist}()},
\code{\link[tidyr]{unnest_longer}()},
\code{\link[tidyr]{unnest_wider}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods.R
\name{tidy}
\alias{tidy}
\alias{tidy.SummarizedExperiment}
\alias{tidy.RangedSummarizedExperiment}
\title{tidy for \code{Seurat}}
\usage{
tidy(object)

\method{tidy}{SummarizedExperiment}(object)

\method{tidy}{RangedSummarizedExperiment}(object)
}
\arguments{
\item{object}{A SummarizedExperiment object}
}
\value{
A \code{tidyseurat} object.
}
\description{
tidy for \code{Seurat}
}
\examples{
data(pasilla)
pasilla \%>\% tidy()

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter.R
\name{filter}
\alias{filter}
\alias{filter.SummarizedExperiment}
\title{Keep rows that match a condition}
\usage{
\method{filter}{SummarizedExperiment}(.data, ..., .preserve = FALSE)
}
\arguments{
\item{.data}{A data frame, data frame extension (e.g. a tibble), or a
lazy data frame (e.g. from dbplyr or dtplyr). See \emph{Methods}, below, for
more details.}

\item{...}{<\code{\link[rlang:args_data_masking]{data-masking}}> Expressions that
return a logical value, and are defined in terms of the variables in
\code{.data}. If multiple expressions are included, they are combined with the
\code{&} operator. Only rows for which all conditions evaluate to \code{TRUE} are
kept.}

\item{.preserve}{Relevant when the \code{.data} input is grouped.
If \code{.preserve = FALSE} (the default), the grouping structure
is recalculated based on the resulting data, otherwise the grouping is kept as is.}
}
\value{
An object of the same type as \code{.data}. The output has the following properties:
\itemize{
\item Rows are a subset of the input, but appear in the same order.
\item Columns are not modified.
\item The number of groups may be reduced (if \code{.preserve} is not \code{TRUE}).
\item Data frame attributes are preserved.
}
}
\description{
The \code{filter()} function is used to subset a data frame,
retaining all rows that satisfy your conditions.
To be retained, the row must produce a value of \code{TRUE} for all conditions.
Note that when a condition evaluates to \code{NA}
the row will be dropped, unlike base subsetting with \code{[}.
}
\details{
The \code{filter()} function is used to subset the rows of
\code{.data}, applying the expressions in \code{...} to the column values to determine which
rows should be retained. It can be applied to both grouped and ungrouped data (see \code{\link[dplyr:group_by]{group_by()}} and
\code{\link[dplyr:ungroup]{ungroup()}}). However, dplyr is not yet smart enough to optimise the filtering
operation on grouped datasets that do not need grouped calculations. For this
reason, filtering is often considerably faster on ungrouped data.
}
\section{Useful filter functions}{



There are many functions and operators that are useful when constructing the
expressions used to filter the data:
\itemize{
\item \code{\link{==}}, \code{\link{>}}, \code{\link{>=}} etc
\item \code{\link{&}}, \code{\link{|}}, \code{\link{!}}, \code{\link[=xor]{xor()}}
\item \code{\link[=is.na]{is.na()}}
\item \code{\link[dplyr:between]{between()}}, \code{\link[dplyr:near]{near()}}
}

}

\section{Grouped tibbles}{



Because filtering expressions are computed within groups, they may
yield different results on grouped tibbles. This will be the case
as soon as an aggregating, lagging, or ranking function is
involved. Compare this ungrouped filtering:

\if{html}{\out{<div class="sourceCode">}}\preformatted{starwars \%>\% filter(mass > mean(mass, na.rm = TRUE))
}\if{html}{\out{</div>}}

With the grouped equivalent:

\if{html}{\out{<div class="sourceCode">}}\preformatted{starwars \%>\% group_by(gender) \%>\% filter(mass > mean(mass, na.rm = TRUE))
}\if{html}{\out{</div>}}

In the ungrouped version, \code{filter()} compares the value of \code{mass} in each row to
the global average (taken over the whole data set), keeping only the rows with
\code{mass} greater than this global average. In contrast, the grouped version calculates
the average mass separately for each \code{gender} group, and keeps rows with \code{mass} greater
than the relevant within-gender average.

}

\section{Methods}{


This function is a \strong{generic}, which means that packages can provide
implementations (methods) for other classes. See the documentation of
individual methods for extra arguments and differences in behaviour.

The following methods are currently available in loaded packages:
\Sexpr[stage=render,results=rd]{dplyr:::methods_rd("filter")}.

}

\examples{
data(pasilla)
pasilla |>  filter(.sample == "untrt1")

# Learn more in ?dplyr_tidy_eval

}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., François, R., Henry, L., Müller, K., Vaughan, D. (2023). dplyr: A Grammar of Data Manipulation. R package version 2.1.4, https://CRAN.R-project.org/package=dplyr
}
\seealso{
Other single table verbs: 
\code{\link[dplyr]{arrange}()},
\code{\link[dplyr]{mutate}()},
\code{\link[dplyr]{reframe}()},
\code{\link[dplyr]{rename}()},
\code{\link[dplyr]{select}()},
\code{\link[dplyr]{slice}()},
\code{\link[dplyr]{summarise}()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tidyr_methods.R
\name{unite}
\alias{unite}
\alias{unite.SummarizedExperiment}
\title{Unite multiple columns into one by pasting strings together}
\usage{
\method{unite}{SummarizedExperiment}(data, col, ..., sep = "_", remove = TRUE, na.rm = FALSE)
}
\arguments{
\item{data}{A data frame.}

\item{col}{The name of the new column, as a string or symbol.

This argument is passed by expression and supports
\link[rlang:topic-inject]{quasiquotation} (you can unquote strings
and symbols). The name is captured from the expression with
\code{\link[rlang:defusing-advanced]{rlang::ensym()}} (note that this kind of interface where
symbols do not represent actual objects is now discouraged in the
tidyverse; we support it here for backward compatibility).}

\item{...}{<\code{\link[tidyr:tidyr_tidy_select]{tidy-select}}> Columns to unite}

\item{sep}{Separator to use between values.}

\item{remove}{If \code{TRUE}, remove input columns from output data frame.}

\item{na.rm}{If \code{TRUE}, missing values will be removed prior to uniting
each value.}
}
\value{
\code{tidySummarizedExperiment}
}
\description{
Convenience function to paste together multiple columns into one.
}
\examples{
tidySummarizedExperiment::pasilla |>
    unite("group", c(condition, type))
    
}
\references{
Hutchison, W.J., Keyes, T.J., The tidyomics Consortium. et al. The tidyomics ecosystem: enhancing omic data analyses. Nat Methods 21, 1166–1170 (2024). https://doi.org/10.1038/s41592-024-02299-2

Wickham, H., Vaughan, D. (2023). tidyr: Tidy Messy Data. R package version 2.0.0, https://CRAN.R-project.org/package=tidyr
}
\seealso{
\code{\link[tidyr:separate]{separate()}}, the complement.
}
